package com.brilliance.swift.element2mx.camt053001;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.brilliance.swift.element2mx.AbstractElement2MxCreator;
import com.brilliance.swift.util.StringUtil;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class Element2MxCamt053001Creator extends AbstractElement2MxCreator {

    @Override
    protected boolean isArray(String key) {
        if ("stmt".equals(key) || "ntryDtls".equals(key)
                || "txDtls".equals(key)) {
            return true;
        }
        return false;
    }

    @Override
    protected void rebuildProperties() {
        Set<Object> sets = properties.keySet();
        for (Object obj : sets) {
            String keyValue = properties.getProperty((String) obj);
            if (keyValue.indexOf("(") > -1 && keyValue.indexOf(")") > -1) {
                String condition = keyValue.substring(keyValue.indexOf("(")+1, keyValue.indexOf(")"));
                String type = "";
                if (StringUtil.isNotEmpty(condition)) {
                    type = condition.split(":")[1];
                }
                String path = keyValue.substring(keyValue.indexOf(")")+2);
                if (StringUtil.isNotEmpty(path) && path.indexOf("&") > -1) {
                    path = path.substring(0, path.indexOf("&"));
                }
                if (StringUtil.isNotEmpty(type) && StringUtil.isNotEmpty(path)) {
                    properties.put(obj, "@addBal&"+type+"&"+path);
                }
            }
        }
    }

    public void addBal(HashMap<String,Object> maps, Object obj) {
        List<Object> objList = (List<Object>)obj;
        Object value = objList.get(0);
        String balanceType = (String) objList.get(1);
        String valuePath = (String) objList.get(2);
        Object balObj = getObj(maps, "bkToCstmrStmt.stmt.bal");
        if (balObj == null) {
            JSONArray jsonArray = new JSONArray();
            putObj(maps, "bkToCstmrStmt.stmt.bal", jsonArray);
            balObj = jsonArray;
        }
        if (balObj != null) {
            JSONArray jsonArray = (JSONArray)balObj;
            Map<String, Object> balMap = null;
            for (int i=0; i<jsonArray.size(); i++) {
                Map<String, Object> balTmpMaps = (Map<String, Object>)jsonArray.get(i);
                if (balanceType.equals(getObj(balTmpMaps, "tp.cdOrPrtry.cd"))) {
                    balMap = balTmpMaps;
                    break;
                }
            }
            if (balMap == null) {
                balMap = new HashMap<>();
                putObj(balMap, "tp.cdOrPrtry.cd", balanceType);
                jsonArray.add(balMap);
            }
            putObj(balMap, valuePath, value);
        }
    }
}
