package com.brilliance.swift.element2mx.camt054001;

import com.brilliance.swift.element2mx.AbstractElement2MxCreator;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.util.DateUtil;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;

public class Element2MxCamt054001Creator extends AbstractElement2MxCreator {

    @Override
    protected boolean isArray(String key) {
        if ("ntfctn".equals(key) || "ntry".equals(key)
            || "ntryDtls".equals(key) || "txDtls".equals(key)
            || "orgId.othr".equals(key)
            || "prvtId.othr".equals(key) || "finInstnId.othr".equals(key)) {
            return true;
        }
        return false;
    }

    @Override
    protected void rebuildProperties() {
        properties.remove("valDt");  //处理逻辑在 postProcess() 方法中
        properties.remove("dbtrInfo");
        properties.remove("dbtrAgtInfo");

        properties.put("dbtrNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.nm");
        properties.put("dbtrOrgAnyBIC", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.id.orgId.anyBIC");
        properties.put("dbtrOrgLei", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.id.orgId.lei");
        properties.put("dbtrOrgOthrId", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.id.orgId.othr.id");
        properties.put("dbtrOrgOthrIdType", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.id.orgId.othr.schmeNm.cd");
        properties.put("dbtrOrgOthrIdTypePrtry", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.id.orgId.othr.schmeNm.prtry");
        properties.put("dbtrOrgOthrIssr", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.id.orgId.othr.issr");
        properties.put("dbtrPstlAdrType", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.adrTp");
        properties.put("dbtrPstlAdrCtry", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.ctry");
        properties.put("dbtrPstlAdrDept", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.dept");
        properties.put("dbtrPstlAdrSubDept", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.subDept");
        properties.put("dbtrPstlAdrStrtNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.strtNm");
        properties.put("dbtrPstlAdrBldgNb", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.bldgNb");
        properties.put("dbtrPstlAdrBldgNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.bldgNm");
        properties.put("dbtrPstlAdrFlr", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.flr");
        properties.put("dbtrPstlAdrRoom", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.room");
        properties.put("dbtrPstlAdrTwnNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.twnNm");
        properties.put("dbtrPstlAdrPstBx", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.pstBx");
        properties.put("dbtrPstlAdrPstCd", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.pstCd");
        properties.put("dbtrPstlAdrCtrySubDvsn", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.ctrySubDvsn");
        properties.put("dbtrPstlAdrDstrctNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.dstrctNm");
        properties.put("dbtrPstlAdrTwnLctnNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.pstlAdr.twnLctnNm");
        properties.put("dbtrAdrLines", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdPties.dbtr.pty.PstlAdr.adrLine");

        properties.put("dbtrAgtBicfi", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.bicfi");
        properties.put("dbtrAgtClrSysId", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.clrSysMmbId.mmbId");
        properties.put("dbtrAgtClrSysIdType", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.clrSysMmbId.clrSysId.cd");
        properties.put("dbtrAgtClrSysIdTypePrtry", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.clrSysMmbId.clrSysId.prtry");
        properties.put("dbtrAgtLei", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.lei");
        properties.put("dbtrAgtNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.nm");
        properties.put("dbtrAgtPstlAdrType", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.adrTp");
        properties.put("dbtrAgtPstlAdrCtry", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.ctry");
        properties.put("dbtrAgtPstlAdrDept", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.dept");
        properties.put("dbtrAgtPstlAdrSubDept", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.subDept");
        properties.put("dbtrAgtPstlAdrStrtNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.strtNm");
        properties.put("dbtrAgtPstlAdrBldgNb", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.bldgNb");
        properties.put("dbtrAgtPstlAdrBldgNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.bldgNm");
        properties.put("dbtrAgtPstlAdrFlr", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.flr");
        properties.put("dbtrAgtPstlAdrRoom", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.room");
        properties.put("dbtrAgtPstlAdrTwnNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.twnNm");
        properties.put("dbtrAgtPstlAdrPstBx", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.pstBx");
        properties.put("dbtrAgtPstlAdrPstCd", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.pstCd");
        properties.put("dbtrAgtPstlAdrCtrySubDvsn", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.ctrySubDvsn");
        properties.put("dbtrAgtPstlAdrDstrctNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.dstrctNm");
        properties.put("dbtrAgtPstlAdrTwnLctnNm", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.pstlAdr.twnLctnNm");
        properties.put("dbtrAgtAdrLines", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.PstlAdr.adrLines");
        properties.put("dbtrAgtOthrId", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.othr.id");
        properties.put("dbtrAgtOthrIdType", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.othr.schmeNm.cd");
        properties.put("dbtrAgtOthrIdTypePrtry", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.othr.schmeNm.prtry");
        properties.put("dbtrAgtOthrIssr", "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdAgts.dbtrAgt.finInstnId.othr.issr");
    }

    @Override
    public void postProcess() {
        //特殊处理 valDt
        if (elementMaps.containsKey("valDt")) {
            String valDtStr = (String) elementMaps.get("valDt");
            if (valDtStr.indexOf("T") > -1) {
                try {
                    XMLGregorianCalendar setlDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(valDtStr);
                    putObj(jsonMaps, "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.valDt.dtTm", valDtStr);
                    putObj(jsonMaps, "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdDts.intrBkSttlmDt", DateUtil.format(setlDt, "yyyy-MM-dd"));
                } catch (DatatypeConfigurationException e) {
                    throw new SwiftException(e.getMessage());
                }
            } else {
                putObj(jsonMaps, "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.valDt.dt", valDtStr);
                putObj(jsonMaps, "bkToCstmrDbtCdtNtfctn.ntfctn.ntry.ntryDtls.txDtls.rltdDts.intrBkSttlmDt", valDtStr);
            }
        }
        super.postProcess();
    }
}
