package com.brilliance.swift.element2mx.pacs008001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.element2mx.AbstractElement2MxCreator;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Element2MxPacs008001Creator extends AbstractElement2MxCreator {

    @Override
    protected boolean isArray(String key) {
        if ("cdtTrfTxInf".equals(key) || "orgId.othr".equals(key)
                || "prvtId.othr".equals(key) || "finInstnId.othr".equals(key)) {
            return true;
        }
        return false;
    }

    @Override
    protected void rebuildProperties() {
        properties.setProperty("rltdRmtInf", "@buildRltdRmtInf");
    }

    public void buildRgltryRptg(HashMap<String,Object> maps, Object obj) {
        List<Object> objList = (List<Object>)obj;
        JSONArray jsonArray = (JSONArray)objList.get(0);
        List<String> list = new ArrayList<>();
        for (int i=0; i<jsonArray.size(); i++) {
            list.add((String) jsonArray.get(i));
        }
        JSONArray rgltryRptgJsonArray = new JSONArray();
        Map<String, Object> rgltryRptgMap = new HashMap<>();
        rgltryRptgJsonArray.add(rgltryRptgMap);
        JSONArray dtlsJsonArray = new JSONArray();
        rgltryRptgMap.put("dtls", dtlsJsonArray);
        Map<String, Object> dtlsRptgMap = new HashMap<>();
        dtlsJsonArray.add(dtlsRptgMap);
        dtlsRptgMap.put("inf", list);
        putObj(maps, "fiToFICstmrCdtTrf.cdtTrfTxInf.rgltryRptg", rgltryRptgJsonArray);
    }

    public void buildStrdAddtlRmtInf(HashMap<String,Object> maps, Object obj) {
        List<Object> objList = (List<Object>)obj;
        JSONArray sourceJsonArray = new JSONArray();
        JSONArray jsonArray = (JSONArray)objList.get(0);
        List<String> list1 = null;
        for (int i=0; i<jsonArray.size(); i++) {
            if (i % 3 == 0) {
                list1 = new ArrayList<>();
                Map<String, Object> map = new HashMap<>();
                map.put("addtlRmtInf", list1);
                sourceJsonArray.add(map);
            }
            list1.add((String) jsonArray.get(i));
        }
        putObj(maps, "fiToFICstmrCdtTrf.cdtTrfTxInf.rmtInf.strd", sourceJsonArray);
    }

    public void buildRltdRmtInf(HashMap<String,Object> maps, Object obj) {
        List<Object> objList = (List<Object>)obj;
        JSONArray rltdRmtInfJsonArray = new JSONArray();
        JSONArray jsonArray = (JSONArray)objList.get(0);
        for (int i=0; i<jsonArray.size(); i++) {
            Map<String, Object> rltdRmtInfMap = new HashMap<>();
            rltdRmtInfMap.put("rmtId", jsonArray.get(i));
            rltdRmtInfJsonArray.add(rltdRmtInfMap);
        }
        putObj(maps, "fiToFICstmrCdtTrf.cdtTrfTxInf.rltdRmtInf", rltdRmtInfJsonArray);
    }

    @Override
    public void postProcess() {
        putObj(jsonMaps, "fiToFICstmrCdtTrf.grpHdr.nbOfTxs", 1);
        super.postProcess();
    }
}
