package com.brilliance.swift.exception;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

/**
 * 接口实例化异常
 */
public class InstantiateException extends CommonRuntimeException {

    private final Class<?> beanClass;
    private final Constructor<?> constructor;
    private final Method constructingMethod;

    public InstantiateException(Constructor<?> constructor, String msg, Throwable cause) {
        super("Failed to instantiate [" + constructor.getDeclaringClass().getName() + "]: " + msg, cause);
        this.beanClass = constructor.getDeclaringClass();
        this.constructor = constructor;
        this.constructingMethod = null;
    }

    public InstantiateException(String beanClass, String msg, Throwable cause) {
        super("Failed to instantiate [" + beanClass + "]: " + msg, cause);
        this.beanClass = null;
        this.constructor = null;
        this.constructingMethod = null;
    }

    public InstantiateException(Class<?> beanClass, String msg) {
        super("Failed to instantiate [" + beanClass.getName() + "]: " + msg);
        this.beanClass = beanClass;
        this.constructor = null;
        this.constructingMethod = null;
    }

    public InstantiateException(Class<?> beanClass, String msg, Throwable cause) {
        super("Failed to instantiate [" + beanClass.getName() + "]: " + msg, cause);
        this.beanClass = beanClass;
        this.constructor = null;
        this.constructingMethod = null;
    }

    public Class<?> getBeanClass() {
        return this.beanClass;
    }

    public Constructor<?> getConstructor() {
        return this.constructor;
    }

    public Method getConstructingMethod() {
        return constructingMethod;
    }
}
