package com.brilliance.swift.mt2SwiftDto.camt053001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.BankToCustomerStatement;
import com.prowidesoftware.swift.model.field.Field20;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt9xx.MT940;
import com.prowidesoftware.swift.model.mt9xx.MT950;

/**
 * @author zh
 * @create 2022-04-24 14:59
 */
public class Camt053001Parse20Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            BankToCustomerStatement bankToCustomerStatement = context.get(BankToCustomerStatement.class);
            Field20 field20 = getField20();
            if (field20 != null) {
                bankToCustomerStatement.getSwiftHeader().setMessageId(field20.getValue());
            }
        }catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }

    private Field20 getField20() {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        if ("940".equals(abstractMT.getMessageType())) {
            MT940 mt940 = (MT940) context.get(AbstractMT.class);
            return mt940.getField20();
        } else {
            MT950 mt950 = (MT950) context.get(AbstractMT.class);
            return mt950.getField20();
        }
    }
}
