package com.brilliance.swift.mt2SwiftDto.camt053001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.BankToCustomerStatement;
import com.prowidesoftware.swift.model.field.Field28C;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt9xx.MT940;
import com.prowidesoftware.swift.model.mt9xx.MT950;

/**
 * @author zh
 * @create 2022-04-24 14:59
 */
public class Camt053001Parse28CField extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            BankToCustomerStatement bankToCustomerStatement = context.get(BankToCustomerStatement.class);
            Field28C field28C = getField28C();
            if(field28C != null){
                bankToCustomerStatement.setPgNb(field28C.getStatementNumber());
                bankToCustomerStatement.setElctrncSeqNb(field28C.getSequenceNumber());
            }
        }catch (Exception e){
            throw new SwiftException(e.getMessage());
        }

    }

    private Field28C getField28C() {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        if ("940".equals(abstractMT.getMessageType())) {
            MT940 mt940 = (MT940) context.get(AbstractMT.class);
            return mt940.getField28C();
        } else {
            MT950 mt950 = (MT950) context.get(AbstractMT.class);
            return mt950.getField28C();
        }
    }
}
