package com.brilliance.swift.mt2SwiftDto.camt054001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.vo.BankToCustomerDebitCreditNotification;
import com.brilliance.swift.vo.common.CcyFormatAmount;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt9xx.MT900;
import com.prowidesoftware.swift.model.mt9xx.MT910;

/**
 * @author zh
 * @create 2022-04-24 14:59
 */
public class Camt054001Parse32aField extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = context.get(BankToCustomerDebitCreditNotification.class);
            if(context.get(AbstractMT.class).getMessageType().equals("900")){
                MT900 mt900 = (MT900) context.get(AbstractMT.class);
                Field32A field32A = mt900.getField32A();
                if(field32A!=null){
                    bankToCustomerDebitCreditNotification.setValueDate(DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd"));
                    CcyFormatAmount cfa = new CcyFormatAmount();
                    cfa.setCcy(field32A.getCurrency());
                    cfa.setAmt(field32A.amount());
                    bankToCustomerDebitCreditNotification.setValueAmount(cfa);
                }
            }else {
                MT910 mt910 = (MT910) context.get(AbstractMT.class);
                Field32A field32A = mt910.getField32A();
                if(field32A!=null){
                    bankToCustomerDebitCreditNotification.setValueDate(DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd"));
                    CcyFormatAmount cfa = new CcyFormatAmount();
                    cfa.setCcy(field32A.getCurrency());
                    cfa.setAmt(field32A.amount());
                    bankToCustomerDebitCreditNotification.setValueAmount(cfa);
                }
            }
        }catch (Exception e){
            throw new SwiftException(e.getMessage());
        }
    }
}
