package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.ServiceLevel;
import com.brilliance.swift.vo.common.ServiceLevelCode;
import com.prowidesoftware.swift.model.field.Field23B;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse23BField extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103)context.get(AbstractMT.class);
            Field23B field23B = mt103.getField23B();
            if (field23B != null) {
                ServiceLevel serviceLevel = new ServiceLevel();
                String value = field23B.getValue();
                if ("CRED".equals(value)) {
                    serviceLevel.setCode(ServiceLevelCode.SDVA);
                } else {
                    serviceLevel.setProprietary(value);
                }
                customerCreditTransfer.setServiceLevel(serviceLevel);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
