package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PurposeChoice;
import com.prowidesoftware.swift.model.field.Field26T;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse26TField extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103)context.get(AbstractMT.class);
            Field26T field26T = mt103.getField26T();
            if (field26T != null) {
                PurposeChoice purposeChoice = new PurposeChoice();
                purposeChoice.setProprietary(field26T.getValue());
                customerCreditTransfer.setPurposeChoice(purposeChoice);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
