package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field50A;
import com.prowidesoftware.swift.model.field.Field50K;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse50Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103)context.get(AbstractMT.class);
            PartyDto partyDto = null;
            if (mt103.getField50A() != null) {
                Field50A field50A = mt103.getField50A();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field50A.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field50A.getLine(1));
                }
                partyDto.setPartyBic(field50A.getBIC());
            } else if (mt103.getField50F() != null) {
                //TODO
            } else if (mt103.getField50K() != null) {
                Field50K field50K = mt103.getField50K();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field50K.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field50K.getLine(1));
                }
                partyDto.setPartyName(field50K.getNameAndAddressLine1());
                if (StringUtil.isNotEmpty(field50K.getNameAndAddressLine2())) {
                    partyDto.addAddress(field50K.getNameAndAddressLine2());
                }
                if (StringUtil.isNotEmpty(field50K.getNameAndAddressLine3())) {
                    partyDto.addAddress(field50K.getNameAndAddressLine3());
                }
                if (StringUtil.isNotEmpty(field50K.getNameAndAddressLine4())) {
                    partyDto.addAddress(field50K.getNameAndAddressLine4());
                }
            }
            if (partyDto != null) {
                customerCreditTransfer.setDebitParty(partyDto);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
