package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field52A;
import com.prowidesoftware.swift.model.field.Field52D;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse52Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103)context.get(AbstractMT.class);
            PartyDto partyDto = null;
            if (mt103.getField52A() != null) {
                Field52A field52A = mt103.getField52A();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field52A.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field52A.getLine(1));
                }
                partyDto.setPartyBic(field52A.getBIC());
            } else if (mt103.getField52D() != null) {
                Field52D field52D = mt103.getField52D();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field52D.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field52D.getLine(1));
                }
                partyDto.setPartyName(field52D.getNameAndAddressLine1());
                if (StringUtil.isNotEmpty(field52D.getNameAndAddressLine2())) {
                    partyDto.addAddress(field52D.getNameAndAddressLine2());
                }
                if (StringUtil.isNotEmpty(field52D.getNameAndAddressLine3())) {
                    partyDto.addAddress(field52D.getNameAndAddressLine3());
                }
                if (StringUtil.isNotEmpty(field52D.getNameAndAddressLine4())) {
                    partyDto.addAddress(field52D.getNameAndAddressLine4());
                }
            }
            if (partyDto != null) {
                customerCreditTransfer.setDebitAgtParty(partyDto);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
