package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field55A;
import com.prowidesoftware.swift.model.field.Field55B;
import com.prowidesoftware.swift.model.field.Field55D;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse55Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103)context.get(AbstractMT.class);
            PartyDto partyDto = null;
            if (mt103.getField55A() != null) {
                Field55A field55A = mt103.getField55A();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field55A.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field55A.getLine(1));
                }
                partyDto.setPartyBic(field55A.getBIC());
            } else if (mt103.getField55B() != null) {
                Field55B field55B = mt103.getField55B();
                //TODO
            } else if (mt103.getField55D() != null) {
                Field55D field55D = mt103.getField55D();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field55D.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field55D.getLine(1));
                }
                partyDto.setPartyName(field55D.getNameAndAddressLine1());
                if (StringUtil.isNotEmpty(field55D.getNameAndAddressLine2())) {
                    partyDto.addAddress(field55D.getNameAndAddressLine2());
                }
                if (StringUtil.isNotEmpty(field55D.getNameAndAddressLine3())) {
                    partyDto.addAddress(field55D.getNameAndAddressLine3());
                }
                if (StringUtil.isNotEmpty(field55D.getNameAndAddressLine4())) {
                    partyDto.addAddress(field55D.getNameAndAddressLine4());
                }
            }
            if (partyDto != null) {
                customerCreditTransfer.setThridAgtParty(partyDto);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
