package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field57A;
import com.prowidesoftware.swift.model.field.Field57B;
import com.prowidesoftware.swift.model.field.Field57C;
import com.prowidesoftware.swift.model.field.Field57D;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse57Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103) context.get(AbstractMT.class);
            PartyDto partyDto = null;
            if (mt103.getField57A() != null) {
                Field57A field57A = mt103.getField57A();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field57A.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field57A.getLine(1));
                }
                partyDto.setPartyBic(field57A.getBIC());
            } else if (mt103.getField57B() != null) {
                Field57B field57B = mt103.getField57B();
                //TODO
            } else if (mt103.getField57C() != null) {
                Field57C field57C = mt103.getField57C();
                partyDto = new PartyDto();
                partyDto = buildPartyAccount(partyDto, field57C.getValue());
            } else if (mt103.getField57D() != null) {
                Field57D field57D = mt103.getField57D();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field57D.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field57D.getLine(1));
                }
                partyDto.setPartyName(field57D.getName());
                if (StringUtil.isNotEmpty(field57D.getNameAndAddressLine2())) {
                    partyDto.addAddress(field57D.getNameAndAddressLine2());
                }
                if (StringUtil.isNotEmpty(field57D.getNameAndAddressLine3())) {
                    partyDto.addAddress(field57D.getNameAndAddressLine3());
                }
                if (StringUtil.isNotEmpty(field57D.getNameAndAddressLine4())) {
                    partyDto.addAddress(field57D.getNameAndAddressLine4());
                }
            }
            if (partyDto != null) {
                customerCreditTransfer.setCreditAgtParty(partyDto);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
