package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.RemittanceInformation;
import com.prowidesoftware.swift.model.field.Field70;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

import java.util.List;

public class Pacs00801Parse70Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103) context.get(AbstractMT.class);
            List<Field70> field70List = mt103.getField70List();
            if (field70List.size() > 0) {
                RemittanceInformation remittanceInfo = new RemittanceInformation();
                String value = "";
                for (int i=0; i<field70List.size(); i++) {
                    value += field70List.get(i).getValue();
                }
                remittanceInfo.addUnstructured(value);
                customerCreditTransfer.setRemittanceInfo(remittanceInfo);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
