package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.CcyFormatAmount;
import com.brilliance.swift.vo.common.ChargeForEnum;
import com.brilliance.swift.vo.common.ChargeInfo;
import com.prowidesoftware.swift.model.field.Field71A;
import com.prowidesoftware.swift.model.field.Field71F;
import com.prowidesoftware.swift.model.field.Field71G;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

import java.util.List;

public class Pacs00801Parse71Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103) context.get(AbstractMT.class);
            Field71A field71A = mt103.getField71A();
            if (field71A != null) {
                String chargeFor = "";
                if (ChargeForEnum.DEBT.desc().equals(field71A.getValue())) {
                    customerCreditTransfer.setChargeFor(ChargeForEnum.DEBT);
                } else if (ChargeForEnum.CRED.desc().equals(field71A.getValue())) {
                    customerCreditTransfer.setChargeFor(ChargeForEnum.CRED);
                } else if (ChargeForEnum.SHAR.desc().equals(field71A.getValue())) {
                    customerCreditTransfer.setChargeFor(ChargeForEnum.SHAR);
                }
            }

            List<Field71F> field71FList = mt103.getField71F();
            if (field71FList.size() > 0) {
                for (Field71F field71F : field71FList) {
                    ChargeInfo chargeInfo = new ChargeInfo();
                    CcyFormatAmount cfa = new CcyFormatAmount();
                    cfa.setCcy(field71F.getCurrency());
                    cfa.setAmt(field71F.amount());
                    chargeInfo.setAmt(cfa);
                    chargeInfo.setPartyDto(customerCreditTransfer.getInstgAgtParty());
                    customerCreditTransfer.addChargeInfo(chargeInfo);
                }
            }
            Field71G field71G = mt103.getField71G();
            if (field71G != null) {
                ChargeInfo chargeInfo = new ChargeInfo();
                CcyFormatAmount cfa = new CcyFormatAmount();
                cfa.setCcy(field71G.getCurrency());
                cfa.setAmt(field71G.amount());
                chargeInfo.setAmt(cfa);
                chargeInfo.setPartyDto(customerCreditTransfer.getInstdAgtParty());
                customerCreditTransfer.addChargeInfo(chargeInfo);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
