package com.brilliance.swift.mt2SwiftDto.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.brilliance.swift.vo.common.CcyFormatAmount;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt2xx.MT202;
import com.prowidesoftware.swift.model.mt2xx.MT202COV;

public class Pacs009001Parse32AField extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = context.get(VoFinancialInstitutionCreditTransfer.class);
            Field32A field32A = getField32A();
            if (field32A != null) {
                financialInstitutionCreditTransfer.setSettledDate(DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd"));
                CcyFormatAmount cfa = new CcyFormatAmount();
                cfa.setCcy(field32A.getCurrency());
                cfa.setAmt(field32A.amount());
                financialInstitutionCreditTransfer.setSettledCcyFormatAmount(cfa);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }

    private Field32A getField32A() {
        if (isCov()) {
            MT202COV mt202Cov = (MT202COV)context.get(AbstractMT.class);
            return mt202Cov.getField32A();
        } else {
            MT202 mt202 = (MT202)context.get(AbstractMT.class);
            return mt202.getField32A();
        }
    }
}
