package com.brilliance.swift.mt2SwiftDto.pacs009001.impl.cov;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field59;
import com.prowidesoftware.swift.model.field.Field59A;
import com.prowidesoftware.swift.model.field.Field59F;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt2xx.MT202COV;

public class Pacs009001Parse59Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            if (!isCov()) return;
            VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = context.get(VoFinancialInstitutionCreditTransfer.class);
            MT202COV mt202COV = (MT202COV) context.get(AbstractMT.class);
            PartyDto partyDto = null;
            if (mt202COV.getField59() != null) {
                Field59 field59 = mt202COV.getField59();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field59.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field59.getLine(1));
                }
                partyDto.setPartyName(field59.getNameAndAddressLine1());
                if (StringUtil.isNotEmpty(field59.getNameAndAddressLine2())) {
                    partyDto.addAddress(field59.getNameAndAddressLine2());
                }
                if (StringUtil.isNotEmpty(field59.getNameAndAddressLine3())) {
                    partyDto.addAddress(field59.getNameAndAddressLine3());
                }
                if (StringUtil.isNotEmpty(field59.getNameAndAddressLine4())) {
                    partyDto.addAddress(field59.getNameAndAddressLine4());
                }
            } else if (mt202COV.getField59A() != null) {
                Field59A field59A = mt202COV.getField59A();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field59A.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field59A.getLine(1));
                }
                partyDto.setPartyBic(field59A.getBIC());
            } else if (mt202COV.getField59F() != null) {
                Field59F field59F = mt202COV.getField59F();
                //TODO
            }
            if (partyDto != null) {
                VoCustomerCreditTransfer customerCreditTransfer = financialInstitutionCreditTransfer.getUnderCustomerCreditTransfer();
                if (customerCreditTransfer == null) {
                    customerCreditTransfer = new VoCustomerCreditTransfer();
                }
                customerCreditTransfer.setCreditParty(partyDto);
                financialInstitutionCreditTransfer.setUnderCustomerCreditTransfer(customerCreditTransfer);
            }
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
