package com.brilliance.swift.mt2mx.camt029001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt029001.AbstractMt2MxCamt029001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field76;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.List;

public class Camt029001Parse76Field extends AbstractMt2MxCamt029001ParseField {

    private static final String NAME = "76";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag76 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag76 != null) {
            Field76 field76 = (Field76)tag76.asField();
            List<String> lines = field76.getLines();
            //第一行: /4!C/[附加信息]    4!C是取消原因代码
            //第2-35行:附加信息的继续
            mt_To_mxField76(lines, txInfAndStsMaps,stsMaps);
        }
    }
}
