package com.brilliance.swift.mt2mx.camt029001.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt029001.AbstractMt2MxCamt029001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field77A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class Camt029001Parse77AField extends AbstractMt2MxCamt029001ParseField {

    private static final String NAME = "77A";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag77A = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag77A != null) {
            Field77A field77A = (Field77A)tag77A.asField();
            String String77A = field77A.getValue().replace("\r\n//", "").replace("\r\n","");
            int index = String77A.indexOf("/UETR/");
            String uetr = "";
            if(index>-1){
                uetr = String77A.substring(index+6);
                txInfAndStsMaps.put("orgnlUETR",uetr);
            }
            if(!((uetr.length()+6)==String77A.length())){
                buildSTErrorInfo(ERROR.T20094, "Block4:77A:", null);
            }
        }else {
            String orgnlUETR = abstractMT.getSwiftMessage().getUETR();
            if(StringUtil.isEmpty(orgnlUETR)){
                buildSTErrorInfo(ERROR.T20087, "Block3/UETR", null);
            }
        }
    }
}
