package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field25;
import com.prowidesoftware.swift.model.field.Field25P;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;
//存储的是账号信息
public class Camt052001Parse25Field extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME_25 = "25";

    private static final String NAME_25P = "25P";

    @Override
    public void parseField() throws SwiftException {
        Field25 field25 = null;
        Field25P field25P = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag25 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_25);
        Tag tag25P = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_25P);
        Map<String, Object> acctMaps = null;
        if (rptMaps.containsKey("acct")) {
            acctMaps = (Map<String, Object>) rptMaps.get("acct");
        } else {
            acctMaps = new HashMap<>();
            rptMaps.put("acct",acctMaps);
        }
        if(tag25!=null){
            field25 = (Field25) tag25.asField();
            mt_to_mxAccount35(field25.getValue(),acctMaps,"Rpt/Acct/Id/IBAN");
        }
        if(tag25P!=null){
            field25P = (Field25P) tag25P.asField();
            mt_to_mxAccount35(field25P.getAccount(),acctMaps,"Rpt/Acct/Id/Othr/Id");
            Map<String, Object> ownrMaps = new HashMap<>();
            acctMaps.put("ownr",ownrMaps);
            Map<String, Object> idMaps = new HashMap<>();
            ownrMaps.put("id",idMaps);
            Map<String, Object> orgIdMaps = new HashMap<>();
            idMaps.put("orgId",orgIdMaps);
            orgIdMaps.put("anyBIC",field25P.getBIC());
        }
    }
}
