package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field28C;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;
//这个域存放了对账单号码和分页序号将这2个值存入map集合中
public class Camt052001Parse28CField extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME = "28C";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag28 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag28 != null) {
            Field28C field28C = (Field28C) tag28.asField();
            rptMaps.put("lglSeqNb",field28C.getStatementNumber());
            Map<String, Object> rptPgntnMaps = null;
            if (rptMaps.containsKey("rptPgntn")) {
                rptPgntnMaps = (Map<String, Object>) rptMaps.get("rptPgntn");
            } else {
                rptPgntnMaps = new HashMap<>();
                rptMaps.put("rptPgntn",rptPgntnMaps);
            }
            rptPgntnMaps.put("pgNb",field28C.getSequenceNumber());
        }
    }
}
