package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field34F;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;
//这个域是最低金额维护，存储在map集合中是只存币种
public class Camt052001Parse34FField extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME = "34F";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag34 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag34 != null) {
            Field34F field34F = (Field34F) tag34.asField();
            Map<String, Object> acctMaps = null;
            if (rptMaps.containsKey("acct")) {
                acctMaps = (Map<String, Object>) rptMaps.get("acct");
            } else {
                acctMaps = new HashMap<>();
                rptMaps.put("acct",acctMaps);
            }
            acctMaps.put("ccy",field34F.getCurrency());
        }
    }
}
