package com.brilliance.swift.mt2mx.camt052001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.vo.common.CdtDbtCode;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field34F;
import com.prowidesoftware.swift.model.field.Field61;
import com.prowidesoftware.swift.model.field.Field86;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
//这个域是对账单细目
public class Camt052001Parse61Field extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME = "61";

    private static final String NAME_86 = "86";

    private static final String NAME_34F = "34F";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag[] tag61 = abstractMT.getSwiftMessage().getBlock4().getTagsByName(NAME);
            List<Tag> tags = abstractMT.getSwiftMessage().getBlock4().getTags();
            Tag tag34 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_34F);
            if (tag61 != null) {
                int index = 0;
                int count = 0;
                for (int i = 0; i < tag61.length; i++) {
                    Field61 field61 = (Field61) tag61[i].asField();
                    Map<String, Object> ntryMaps = null;
                    JSONArray ntryJsonArray = null;
                    if(rptMaps.containsKey("ntry")){
                        ntryJsonArray = (JSONArray) rptMaps.get("ntry");
                        if(i==0){
                            ntryMaps = (Map<String, Object>)ntryJsonArray.get(0);
                        }else {
                            ntryMaps = new HashMap<>();
                            ntryJsonArray.add(ntryMaps);
                        }
                    }else {
                        ntryJsonArray = new JSONArray();
                        ntryMaps = new HashMap<>();
                        rptMaps.put("ntry",ntryJsonArray);
                        ntryJsonArray.add(ntryMaps);
                    }
                    if(field61.getValueDate()!=null){
                        Map<String, Object> valDtMaps = new HashMap<>();
                        ntryMaps.put("valDt",valDtMaps);
                        Date date = DateUtil.parseDate("20"+field61.getValueDate(), "yyyyMMdd");
                        String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                        valDtMaps.put("dt",dateStr);
                    }
                    if(field61.getEntryDate()!=null){
                        Map<String, Object> bookgDtMaps = new HashMap<>();
                        ntryMaps.put("bookgDt",bookgDtMaps);
                        Date date = DateUtil.parseDate("20"+field61.getValueDate().substring(0,2)+field61.getEntryDate(), "yyyyMMdd");
                        String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                        bookgDtMaps.put("dt",dateStr);
                    }
                    if(field61.getDCMark()!=null){
                        if("RC".equals(field61.getDCMark())||"D".equals(field61.getDCMark())){
                            if("RC".equals(field61.getDCMark())){
                                ntryMaps.put("rvslInd",Boolean.TRUE);
                            }
                            ntryMaps.put("cdtDbtInd", CdtDbtCode.DBIT.value());
                        }else {
                            if("RD".equals(field61.getDCMark())){
                                ntryMaps.put("rvslInd",Boolean.TRUE);
                            }
                            ntryMaps.put("cdtDbtInd", CdtDbtCode.CRDT.value());
                        }
                    }
                    if(field61.getAmount()!=null){
                        Map<String, Object> amtMaps = new HashMap<>();
                        ntryMaps.put("amt",amtMaps);
                        amtMaps.put("value",field61.amount());
                        Field34F field34F = (Field34F) tag34.asField();
                        amtMaps.put("ccy",field34F.getCurrency());
                    }
                    JSONArray ntryDtlsJsonArray = null;
                    Map<String, Object> ntryDtlsMaps = null;
                    if(ntryMaps.containsKey("ntryDtls")){
                        ntryDtlsJsonArray = (JSONArray)ntryMaps.get("ntryDtls");
                        ntryDtlsMaps = (Map<String, Object>)ntryDtlsJsonArray.get(0);
                    }else {
                        ntryDtlsJsonArray = new JSONArray();
                        ntryDtlsMaps = new HashMap<>();
                        ntryDtlsJsonArray.add(ntryDtlsMaps);
                        ntryMaps.put("ntryDtls",ntryDtlsJsonArray);
                    }
                    JSONArray txDtlsJsonArray = null;
                    Map<String, Object> txDtlsMaps = null;
                    if(ntryDtlsMaps.containsKey("txDtls")){
                        txDtlsJsonArray = (JSONArray)ntryDtlsMaps.get("txDtls");
                        txDtlsMaps = (Map<String, Object>)txDtlsJsonArray.get(0);
                    }else {
                        txDtlsJsonArray = new JSONArray();
                        txDtlsMaps = new HashMap<>();
                        ntryDtlsMaps.put("txDtls",txDtlsJsonArray);
                        txDtlsJsonArray.add(txDtlsMaps);
                    }
                    if(field61.getReferenceForTheAccountOwner()!=null){
                        Map<String, Object> refsMaps = null;
                        if(txDtlsMaps.containsKey("refs")){
                            refsMaps = (Map<String, Object>)txDtlsMaps.get("refs");
                        }else {
                            refsMaps = new HashMap<>();
                            txDtlsMaps.put("refs",refsMaps);
                        }
                        refsMaps.put("endToEndId",field61.getReferenceForTheAccountOwner());
                    }
                    if(field61.getReferenceOfTheAccountServicingInstitution()!=null){
                        ntryMaps.put("acctSvcrRef",field61.getReferenceOfTheAccountServicingInstitution());
                    }
                    if(field61.getSupplementaryDetails()!=null){
                        txDtlsMaps.put("addtlTxInf",field61.getSupplementaryDetails());
                    }
                    Tag[] tag86 = abstractMT.getSwiftMessage().getBlock4().getTagsByName(NAME_86);
                    if(tag86!=null){
                        if(tags!=null){
                            for (;index < tags.size()-1; index++) {
                                if(tags.get(index).getName().equals("61")&&tags.get(index+1).getName().equals("86")){
                                    Field86 field86 = (Field86) tag86[count].asField();
                                    ntryMaps.put("addtlRptInf",field86.getValue().replace("\r\n",""));
                                    count++;
                                }
                            }
                        }
                    }

                }
            }
        }catch (ParseException e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
