package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field90C;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.utils.SwiftFormatUtils;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;
//这个域存储的是贷记笔数和金额
public class Camt052001Parse90CField extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME = "90C";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag90C = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag90C != null) {
            Field90C field90C = (Field90C)tag90C.asField();
            Map<String, Object> txsSummryMaps = null;
            if (rptMaps.containsKey("txsSummry")) {
                txsSummryMaps = (Map<String, Object>) rptMaps.get("txsSummry");
            } else {
                txsSummryMaps = new HashMap<>();
                rptMaps.put("txsSummry",txsSummryMaps);
            }
            Map<String, Object> ttlCdtNtriesMaps = null;
            if (txsSummryMaps.containsKey("ttlCdtNtries")) {
                ttlCdtNtriesMaps = (Map<String, Object>) rptMaps.get("ttlCdtNtries");
            } else {
                ttlCdtNtriesMaps = new HashMap<>();
                txsSummryMaps.put("ttlCdtNtries",ttlCdtNtriesMaps);
            }
            Number number = SwiftFormatUtils.getNumber(field90C.getAmount());
            BigDecimal amt = new BigDecimal(number.toString()).stripTrailingZeros();
            ttlCdtNtriesMaps.put("nbOfNtries",field90C.getNumber());
            ttlCdtNtriesMaps.put("sum",amt);
        }
    }
}
