package com.brilliance.swift.mt2mx.camt053001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt053001.impl.*;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt053001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        //将报文类型放入jsonMaps集合中，这个maps集合是最上层
        jsonMaps.put("identifier", "camt.053.001.08");
        Map<String, Object> appHdrMaps = (Map<String, Object>)jsonMaps.get("appHdr");
        //将消息头中的消息名放入头部的map集合中
        appHdrMaps.put("msgDefIdr", "camt.053.001.08");
        //得到AbstractMT这个对象用来解析mt文件
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Map<String, Object> bkToCstmrStmtMaps = new HashMap<>();
        jsonMaps.put("bkToCstmrStmt", bkToCstmrStmtMaps);
        Map<String, Object> grpHdrMaps = new HashMap<>();
        bkToCstmrStmtMaps.put("grpHdr", grpHdrMaps);
        //将当前的时间存入这个map集合中
        grpHdrMaps.put("creDtTm", getCreateDateStr());
        grpHdrMaps.put("nbOfTxs", "1");

        Map<String, Object> stmtMaps = new HashMap<>();
        JSONArray stmtJsonArray = new JSONArray();
        stmtJsonArray.add(stmtMaps);
        bkToCstmrStmtMaps.put("stmt", stmtJsonArray);
        Map<String, Object> ntryMaps = new HashMap<>();
        JSONArray ntryJsonArray = new JSONArray();
        Map<String, Object> ntryDtlsMaps = new HashMap<>();
        JSONArray ntryDtlsJsonArray = new JSONArray();
        Map<String, Object> txDtlsMaps = new HashMap<>();
        JSONArray txDtlsJsonArray = new JSONArray();
        //将报文追踪号存入map集合中
        String uetr = abstractMT.getSwiftMessage().getUETR();
        if (StringUtil.isNotEmpty(uetr)) {
            ntryJsonArray.add(ntryMaps);
            stmtMaps.put("ntry", ntryJsonArray);
            ntryDtlsJsonArray.add(ntryDtlsMaps);
            ntryMaps.put("ntryDtls", ntryDtlsJsonArray);
            txDtlsJsonArray.add(txDtlsMaps);
            ntryDtlsMaps.put("txDtls", txDtlsJsonArray);
            Map<String, Object> refsMaps = new HashMap<>();
            txDtlsMaps.put("refs",refsMaps);
            refsMaps.put("uetr",uetr);
        }
        //在sts中存入默认值BOOK,bkTxCd下cd,issr取初始值NOTPROVIDED
        Map<String, Object> stsMaps = new HashMap<>();
        ntryMaps.put("sts",stsMaps);
        stsMaps.put("cd","BOOK");
        Map<String, Object> bkTxCdMaps = new HashMap<>();
        ntryMaps.put("bkTxCd",bkTxCdMaps);
        Map<String, Object> prtryMaps = new HashMap<>();
        bkTxCdMaps.put("prtry",prtryMaps);
        prtryMaps.put("cd", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        prtryMaps.put("issr",Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<>();
        list.add(new Camt053001Parse20Field());
        list.add(new Camt053001Parse25Field());
        list.add(new Camt053001Parse28CField());
        list.add(new Camt053001Parse60Field());
        list.add(new Camt053001Parse61Field());
        list.add(new Camt053001Parse62Field());
        list.add(new Camt053001Parse64Field());
        list.add(new Camt053001Parse65Field());
        list.add(new Camt053001Parse86Field());
        return list;
    }
}
