package com.brilliance.swift.mt2mx.camt053001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt053001.AbstractMt2MxCamt053001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.vo.common.BalanceTypeCode;
import com.brilliance.swift.vo.common.CdtDbtCode;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field65;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
//某日有效余额
public class Camt053001Parse65Field extends AbstractMt2MxCamt053001ParseField {

    private static final String NAME = "65";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            if("950".equals(abstractMT.getMessageType())){
                return;
            }
            Tag[] tag65 = abstractMT.getSwiftMessage().getBlock4().getTagsByName(NAME);
            if (tag65.length>0) {
                for (int i = 0; i < tag65.length; i++) {
                    Field65 field65 = (Field65) tag65[i].asField();
                    Map<String, Object> balMaps = null;
                    JSONArray balJsonArray = null;
                    if(stmtMaps.containsKey("bal")){
                        balJsonArray = (JSONArray) stmtMaps.get("bal");
                        balMaps = new HashMap<>();
                        balJsonArray.add(balMaps);
                    }else {
                        balJsonArray = new JSONArray();
                        balMaps = new HashMap<>();
                        stmtMaps.put("bal",balJsonArray);
                        balJsonArray.add(balMaps);
                    }
                    Map<String, Object> tpMaps = new HashMap<>();
                    balMaps.put("tp",tpMaps);
                    Map<String, Object> cdOrPrtryMaps = new HashMap<>();
                    tpMaps.put("cdOrPrtry",cdOrPrtryMaps);
                    cdOrPrtryMaps.put("cd", BalanceTypeCode.FWAV.value());
                    Map<String, Object> dtMaps = null;
                    if(balMaps.containsKey("dt")){
                        dtMaps = (Map<String, Object>)balMaps.get("dt");
                    }else {
                        dtMaps = new HashMap<>();
                        balMaps.put("dt",dtMaps);
                    }
                    Map<String, Object> amtMaps = null;
                    if(balMaps.containsKey("amt")){
                        amtMaps = (Map<String, Object>)balMaps.get("amt");
                    }else {
                        amtMaps = new HashMap<>();
                        balMaps.put("amt",amtMaps);
                    }
                    if ("D".equals(field65.getDCMark())) {
                        balMaps.put("cdtDbtInd", CdtDbtCode.DBIT.value());
                    } else if ("C".equals(field65.getDCMark())) {
                        balMaps.put("cdtDbtInd", CdtDbtCode.CRDT.value());
                    }
                    Date date = DateUtil.parseDate("20" + field65.getDate(), "yyyyMMdd");
                    String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                    dtMaps.put("dt",dateStr);
                    amtMaps.put("value",field65.amount());
                    amtMaps.put("ccy",field65.getCurrency());
                }
            }
        } catch (ParseException e) {
            throw new SwiftException(e.getMessage());
        }
    }
}
