package com.brilliance.swift.mt2mx.camt054001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt054001.AbstractMt2MxCamt054001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field13D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;
//这个域存放的是报文的创建时间，将这个时间放入map集合中
public class Camt054001Parse13DField extends AbstractMt2MxCamt054001ParseField {

    private static final String NAME = "13D";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag13D = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        Map<String, Object> bookgDtMaps = new HashMap<>();
        ntryMaps.put("bookgDt",bookgDtMaps);
        if (tag13D != null) {
            String xmlDateStr = "";
            Field13D field13D = (Field13D) tag13D.asField();
            if(field13D.getDate().length()==6){
                xmlDateStr = "20" + field13D.getDate().substring(0,2)
                        +"-"+field13D.getDate().substring(2,4)
                        +"-"+field13D.getDate().substring(4,6);
            }else if(field13D.getDate().length()==8){
                xmlDateStr = field13D.getDate().substring(0,4)
                        +"-"+field13D.getDate().substring(4,6)
                        +"-"+field13D.getDate().substring(6,8);
            }
            String mxTime = "";
            if(field13D.getTime().length()==4){
                mxTime = field13D.getTime().substring(0,2)+":"+field13D.getTime().substring(2)+":00";
            }else if(field13D.getTime().length()==6){
                mxTime = field13D.getTime().substring(0,2)+":"+field13D.getTime().substring(2,4)+":"+field13D.getTime().substring(4);
            }else {
                mxTime = field13D.getTime().substring(0,2)+":"+field13D.getTime().substring(2,4)+":"+field13D.getTime().substring(4,6)
                        +"."+field13D.getTime().substring(7);
            }
            String mxOffset = "";
            if(field13D.getOffset().length()==4){
                mxOffset = field13D.getOffset().substring(0,2)+":"+field13D.getOffset().substring(2);
            }else {
                mxOffset = field13D.getOffset()+":00";
            }
            xmlDateStr = xmlDateStr +"T" + mxTime + "+" +mxOffset;
            bookgDtMaps.put("dtTm",xmlDateStr);
        }else {
            bookgDtMaps.put("dtTm","9999-12-31T00:00:00+00:00");
        }
    }
}
