package com.brilliance.swift.mt2mx.camt054001.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt054001.AbstractMt2MxCamt054001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
//这个域存储的是起息日，货币和金额
public class Camt054001Parse32AField extends AbstractMt2MxCamt054001ParseField {

    private static final String NAME = "32A";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag32A = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag32A != null) {
                Field32A field32A = (Field32A)tag32A.asField();
                if(field32A.getValue().length()>10){
                    Map<String, Object> acctMaps = null;
                    if(ntfctnMaps.containsKey("acct")){
                        acctMaps = (Map<String, Object>)ntfctnMaps.get("acct");
                    }else {
                        acctMaps = new HashMap<>();
                        ntfctnMaps.put("acct",acctMaps);
                    }
                    buildSTErrorInfo(ERROR.T20200, "Ntfctn/Acct/Ccy", null);
                    acctMaps.put("ccy",field32A.getValue().substring(6,9));
                }
                Date date = DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                Map<String, Object> valDtMaps = new HashMap<>();
                ntryMaps.put("valDt",valDtMaps);
                valDtMaps.put("dt",dateStr);
                Map<String, Object> rltdDtsMaps = new HashMap<>();
                txDtlsMaps.put("rltdDts",rltdDtsMaps);
                rltdDtsMaps.put("intrBkSttlmDt",dateStr);
                Map<String, Object> amtMaps = new HashMap<>();
                amtMaps.put("value",field32A.amount());
                amtMaps.put("ccy",field32A.getCurrency());
                ntryMaps.put("amt",amtMaps);
                Map<String, Object> txDtlAmtMaps = new HashMap<>(amtMaps);
                txDtlsMaps.put("amt",txDtlAmtMaps);
            }
        } catch (ParseException e) {
            throw  new SwiftException(e.getMessage());
        }
    }
}
