package com.brilliance.swift.mt2mx.camt054001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.camt054001.AbstractMt2MxCamt054001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field52A;
import com.prowidesoftware.swift.model.field.Field52D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;
//指示行信息
public class Camt054001Parse52For910Field extends AbstractMt2MxCamt054001ParseField {

    private static final String NAME_A = "52A";

    private static final String NAME_D = "52D";

    @Override
    public void parseField() throws SwiftException {
        Field52A field52A = null;
        Field52D field52D = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        if("900".equals(abstractMT.getMessageType())){
            return;
        }
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
        if (tag != null) {
            field52A = (Field52A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_D);
        if (tag != null) {
            field52D = (Field52D)tag.asField();
        }
        String flag = (String) context.get(Mt2MxContextIdentifier.MT_TO_MX_FLAG_50);
        if("true".equals(flag)){
            Map<String, Object> rltdAgtsMaps = null;
            if (txDtlsMaps.containsKey("rltdAgts")) {
                rltdAgtsMaps = (Map<String, Object>) txDtlsMaps.get("rltdAgts");
            } else {
                rltdAgtsMaps = new HashMap<>();
                txDtlsMaps.put("rltdAgts",rltdAgtsMaps);
            }
            Map<String, Object> dbtrAgtMaps = null;
            if (rltdAgtsMaps.containsKey("dbtrAgt")) {
                dbtrAgtMaps = (Map<String, Object>) rltdAgtsMaps.get("dbtrAgt");
            } else {
                dbtrAgtMaps = new HashMap<>();
            }
            String account = "";
            if (field52A != null) {
                String bicCode = field52A.getBIC();
                mt_to_mxBICFI(bicCode, dbtrAgtMaps);
                if (StringUtil.isNotEmpty(field52A.getComponent1())) {
                    account += "/" + field52A.getComponent1();
                }
                if (StringUtil.isNotEmpty(field52A.getComponent2())) {
                    account += "/" + field52A.getComponent2();
                }
            }
            if (field52D != null) {
                if (StringUtil.isNotEmpty(field52D.getComponent1())) {
                    account += "/" + field52D.getComponent1();
                }
                if (StringUtil.isNotEmpty(field52D.getComponent2())) {
                    account += "/" + field52D.getComponent2();
                }
                String nameAddress = field52D.getNameAndAddress();
                mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(nameAddress, dbtrAgtMaps);
            }
            if (StringUtil.isNotEmpty(account)) {
                if (account.startsWith("//") && !account.startsWith("//CH") && !account.startsWith("//FW")) {
                    Map<String, Object> finInstnIdMaps = null;
                    if (dbtrAgtMaps.containsKey("finInstnId")) {
                        finInstnIdMaps = (Map<String, Object>) dbtrAgtMaps.get("finInstnId");
                    } else {
                        finInstnIdMaps = new HashMap<>();
                        dbtrAgtMaps.put("finInstnId", finInstnIdMaps);
                    }
                    Map<String, Object> clrSysMmbIdMaps = null;
                    if (finInstnIdMaps.containsKey("clrSysMmbId")) {
                        clrSysMmbIdMaps = (Map<String, Object>) finInstnIdMaps.get("clrSysMmbId");
                    } else {
                        clrSysMmbIdMaps = new HashMap<>();
                        finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                    }
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                }
                if(dbtrAgtMaps.size()>0){
                    rltdAgtsMaps.put("dbtrAgt",dbtrAgtMaps);
                }
            }
        }else {
            Map<String, Object> rltdPtiesMaps = null;
            if (txDtlsMaps.containsKey("rltdPties")) {
                rltdPtiesMaps = (Map<String, Object>) txDtlsMaps.get("rltdPties");
            } else {
                rltdPtiesMaps = new HashMap<>();
                txDtlsMaps.put("rltdPties",rltdPtiesMaps);
            }
            Map<String, Object> dbtrAcctMaps = null;
            if (rltdPtiesMaps.containsKey("dbtrAcct")) {
                dbtrAcctMaps = (Map<String, Object>) rltdPtiesMaps.get("dbtrAcct");
            } else {
                dbtrAcctMaps = new HashMap<>();
            }
            Map<String, Object> dbtrMaps = null;
            if (rltdPtiesMaps.containsKey("dbtr")) {
                dbtrMaps = (Map<String, Object>) rltdPtiesMaps.get("dbtr");
            } else {
                dbtrMaps = new HashMap<>();
                rltdPtiesMaps.put("dbtr",dbtrMaps);
            }
            Map<String, Object> agtMaps = null;
            if (rltdPtiesMaps.containsKey("agt")) {
                agtMaps = (Map<String, Object>) dbtrMaps.get("agt");
            } else {
                agtMaps = new HashMap<>();
            }
            String account = "";
            if (field52A != null) {
                String bicCode = field52A.getBIC();
                mt_to_mxBICFI(bicCode, agtMaps);
                if (StringUtil.isNotEmpty(field52A.getComponent1())) {
                    account += "/" + field52A.getComponent1();
                }
                if (StringUtil.isNotEmpty(field52A.getComponent2())) {
                    account += "/" + field52A.getComponent2();
                }
            }
            if (field52D != null) {
                if (StringUtil.isNotEmpty(field52D.getComponent1())) {
                    account += "/" + field52D.getComponent1();
                }
                if (StringUtil.isNotEmpty(field52D.getComponent2())) {
                    account += "/" + field52D.getComponent2();
                }
                String nameAddress = field52D.getNameAndAddress();
                mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(nameAddress, agtMaps);
            }
            if (StringUtil.isNotEmpty(account)) {
                if (account.startsWith("//") && !account.startsWith("//CH") && !account.startsWith("//FW")) {
                    Map<String, Object> finInstnIdMaps = null;
                    if (agtMaps.containsKey("finInstnId")) {
                        finInstnIdMaps = (Map<String, Object>)agtMaps.get("finInstnId");
                    } else {
                        finInstnIdMaps = new HashMap<>();
                        agtMaps.put("finInstnId", finInstnIdMaps);
                    }
                    Map<String, Object> clrSysMmbIdMaps = null;
                    if (finInstnIdMaps.containsKey("clrSysMmbId")) {
                        clrSysMmbIdMaps = (Map<String, Object>)finInstnIdMaps.get("clrSysMmbId");
                    } else {
                        clrSysMmbIdMaps = new HashMap<>();
                        finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                    }
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                } else if (!account.startsWith("//") || account.startsWith("//CH")) {
                    mt_to_mxFinancialInstitutionAccount(account, dbtrAcctMaps, "DbtrAcct/Id");
                }
            }
            if(agtMaps.size()>0){
                dbtrMaps.put("agt",agtMaps);
            }
            if(dbtrAcctMaps.size()>0){
                rltdPtiesMaps.put("dbtrAcct",dbtrAcctMaps);
            }
        }
    }
}
