package com.brilliance.swift.mt2mx.camt054001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt054001.AbstractMt2MxCamt054001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field72;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.List;
//附加说明
public class Camt054001Parse72Field extends AbstractMt2MxCamt054001ParseField {

    private static final String NAME = "72";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag72 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag72 != null) {
            Field72 field72 = (Field72)tag72.asField();
            List<String> lines = field72.getLines();
            String addtlTxInf = "";
            if(lines!=null){
                addtlTxInf = lines.get(0);
                if(addtlTxInf.length()<35){
                    addtlTxInf = addtlTxInf + " ";
                }
                String line = "";
                for (int i = 1; i < lines.size(); i++) {
                    if(lines.get(i).startsWith("//")){
                        line = lines.get(i).substring(2);
                    }else {
                        line = lines.get(i);
                    }
                    if(line.length()<35){
                        addtlTxInf = addtlTxInf +line +" ";
                    }else {
                        addtlTxInf = addtlTxInf + line;
                    }
                }
            }
            txDtlsMaps.put("addtlTxInf",addtlTxInf.trim());
        }
    }
}
