package com.brilliance.swift.mt2mx.camt056001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt056001.impl.*;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt056001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        //将报文类型放入jsonMaps集合中，这个maps集合是最上层
        jsonMaps.put("identifier", "camt.056.001.08");
        Map<String, Object> appHdrMaps = (Map<String, Object>)jsonMaps.get("appHdr");
        //将消息头中的消息名放入头部的map集合中
        appHdrMaps.put("msgDefIdr", "camt.056.001.08");
        //得到AbstractMT这个对象用来解析mt文件
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Map<String, Object> fiToFIPmtCxlReqMaps = new HashMap<>();
        jsonMaps.put("fiToFIPmtCxlReq", fiToFIPmtCxlReqMaps);
        Map<String, Object> assgnmtMaps = new HashMap<>();
        fiToFIPmtCxlReqMaps.put("assgnmt", assgnmtMaps);
        //将当前的时间存入这个map集合中
        assgnmtMaps.put("creDtTm", getCreateDateStr());

        Map<String, Object> undrlygMaps = new HashMap<>();
        JSONArray undrlygJsonArray = new JSONArray();
        undrlygJsonArray.add(undrlygMaps);
        fiToFIPmtCxlReqMaps.put("undrlyg", undrlygJsonArray);
        Map<String, Object> txInfMaps = new HashMap<>();
        JSONArray txInfJsonArray = new JSONArray();
        txInfJsonArray.add(txInfMaps);
        undrlygMaps.put("txInf",txInfJsonArray);
        //将报文追踪号存入map集合中
        String orgnlUETR = abstractMT.getSwiftMessage().getUETR();
        if (StringUtil.isNotEmpty(orgnlUETR)) {
            txInfMaps.put("orgnlUETR", orgnlUETR);
        }
        //根据官方文档这个位置存值NOTPROVIDED
        txInfMaps.put("orgnlEndToEndId",Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        String sendBic = (String) context.get(Mt2MxContextIdentifier.MT_SEND_BIC, true);
        if (StringUtil.isNotEmpty(sendBic)) {
            Map<String, Object> assgnrMaps = new HashMap<>();
            assgnmtMaps.put("assgnr",assgnrMaps);
            Map<String, Object> agtMaps = new HashMap<>();
            assgnrMaps.put("agt",agtMaps);
            //调用这个方法将转让人(消息发送者)的参与行的行号存入map集合中
            mt_to_mxBICFI(sendBic, agtMaps);
        }
        String receiverBic = (String) context.get(Mt2MxContextIdentifier.MT_RECEIVE_BIC, true);
        if (StringUtil.isNotEmpty(receiverBic)) {
            Map<String, Object> assgneMaps = new HashMap<>();
            assgnmtMaps.put("assgne",assgneMaps);
            Map<String, Object> agtMaps = new HashMap<>();
            assgneMaps.put("agt",agtMaps);
            //调用这个方法将受让人(消息接受者)的参与行的行号存入map集合中
            mt_to_mxBICFI(receiverBic, agtMaps);
        }
        //假定创建者是代理人而不是当事人,根据官方文档在nm和adrLine这两个位置存值NOTPROVIDED
        Map<String, Object> caseMaps = null;
        if(txInfMaps.containsKey("_case")){
            caseMaps = (Map<String, Object>) txInfMaps.get("_case");
        }else {
            caseMaps = new HashMap<>();
            txInfMaps.put("_case",caseMaps);
        }
        Map<String, Object> cretrMaps = new HashMap<>();
        Map<String, Object> agtMaps = new HashMap<>();
        Map<String, Object> finInstnIdMaps = new HashMap<>();
        Map<String, Object> pstlAdrMaps = new HashMap<>();
        caseMaps.put("cretr",cretrMaps);
        cretrMaps.put("agt",agtMaps);
        agtMaps.put("finInstnId",finInstnIdMaps);
        finInstnIdMaps.put("nm", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        finInstnIdMaps.put("pstlAdr",pstlAdrMaps);
        JSONArray adrLineJsonArray = new JSONArray();
        pstlAdrMaps.put("adrLine",adrLineJsonArray);
        adrLineJsonArray.add(Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<>();
        list.add(new Camt056001Parse20Field());
        list.add(new Camt056001Parse21Field());
        list.add(new Camt056001Parse11SField());
        list.add(new Camt056001Parse79Field());
        list.add(new Camt056001Parse32AField());
        return list;
    }
}
