package com.brilliance.swift.mt2mx.camt056001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt056001.AbstractMt2MxCamt056001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field11S;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
//这个域的作用就是将原始消息的名称和原始消息的创建时间存入map集合
public class Camt056001Parse11SField extends AbstractMt2MxCamt056001ParseField {

    private static final String NAME = "11S";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag11S = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag11S != null) {
                Field11S field11S = (Field11S)tag11S.asField();
                Date date = DateUtil.parseDate("20"+field11S.getDate(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                Map<String, Object> orgnlGrpInfMaps = null;
                if(txInfMaps.containsKey("orgnlGrpInf")){
                    orgnlGrpInfMaps = (Map<String, Object>)txInfMaps.get("orgnlGrpInf");
                }else {
                    orgnlGrpInfMaps = new HashMap<>();
                    txInfMaps.put("orgnlGrpInf",orgnlGrpInfMaps);
                }
                String mtType = field11S.getMT();
                String mxType = getMxType(mtType);
                orgnlGrpInfMaps.put("orgnlMsgNmId",mxType);
                orgnlGrpInfMaps.put("orgnlCreDtTm",dateStr+"T00:00:00+00:00");
            }
        } catch (ParseException e) {
        throw  new SwiftException(e.getMessage());
        }
    }
}
