package com.brilliance.swift.mt2mx.camt056001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt056001.AbstractMt2MxCamt056001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;
//将原始消息的标识号填入map集合中
public class Camt056001Parse21Field extends AbstractMt2MxCamt056001ParseField {

    private static final String NAME = "21";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag21 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag21 != null) {
            txInfMaps.put("orgnlInstrId",tag21.getValue());
            Map<String, Object> orgnlGrpInfMaps = null;
            if(txInfMaps.containsKey("orgnlGrpInf")){
                orgnlGrpInfMaps = (Map<String, Object>)txInfMaps.get("orgnlGrpInf");
            }else {
                orgnlGrpInfMaps = new HashMap<>();
                txInfMaps.put("orgnlGrpInf",orgnlGrpInfMaps);
            }
            orgnlGrpInfMaps.put("orgnlMsgId",tag21.getValue());
        }
    }
}
