package com.brilliance.swift.mt2mx.camt056001.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt056001.AbstractMt2MxCamt056001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
//这个域的作用是将原始发报行给收报行的金额和原始结算日期填入map集合中
public class Camt056001Parse32AField extends AbstractMt2MxCamt056001ParseField {

    private static final String NAME = "32A";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag32A = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag32A != null) {
                Field32A field32A = (Field32A)tag32A.asField();
                Date date = DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                txInfMaps.put("orgnlIntrBkSttlmDt",dateStr);
                Map<String,Object> orgnlIntrBkSttlmAmtMaps = new HashMap();
                orgnlIntrBkSttlmAmtMaps.put("value", field32A.amount());
                orgnlIntrBkSttlmAmtMaps.put("ccy", field32A.getCurrency());
                txInfMaps.put("orgnlIntrBkSttlmAmt",orgnlIntrBkSttlmAmtMaps);
            }else {
                buildSTErrorInfo(ERROR.T20088, "Block4:32A:", null);
            }
        } catch (ParseException e) {
            throw  new SwiftException(e.getMessage());
        }
    }
}
