package com.brilliance.swift.mt2mx.camt056001.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt056001.AbstractMt2MxCamt056001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field79;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.List;
//79域就是将取消原因对应代码和取消原因的详情放入对应的map集合中
public class Camt056001Parse79Field extends AbstractMt2MxCamt056001ParseField {

    private static final String NAME = "79";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag79 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag79 != null) {
            Field79 field79 = (Field79)tag79.asField();
            List<String> lines = field79.getLines();
            //第一行: /4!C/[附加信息]    4!C是取消原因代码
            //第2-35行:附加信息的继续
            //最后一行:/UETR/UETRValue
            mt_To_mxField79(lines,txInfMaps);
        }else {
            String orgnlUETR = abstractMT.getSwiftMessage().getUETR();
            if(StringUtil.isEmpty(orgnlUETR)){
                buildSTErrorInfo(ERROR.T20087, "Block3/UETR", null);
            }
            mt_To_mxField79(null,txInfMaps);
        }
    }
}
