package com.brilliance.swift.mt2mx.camt057001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt057001.impl.*;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt057001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        jsonMaps.put("identifier", "camt.057.001.06");
        Map<String, Object> appHdrMaps = (Map<String, Object>)jsonMaps.get("appHdr");
        appHdrMaps.put("msgDefIdr", "camt.057.001.06");
        AbstractMT abstractMT = context.get(AbstractMT.class);

        //初始化转换和不需要BLOCK4的转换
        Map<String, Object> ntfctnToRcvMaps = new HashMap<>();
        jsonMaps.put("ntfctnToRcv", ntfctnToRcvMaps);
        Map<String, Object> grpHdrMaps = new HashMap<>();
        ntfctnToRcvMaps.put("grpHdr", grpHdrMaps);
        grpHdrMaps.put("creDtTm", getCreateDateStr());
        grpHdrMaps.put("nbOfTxs", "1");

        Map<String, Object> ntfctnMaps = new HashMap<>();
        ntfctnToRcvMaps.put("ntfctn", ntfctnMaps);
        Map<String, Object> itmMaps = new HashMap<>();
        JSONArray itmJsonArray = new JSONArray();
        itmJsonArray.add(itmMaps);
        ntfctnMaps.put("itm",itmJsonArray);
        String uetr = abstractMT.getSwiftMessage().getUETR();
        if (StringUtil.isNotEmpty(uetr)) {
            itmMaps.put("uetr",uetr);
        }

    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<>();
        list.add(new Camt057001Parse20Field());
        list.add(new Camt057001Parse21Field());
        list.add(new Camt057001Parse25Field());
        list.add(new Camt057001Parse30Field());
        list.add(new Camt057001Parse32BField());
        list.add(new Camt057001Parse50Field());
        list.add(new Camt057001Parse52Field());
        list.add(new Camt057001Parse56Field());
        return list;
    }
}
