package com.brilliance.swift.mt2mx.camt057001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt057001.AbstractMt2MxCamt057001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field30;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
//起息日
public class Camt057001Parse30Field extends AbstractMt2MxCamt057001ParseField {

    private static final String NAME = "30";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag30 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag30 != null) {
                Field30 field30 = (Field30)tag30.asField();
                Date date = DateUtil.parseDate("20"+field30.getValue(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                ntfctnMaps.put("xpctdValDt",dateStr);
            }else {
                ntfctnMaps.put("xpctdValDt",grpHdrMaps.get("creDtTm"));
            }
        }catch (ParseException e) {
            throw new SwiftException(e.getMessage());
        }

    }
}
