package com.brilliance.swift.mt2mx.camt057001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt057001.AbstractMt2MxCamt057001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32B;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;
//货币和金额
public class Camt057001Parse32BField extends AbstractMt2MxCamt057001ParseField {

    private static final String NAME = "32B";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag32B = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag32B != null) {
            Field32B field32B = (Field32B) tag32B.asField();
            Map<String, Object> itmMaps = null;
            JSONArray itmJsonArray = null;
            if(ntfctnMaps.containsKey("itm")){
                itmJsonArray = (JSONArray) ntfctnMaps.get("itm");
                itmMaps = (Map<String, Object>)itmJsonArray.get(0);
            }else {
                itmJsonArray = new JSONArray();
                itmMaps = new HashMap<>();
                ntfctnMaps.put("itm",itmJsonArray);
                itmJsonArray.add(itmMaps);
            }
            Map<String, Object> amtMaps = null;
            if (itmMaps.containsKey("amt")) {
                amtMaps = (Map<String, Object>) ntfctnMaps.get("amt");
            } else {
                amtMaps = new HashMap<>();
                itmMaps.put("amt",amtMaps);
            }
            amtMaps.put("value", field32B.amount());
            amtMaps.put("ccy", field32B.getCurrency());
        }
    }
}
