package com.brilliance.swift.mt2mx.camt057001.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt057001.AbstractMt2MxCamt057001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field50;
import com.prowidesoftware.swift.model.field.Field50C;
import com.prowidesoftware.swift.model.field.Field50F;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
//汇款人
public class Camt057001Parse50Field extends AbstractMt2MxCamt057001ParseField {

    private static final String NAME = "50";

    private static final String NAME_C = "50C";

    private static final String NAME_F = "50F";

    @Override
    public void parseField() throws SwiftException {
        Field50 field50 = null;
        Field50C field50C = null;
        Field50F field50F = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag50 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag50 != null) {
            field50 = (Field50)tag50.asField();
        }
        tag50 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_C);
        if(tag50!=null){
            field50C = (Field50C)tag50.asField();
        }
        tag50 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_F);
        if (tag50!=null){
            field50F = (Field50F) tag50.asField();
        }
        Map<String, Object> dbtrMaps = null;
        if (ntfctnMaps.containsKey("dbtr")) {
            dbtrMaps = (Map<String, Object>) ntfctnMaps.get("dbtr");
        } else {
            dbtrMaps = new HashMap<>();
            ntfctnMaps.put("dbtr",dbtrMaps);
        }
        Map<String, Object> ptyMaps = null;
        if (dbtrMaps.containsKey("pty")) {
            ptyMaps = (Map<String, Object>) dbtrMaps.get("pty");
        } else {
            ptyMaps = new HashMap<>();
        }
        if(field50!=null){
            String nameAddress = field50.getNameAndAddress();
            mt_to_mxPartyNameAndAddress(nameAddress, ptyMaps);
        }
        if(field50C!=null){
            String bicCode = field50C.getBIC();
            mt_to_mxAnyBIC(bicCode, ptyMaps);
        }
        if(field50F!=null){
            String partyIdentifier = field50F.getPartyIdentifier();
            String nameAddress = "";
            List<String> lines = field50F.getLines();
            for (int i=0; i<lines.size(); i++) {
                if (i == 0) {
                    continue;
                }
                if (i == lines.size()-1) {
                    nameAddress += lines.get(i);
                } else {
                    nameAddress += lines.get(i) + Mx2MtConstants.NEW_LINE;
                }
            }
            //mt_to_mxPartyNameAndStructuredAddress(nameAddress,ptyMaps);
            mt_to_mxFATFNameAndAddress(partyIdentifier, nameAddress, ptyMaps);
            if(ptyMaps.size()>0){
                dbtrMaps.put("pty",ptyMaps);
            }
        }
    }
}
