package com.brilliance.swift.mt2mx.camt057001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt057001.AbstractMt2MxCamt057001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field52A;
import com.prowidesoftware.swift.model.field.Field52D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;
//指示行
public class Camt057001Parse52Field extends AbstractMt2MxCamt057001ParseField {

    private static final String NAME_A = "52A";

    private static final String NAME_D = "52D";

    @Override
    public void parseField() throws SwiftException {
        Field52A field52A = null;
        Field52D field52D = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
        if (tag != null) {
            field52A = (Field52A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_D);
        if (tag != null) {
            field52D = (Field52D)tag.asField();
        }
        Map<String, Object> dbtrAgtMaps = null;
        if (ntfctnMaps.containsKey("dbtrAgt")) {
            dbtrAgtMaps = (Map<String, Object>) ntfctnMaps.get("dbtrAgt");
        } else {
            dbtrAgtMaps = new HashMap<>();
        }
        String account = "";
        if (field52A != null) {
            String bicCode = field52A.getBIC();
            mt_to_mxBICFI(bicCode, dbtrAgtMaps);
        }
        if (field52D != null) {
            String nameAddress = field52D.getNameAndAddress();
            mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(nameAddress, dbtrAgtMaps);
        }
        if (dbtrAgtMaps.size() > 0) {
            ntfctnMaps.put("dbtrAgt", dbtrAgtMaps);
        }
    }
}
