package com.brilliance.swift.mt2mx.camt057001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt057001.AbstractMt2MxCamt057001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field56A;
import com.prowidesoftware.swift.model.field.Field56D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;
//中间行
public class Camt057001Parse56Field extends AbstractMt2MxCamt057001ParseField {

    private static final String NAME_A = "56A";

    private static final String NAME_D = "56D";

    @Override
    public void parseField() throws SwiftException {
        Field56A field56A = null;
        Field56D field56D = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
        if (tag != null) {
            field56A = (Field56A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_D);
        if (tag != null) {
            field56D = (Field56D)tag.asField();
        }
        Map<String, Object> intrmyAgtMaps = null;
        if (ntfctnMaps.containsKey("intrmyAgt")) {
            intrmyAgtMaps = (Map<String, Object>) ntfctnMaps.get("intrmyAgt");
        } else {
            intrmyAgtMaps = new HashMap<>();
        }
        if(field56A!=null){
            String bicCode = field56A.getBIC();
            mt_to_mxBICFI(bicCode, intrmyAgtMaps);
        }
        if (field56D != null) {
            String nameAddress = field56D.getNameAndAddress();
            mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(nameAddress, intrmyAgtMaps);
        }
        if(intrmyAgtMaps.size()>0){
            ntfctnMaps.put("intrmyAgt",intrmyAgtMaps);
        }
    }
}
