package com.brilliance.swift.mt2mx.camt060001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt060001.impl.*;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt060001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        jsonMaps.put("identifier", "camt.060.001.05");
        Map<String, Object> appHdrMaps = (Map<String, Object>)jsonMaps.get("appHdr");
        appHdrMaps.put("msgDefIdr", "camt.060.001.05");
        appHdrMaps.put("bizSvc", "swift.cbprplus.02");

        Map<String, Object> acctRptgReqMaps = new HashMap<>();
        jsonMaps.put("acctRptgReq", acctRptgReqMaps);
        Map<String, Object> grpHdrMaps = new HashMap<>();
        acctRptgReqMaps.put("grpHdr", grpHdrMaps);
        grpHdrMaps.put("creDtTm", getCreateDateStr());

        JSONArray rptgReqJsonArray = new JSONArray();
        acctRptgReqMaps.put("rptgReq", rptgReqJsonArray);
    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<>();
        list.add(new Camt060001Parse20Field());
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag[] tags = abstractMT.getSwiftMessage().getBlock4().getTagsByName("12");
        if (tags != null && tags.length > 0) {
            for (int i=0; i<tags.length; i++) {
                list.add(new Camt060001Parse12Field(i));
                list.add(new Camt060001Parse25Field(i));
                list.add(new Camt060001Parse34FField(i));
            }
        }
        return list;
    }
}
