package com.brilliance.swift.mt2mx.camt060001.impl;

import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.camt060001.AbstractMt2MxCamt060001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Camt060001Parse25Field extends AbstractMt2MxCamt060001ParseField {

    private static final String NAME = "25";

    private int index = -1; //存在多个域循环, 表示xml节点的下标.

    public Camt060001Parse25Field(int index) {
        this.index = index;
    }

    @Override
    public void parseField() {
        List<Tag> tags = list.get(index);
        if (tags != null && tags.size() > 0) {
            Tag tag = null;
            for (int i=0; i<tags.size(); i++) {
                if (NAME.equals(tags.get(i).getName())) {
                    tag = tags.get(i);
                    break;
                }
            }
            if (tag != null) {
                Map<String, Object> rptgReqMaps = null;
                if (rptgReqJsonArray.size() == (index+1)) {
                    rptgReqMaps = (Map<String, Object>)rptgReqJsonArray.get(index);
                } else {
                    rptgReqMaps = new HashMap<>();
                    rptgReqJsonArray.add(rptgReqMaps);
                }
                Map<String, Object> acctMaps = null;
                if (rptgReqMaps.containsKey("acct")) {
                    acctMaps = (Map<String, Object>)rptgReqMaps.get("acct");
                } else {
                    acctMaps = new HashMap<>();
                    rptgReqMaps.put("acct", acctMaps);
                }
                mt_to_mxAccount35(tag.getValue(), acctMaps,"AcctRptgReq/RptgReq/Acct/Id/Othr/Id");

                String sendBic = (String) context.get(Mt2MxContextIdentifier.MT_SEND_BIC, true);
                if (StringUtil.isNotEmpty(sendBic)) {
                    Map<String, Object> acctOwnrMaps = new HashMap<>();
                    rptgReqMaps.put("acctOwnr", acctOwnrMaps);
                    Map<String, Object> agtMaps = new HashMap<>();
                    acctOwnrMaps.put("agt", agtMaps);
                    mt_to_mxBICFI(sendBic, agtMaps);
                }
            }
        }
    }
}
