package com.brilliance.swift.mt2mx.camt060001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.mt2mx.camt060001.AbstractMt2MxCamt060001ParseField;
import com.brilliance.swift.vo.common.CdtDbtCode;
import com.brilliance.swift.vo.common.EntryStatusCode;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field34F;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Camt060001Parse34FField extends AbstractMt2MxCamt060001ParseField {

    private static final String NAME = "34F";

    private int index = -1; //存在多个域循环, 表示xml节点的下标.

    public Camt060001Parse34FField(int index) {
        this.index = index;
    }

    @Override
    public void parseField() {
        List<Tag> tags = list.get(index);
        if (tags != null && tags.size() > 0) {
            List<Tag> tag34List = new ArrayList<>();
            for (int i=0; i<tags.size(); i++) {
                if (NAME.equals(tags.get(i).getName())) {
                    tag34List.add(tags.get(i));
                }
            }
            if (tag34List.size() > 0) {
                Map<String, Object> rptgReqMaps = null;
                if (rptgReqJsonArray.size() == (index+1)) {
                    rptgReqMaps = (Map<String, Object>)rptgReqJsonArray.get(index);
                } else {
                    rptgReqMaps = new HashMap<>();
                    rptgReqJsonArray.add(rptgReqMaps);
                }
                Map<String, Object> reqdTxTpMaps = null;
                if (rptgReqMaps.containsKey("reqdTxTp")) {
                    reqdTxTpMaps = (Map<String, Object>)rptgReqMaps.get("reqdTxTp");
                } else {
                    reqdTxTpMaps = new HashMap<>();
                    rptgReqMaps.put("reqdTxTp", reqdTxTpMaps);
                }
                //设置 Status节点
                Map<String, Object> stsMaps = null;
                if (reqdTxTpMaps.containsKey("sts")) {
                    stsMaps = (Map<String, Object>)reqdTxTpMaps.get("sts");
                } else {
                    stsMaps = new HashMap<>();
                    reqdTxTpMaps.put("sts", stsMaps);
                }
                stsMaps.put("cd", EntryStatusCode.INFO.value());
                BigDecimal crAmt = BigDecimal.ZERO;
                BigDecimal drAmt = BigDecimal.ZERO;
                JSONArray flrLmtJsonArray = null;
                if (reqdTxTpMaps.containsKey("flrLmt")) {
                    flrLmtJsonArray = (JSONArray)reqdTxTpMaps.get("flrLmt");
                } else {
                    flrLmtJsonArray = new JSONArray();
                    reqdTxTpMaps.put("flrLmt", flrLmtJsonArray);
                }
                for (Tag tag : tag34List) {
                    Map<String, Object> flrLmtMaps = new HashMap<>();
                    Field34F field34 = (Field34F)tag.asField();
                    if ("C".equals(field34.getDCMark())) {
                        crAmt = crAmt.add(field34.amount());
                        flrLmtMaps.put("cdtDbtInd", "CRED");
                    } else {
                        drAmt = drAmt.add(field34.amount());
                        flrLmtMaps.put("cdtDbtInd", "DEBT");
                    }
                    Map<String, Object> amtMaps = new HashMap<>();
                    amtMaps.put("ccy", field34.getCurrency());
                    amtMaps.put("value", field34.amount());
                    flrLmtMaps.put("amt", amtMaps);
                    flrLmtJsonArray.add(flrLmtMaps);
                }
                if (crAmt.compareTo(drAmt) > -1) {
                    reqdTxTpMaps.put("cdtDbtInd", CdtDbtCode.CRDT.value());
                } else {
                    reqdTxTpMaps.put("cdtDbtInd", CdtDbtCode.DBIT.value());
                }
            }
        }
    }
}
