package com.brilliance.swift.mt2mx.pacs002001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.pacs002001.impl.Pacs002001Parse20Field;
import com.brilliance.swift.mt2mx.pacs002001.impl.Pacs002001Parse21Field;
import com.brilliance.swift.mt2mx.pacs002001.impl.Pacs002001Parse72Field;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxPacs002001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        jsonMaps.put("identifier", "pacs.002.001.10");
        Map<String, Object> appHdrMaps = (Map<String, Object>)jsonMaps.get("appHdr");
        appHdrMaps.put("msgDefIdr", "pacs.002.001.10");
        appHdrMaps.put("bizSvc", "swift.cbprplus.02");
        AbstractMT abstractMT = context.get(AbstractMT.class);

        //初始化转换和不需要BLOCK4的转换
        Map<String, Object> fiToFIPmtStsRptMaps = new HashMap<>();
        jsonMaps.put("fiToFIPmtStsRpt", fiToFIPmtStsRptMaps);
        Map<String, Object> grpHdrMaps = new HashMap<>();
        fiToFIPmtStsRptMaps.put("grpHdr", grpHdrMaps);
        grpHdrMaps.put("creDtTm", getCreateDateStr());

        Map<String, Object> txInfAndStsMaps = new HashMap<>();
        JSONArray txInfAndStsJsonArray = new JSONArray();
        txInfAndStsJsonArray.add(txInfAndStsMaps);
        fiToFIPmtStsRptMaps.put("txInfAndSts", txInfAndStsJsonArray);
        //设置 UETR
        String uetr = abstractMT.getSwiftMessage().getUETR();
        if (StringUtil.isNotEmpty(uetr)) {
            txInfAndStsMaps.put("orgnlUETR", uetr);
        }
        //设置InstructingAgent InstructedAgent 取值从sendbic receivebic
        String sendBic = (String) context.get(Mt2MxContextIdentifier.MT_SEND_BIC, true);
        if (StringUtil.isNotEmpty(sendBic)) {
            Map<String, Object> instgAgtMaps = new HashMap<>();
            txInfAndStsMaps.put("instgAgt", instgAgtMaps);
            mt_to_mxBICFI(sendBic, instgAgtMaps);
        }
        String receiverBic = (String) context.get(Mt2MxContextIdentifier.MT_RECEIVE_BIC, true);
        if (StringUtil.isNotEmpty(receiverBic)) {
            Map<String, Object> instdAgtMaps = new HashMap<>();
            txInfAndStsMaps.put("instdAgt", instdAgtMaps);
            mt_to_mxBICFI(receiverBic, instdAgtMaps);
        }
        //设置原始消息类型
        Map<String, Object> orgnlGrpInfMaps = new HashMap<>();
        String messageType = "MT" + abstractMT.getMessageType();
        if (abstractMT.getSwiftMessage().isCOV()) {
            messageType += " COVE";
        }
        orgnlGrpInfMaps.put("orgnlMsgNmId", messageType);
        txInfAndStsMaps.put("orgnlGrpInf", orgnlGrpInfMaps);
    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<>();
        list.add(new Pacs002001Parse20Field());
        list.add(new Pacs002001Parse21Field());
        list.add(new Pacs002001Parse72Field());
        return list;
    }
}
