package com.brilliance.swift.mt2mx.pacs002001.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.pacs002001.AbstractMt2MxPacs002001ParseField;
import com.brilliance.swift.vo.common.PaymentTransactionStatusCode;
import com.prowidesoftware.swift.model.SwiftTagListBlock;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs002001Parse72Field extends AbstractMt2MxPacs002001ParseField {

    @Override
    public void parseField() {
        Tag tag72 = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        boolean isCov = abstractMT.getSwiftMessage().isCOV();
        if (isCov) {
            SwiftTagListBlock swiftTagListBlock = abstractMT.getSequence("A");
            if (swiftTagListBlock != null) {
                tag72 = swiftTagListBlock.getTagByName("72");
            }
        } else {
            tag72 = abstractMT.getSwiftMessage().getBlock4().getTagByName("72");
        }
        if (tag72 != null) {
            txInfAndStsMaps.put("txSts", PaymentTransactionStatusCode.RJCT.value());
            String mt72 = tag72.getValue();
            String[] mt72s = mt72.split(Mx2MtConstants.NEW_LINE);
            String mRef = "";
            String tRef = "";
            for (String value : mt72s) {
                if (value.startsWith("/MREF/")) {
                    mRef = value.substring(6);
                }
                if (value.startsWith("/TREF/")) {
                    tRef = value.substring(6);
                }
            }
            Map<String, Object> orgnlGrpInfMaps = null;
            if (txInfAndStsMaps.containsKey("orgnlGrpInf")) {
                orgnlGrpInfMaps = (Map<String, Object>)txInfAndStsMaps.get("orgnlGrpInf");
            } else {
                orgnlGrpInfMaps = new HashMap<>();
                txInfAndStsMaps.put("orgnlGrpInf", orgnlGrpInfMaps);
            }
            if (mRef.length() > 0) {
                orgnlGrpInfMaps.put("orgnlMsgId", mRef);
                txInfAndStsMaps.put("orgnlInstrId", mRef);
            } else {
                orgnlGrpInfMaps.put("orgnlMsgId", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                txInfAndStsMaps.put("orgnlInstrId", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
            }
            if ("103".equals(abstractMT.getMessageType())) {
                if (tRef.length() > 0) {
                    txInfAndStsMaps.put("orgnlEndToEndId", tRef);
                } else {
                    txInfAndStsMaps.put("orgnlEndToEndId", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                }
            }
            mt_to_mxReject72(mt72, txInfAndStsMaps);
        }
    }
}
