package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

public class Pacs004001Parse32AField extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "32A";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag != null) {
                Field32A field32A = (Field32A)tag.asField();
                Date date = DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                txInfMaps.put("intrBkSttlmDt", dateStr);
                Map<String, Object> rtrdIntrBkSttlmAmtMaps = new HashMap<>();
                rtrdIntrBkSttlmAmtMaps.put("value", field32A.amount());
                rtrdIntrBkSttlmAmtMaps.put("ccy", field32A.getCurrency());
                txInfMaps.put("rtrdIntrBkSttlmAmt", rtrdIntrBkSttlmAmtMaps);
            }
        } catch (ParseException e) {
            throw  new SwiftException(e.getMessage());
        }
    }
}
