package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field33B;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs004001Parse33BField extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "33B";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag != null) {
            Field33B field33B = (Field33B)tag.asField();
            Map<String, Object> rtrdInstdAmtMaps = new HashMap<>();
            rtrdInstdAmtMaps.put("value", field33B.amount());
            rtrdInstdAmtMaps.put("ccy", field33B.getCurrency());
            txInfMaps.put("rtrdInstdAmt", rtrdInstdAmtMaps);
        }
    }
}
