package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.vo.VoSettlementMethodHelper;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field55A;
import com.prowidesoftware.swift.model.field.Field55B;
import com.prowidesoftware.swift.model.field.Field55D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

/**
 * 如果55存在，那么53 54必须同时存在
 */
public class Pacs004001Parse55Field extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME_A = "55A";

    private static final String NAME_B = "55B";

    private static final String NAME_D = "55D";

    @Override
    public void parseField() throws SwiftException {
        VoSettlementMethodHelper setlMtdHelper = context.get(VoSettlementMethodHelper.class);
        if (setlMtdHelper.isTranslate55Flag()) {
            Field55A field55A = null;
            Field55B field55B = null;
            Field55D field55D = null;
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
            if (tag != null) {
                field55A = (Field55A)tag.asField();
            }
            tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_B);
            if (tag != null) {
                field55B = (Field55B)tag.asField();
            }
            tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_D);
            if (tag != null) {
                field55D = (Field55D)tag.asField();
            }
            if (field55A != null || field55B != null || field55D != null) {
                buildSTErrorInfo(ERROR.T20008, "PmtRtr/GrpHdr/SttlmInf/ThrdRmbrsmntAgt", null);
            }
        }
    }
}
