package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field59;
import com.prowidesoftware.swift.model.field.Field59A;
import com.prowidesoftware.swift.model.field.Field59F;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Pacs004001Parse59Field extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "59";

    private static final String NAME_A = "59A";

    private static final String NAME_F = "59F";

    @Override
    public void parseField() throws SwiftException {
        Field59 field59 = null;
        Field59A field59A = null;
        Field59F field59F = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag != null) {
            field59 = (Field59)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
        if (tag != null) {
            field59A = (Field59A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_F);
        if (tag != null) {
            field59F = (Field59F)tag.asField();
        }
        Map<String, Object> rtrChainMaps = null;
        if (txInfMaps.containsKey("rtrChain")) {
            rtrChainMaps = (Map<String, Object>) txInfMaps.get("rtrChain");
        } else {
            rtrChainMaps = new HashMap<>();
        }
        Map<String, Object> cdtrMaps = null;
        if (rtrChainMaps.containsKey("cdtr")) {
            cdtrMaps = (Map<String, Object>) rtrChainMaps.get("cdtr");
        } else {
            cdtrMaps = new HashMap<>();
        }
        Map<String, Object> ptyMaps = null;
        if (cdtrMaps.containsKey("pty")) {
            ptyMaps = (Map<String, Object>) cdtrMaps.get("pty");
        } else {
            ptyMaps = new HashMap<>();
        }
        String account = "";
        if (field59A != null) {
            String bicCode = field59A.getBIC();
            if (StringUtil.isNotEmpty(field59A.getComponent1())) {
                account += "/" + field59A.getComponent1();
            }
            mt_to_mxAnyBIC(bicCode, ptyMaps);
            if (StringUtil.isEmpty(account)) {
                buildDefaultValue(ptyMaps);
            }
        }
        if (field59F != null) {
            if (StringUtil.isNotEmpty(field59F.getComponent1())) {
                account += "/" + field59F.getComponent1();
            }
            if (StringUtil.isEmpty(account)) {
                buildDefaultValue(ptyMaps);
            }
            String nameAddress = "";
            List<String> lines = field59F.getLines();
            for (int i=0; i<lines.size(); i++) {
                if (i == 0 && StringUtil.isNotEmpty(account)) {
                    continue;
                }
                if (i == lines.size()-1) {
                    nameAddress += lines.get(i);
                } else {
                    nameAddress += lines.get(i) + Mx2MtConstants.NEW_LINE;
                }
            }
            mt_to_mxPartyNameAndStructuredAddress(nameAddress, ptyMaps);
        }
        if (field59 != null) {
            if (StringUtil.isNotEmpty(field59.getComponent1())) {
                account += "/" + field59.getComponent1();
            }
            String nameAddress1 = field59.getNameAndAddressLine1();
            if (("/"+Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE).equals(account) && StringUtil.isNotEmpty(nameAddress1) && nameAddress1.startsWith("//")) {
                Map<String, Object> agtMaps = null;
                if (cdtrMaps.containsKey("agt")) {
                    agtMaps = (Map<String, Object>) cdtrMaps.get("agt");
                } else {
                    agtMaps = new HashMap<>();
                    cdtrMaps.put("agt", agtMaps);
                }
                Map<String, Object> finInstnIdMaps = null;
                if (agtMaps.containsKey("finInstnId")) {
                    finInstnIdMaps = (Map<String, Object>)agtMaps.get("finInstnId");
                } else {
                    finInstnIdMaps = new HashMap<>();
                    agtMaps.put("finInstnId", finInstnIdMaps);
                }
                if (isMTClearingSystemCodeInList(nameAddress1)) {
                    Map<String, Object> clrSysMmbIdMaps = null;
                    if (finInstnIdMaps.containsKey("clrSysMmbId")) {
                        clrSysMmbIdMaps = (Map<String, Object>)finInstnIdMaps.get("clrSysMmbId");
                    } else {
                        clrSysMmbIdMaps = new HashMap<>();
                        finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                    }
                    mt_to_mxClearingIdentifier(nameAddress1, clrSysMmbIdMaps);
                } else {
                    String nameAddress = field59.getNameAndAddress(Mx2MtConstants.NEW_LINE);
                    mt_to_mxPartyNameAndAddress(nameAddress, finInstnIdMaps);
                    buildSTErrorInfo(ERROR.T20127, "PmtRtr/TxInf/RtrChain/Cdtr/Agt/FinInstnId", null);
                }
            } else {
                String nameAddress = field59.getNameAndAddress(Mx2MtConstants.NEW_LINE);
                mt_to_mxPartyNameAndAddress(nameAddress, ptyMaps);
                if (StringUtil.isEmpty(account)) {
                    buildDefaultValue(ptyMaps);
                }
            }
        }
        if (ptyMaps.size() > 0) {
            cdtrMaps.put("pty", ptyMaps);
        }
        if (cdtrMaps.size() > 0) {
            rtrChainMaps.put("cdtr", cdtrMaps);
        }
        if (rtrChainMaps.size() > 0) {
            txInfMaps.put("rtrChain", rtrChainMaps);
        }
    }
    /**
     * IF 59A/Account 59/Account IsAbsent
     * THEN Copy "NOTPROVIDED" to Debtor/Id/OrgID/Other/ID
     * and "TXID" to SchemeName/Code
     * @param dbtrMaps
     */
    private void buildDefaultValue(Map<String, Object> dbtrMaps) {
        Map<String, Object> idMaps = null;
        if (dbtrMaps.containsKey("id")) {
            idMaps = (Map<String, Object>)dbtrMaps.get("id");
        } else {
            idMaps = new HashMap<>();
            dbtrMaps.put("id", idMaps);
        }
        Map<String, Object> idOrgMaps = null;
        if (idMaps.containsKey("orgId")) {
            idOrgMaps = (Map<String, Object>)idMaps.get("orgId");
        } else {
            idOrgMaps = new HashMap<>();
            idMaps.put("orgId", idOrgMaps);
        }
        JSONArray othrJsonArray = null;
        if (idOrgMaps.containsKey("othr")) {
            othrJsonArray = (JSONArray) idOrgMaps.get("othr");
        } else {
            othrJsonArray = new JSONArray();
            idOrgMaps.put("othr", othrJsonArray);
        }
        Map<String, Object> othrMaps = new HashMap<>();
        othrJsonArray.add(othrMaps);
        othrMaps.put("id", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
    }
}
