package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field70;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs004001Parse70Field extends AbstractMt2MxPacs004001ParseField {

    private static final String NAME = "70";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag != null) {
            Field70 field70 = (Field70)tag.asField();
            String mt70 = field70.getValue();
            Map<String, Object> rtrChainMaps = null;
            if (txInfMaps.containsKey("rtrChain")) {
                rtrChainMaps = (Map<String, Object>) txInfMaps.get("rtrChain");
            } else {
                rtrChainMaps = new HashMap<>();
            }
            Map<String, Object> ultmtDbtrMaps = null;
            if (rtrChainMaps.containsKey("ultmtDbtr")) {
                ultmtDbtrMaps = (Map<String, Object>)rtrChainMaps.get("ultmtDbtr");
            } else {
                ultmtDbtrMaps = new HashMap<>();
            }
            Map<String, Object> ptyMaps = null;
            if (ultmtDbtrMaps.containsKey("pty")) {
                ptyMaps = (Map<String, Object>)ultmtDbtrMaps.get("pty");
            } else {
                ptyMaps = new HashMap<>();
            }
            mt_to_mxUltimateParty(mt70, ptyMaps,"/ULTD/");
            if (ptyMaps.size() > 0) {
                ultmtDbtrMaps.put("pty", ptyMaps);
            }
            if (ultmtDbtrMaps.size() > 0) {
                rtrChainMaps.put("ultmtDbtr", ultmtDbtrMaps);
            }

            Map<String, Object> ultmtCdtrMaps = null;
            if (rtrChainMaps.containsKey("ultmtCdtr")) {
                ultmtCdtrMaps = (Map<String, Object>)rtrChainMaps.get("ultmtCdtr");
            } else {
                ultmtCdtrMaps = new HashMap<>();
            }
            Map<String, Object> cdtrPtyMaps = null;
            if (ultmtCdtrMaps.containsKey("pty")) {
                cdtrPtyMaps = (Map<String, Object>)ultmtCdtrMaps.get("pty");
            } else {
                cdtrPtyMaps = new HashMap<>();
            }
            mt_to_mxUltimateParty(mt70, cdtrPtyMaps,"/ULTB/");
            if (cdtrPtyMaps.size() > 0) {
                ultmtCdtrMaps.put("pty", cdtrPtyMaps);
            }
            if (ultmtCdtrMaps.size() > 0) {
                rtrChainMaps.put("ultmtCdtr", ultmtCdtrMaps);
            }
            if (rtrChainMaps.size() > 0) {
                txInfMaps.put("rtrChain", rtrChainMaps);
            }
        }
    }
}
