package com.brilliance.swift.mt2mx.pacs004001.mt103retn;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.pacs004001.AbstractMt2MxPacs004001ParseField;
import com.brilliance.swift.mt2mx.setlmtd.SettlementMethodAnalyzerFactory;
import com.brilliance.swift.vo.VoSettlementMethodHelper;

import java.util.HashMap;
import java.util.Map;

/**
 * Group Header -> Settlement Information -> Settlement Method
 */
public class Pacs004001ParseSetlMtdField extends AbstractMt2MxPacs004001ParseField {
    @Override
    public void parseField() throws SwiftException {
        context.set(Mt2MxContextIdentifier.MT_TO_MX_RETURN_FLAG, Mx2MtConstants.YES);
        VoSettlementMethodHelper setlMtdHelper = SettlementMethodAnalyzerFactory.find(context).analyse();
        String settlementMethod = setlMtdHelper.getSettlementMethod();
        Map<String, Object> sttlmInfMaps = null;
        if (grpHdrMaps.containsKey("sttlmInf")) {
            sttlmInfMaps = (Map<String, Object>) grpHdrMaps.get("sttlmInf");
        } else {
            sttlmInfMaps = new HashMap<>();
            grpHdrMaps.put("sttlmInf", sttlmInfMaps);
        }
        sttlmInfMaps.put("sttlmMtd", settlementMethod);
        context.set(setlMtdHelper);
    }
}
