package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field13C;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs00801Parse13CField extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME = "13C";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag[] tags = abstractMT.getSwiftMessage().getBlock4().getTagsByName(NAME);
        if (tags != null && tags.length > 0) {
            Map<String,Object> sttlmTmIndctnMaps = null;
            if (cdtTrfTxInfMaps.containsKey("sttlmTmIndctn")) {
                sttlmTmIndctnMaps = (Map<String,Object>)cdtTrfTxInfMaps.get("sttlmTmIndctn");
            } else {
                sttlmTmIndctnMaps = new HashMap<>();
                cdtTrfTxInfMaps.put("sttlmTmIndctn", sttlmTmIndctnMaps);
            }
            Map<String,Object> sttlmTmReqMaps = null;
            if (cdtTrfTxInfMaps.containsKey("sttlmTmReq")) {
                sttlmTmReqMaps = (Map<String,Object>)cdtTrfTxInfMaps.get("sttlmTmReq");
            } else {
                sttlmTmReqMaps = new HashMap<>();
                cdtTrfTxInfMaps.put("sttlmTmReq", sttlmTmReqMaps);
            }
            for (int i=0; i<tags.length; i++) {
                Field13C field13C = (Field13C)tags[i].asField();
                String dateTimeStr = "0001-01-01T"
                        + field13C.getTime().substring(0,2)
                        + ":" + field13C.getTime().substring(2,4)
                        + ":00"
                        + field13C.getSign()
                        + field13C.getOffset().substring(0, 2)
                        + ":" + field13C.getOffset().substring(2, 4);
                String timeStr = field13C.getTime().substring(0,2)
                        + ":" + field13C.getTime().substring(2,4)
                        + ":00"
                        + field13C.getSign()
                        + field13C.getOffset().substring(0, 2)
                        + ":" + field13C.getOffset().substring(2, 4);
                if ("SNDTIME".equals(field13C.getCode())) {
                    sttlmTmIndctnMaps.put("dbtDtTm", dateTimeStr);
                } else if ("RNCTIME".equals(field13C.getCode())) {
                    sttlmTmIndctnMaps.put("cdtDtTm", dateTimeStr);
                } else if ("CLSTIME".equals(field13C.getCode())) {
                    sttlmTmReqMaps.put("clsTm", timeStr);
                } else if ("TILTIME".equals(field13C.getCode())) {
                    sttlmTmReqMaps.put("tillTm", timeStr);
                } else if ("FROTIME".equals(field13C.getCode())) {
                    sttlmTmReqMaps.put("frTm", timeStr);
                } else if ("REJTIME".equals(field13C.getCode())) {
                    sttlmTmReqMaps.put("rjctTm", timeStr);
                }
            }
        }
    }
}
