package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field77B;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Pacs00801Parse77BField extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME = "77B";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag != null) {
            String creditorCountryCode = "";
            String debtorCountryCode = "";
            Field77B field77B = (Field77B)tag.asField();
            List<String> lines = field77B.getLines();
            JSONArray rgltryRptgJsonArray = null;
            if (cdtTrfTxInfMaps.containsKey("rgltryRptg")) {
                rgltryRptgJsonArray = (JSONArray)cdtTrfTxInfMaps.get("rgltryRptg");
            } else {
                rgltryRptgJsonArray = new JSONArray();
                cdtTrfTxInfMaps.put("rgltryRptg", rgltryRptgJsonArray);
            }
            Map<String, Object> rgltryRptgMaps = new HashMap<>();
            rgltryRptgJsonArray.add(rgltryRptgMaps);
            JSONArray dtlsJsonArray = null;
            if (rgltryRptgMaps.containsKey("dtls")) {
                dtlsJsonArray = (JSONArray) rgltryRptgMaps.get("dtls");
            } else {
                dtlsJsonArray = new JSONArray();
                rgltryRptgMaps.put("dtls", dtlsJsonArray);
            }
            Map<String, Object> dtlsMaps = new HashMap<>();
            dtlsJsonArray.add(dtlsMaps);
            dtlsMaps.put("inf", lines);
            for (int i=0; i<lines.size();i++) {
                String line = lines.get(i);
                String regex = "/BENEFRES/([A-Z]{2})";
                Pattern p = Pattern.compile(regex);
                Matcher m = p.matcher(line);
                if (m.find()) {
                    creditorCountryCode = m.group(1);
                    break;
                }
            }
            if (StringUtil.isNotEmpty(creditorCountryCode)) {
                Map<String, Object> cdtrMaps = null;
                if (cdtTrfTxInfMaps.containsKey("cdtr")) {
                    cdtrMaps = (Map<String, Object>) cdtTrfTxInfMaps.get("cdtr");
                } else {
                    cdtrMaps = new HashMap<>();
                }
                cdtrMaps.put("ctryOfRes", creditorCountryCode);
            }
            for (int i=0; i<lines.size();i++) {
                String line = lines.get(i);
                String regex = "/ORDERRES/([A-Z]{2})";
                Pattern p = Pattern.compile(regex);
                Matcher m = p.matcher(line);
                if (m.find()) {
                    debtorCountryCode = m.group(1);
                    break;
                }
            }
            if (StringUtil.isNotEmpty(debtorCountryCode)) {
                Map<String, Object> dbtrMaps = null;
                if (cdtTrfTxInfMaps.containsKey("dbtr")) {
                    dbtrMaps = (Map<String, Object>) cdtTrfTxInfMaps.get("dbtr");
                } else {
                    dbtrMaps = new HashMap<>();
                }
                dbtrMaps.put("ctryOfRes", debtorCountryCode);
            }
        }
    }
}
