package com.brilliance.swift.mt2mx.pacs009001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.mt2mx.AbstractMt2MxParseField;
import com.prowidesoftware.swift.model.SwiftTagListBlock;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.Map;

public abstract class AbstractMt2MxPacs009001ParseField extends AbstractMt2MxParseField {

    protected Map<String, Object> appHdrMaps = null;

    protected Map<String, Object> grpHdrMaps = null;

    protected Map<String, Object> cdtTrfTxInfMaps = null;

    protected Map<String, Object> undrlygCstmrCdtTrfMaps = null;

    @Override
    public void initJsonMaps() {
        super.initJsonMaps();
        appHdrMaps = (Map<String, Object>)jsonMaps.get("appHdr");
        Map<String, Object> fiCdtTrfMaps = (Map<String, Object>)jsonMaps.get("fiCdtTrf");
        grpHdrMaps = (Map<String, Object>)fiCdtTrfMaps.get("grpHdr");
        JSONArray cdtTrfTxInfJsonArray = (JSONArray) fiCdtTrfMaps.get("cdtTrfTxInf");
        cdtTrfTxInfMaps = (Map<String, Object>)cdtTrfTxInfJsonArray.get(0);
        undrlygCstmrCdtTrfMaps = (Map<String, Object>)cdtTrfTxInfMaps.get("undrlygCstmrCdtTrf");
    }

    /**
     * 用于获取报文tag
     * 解决mt报文中SequenceA，SequenceB都存在相同的tag
     * @param tagName
     * @param sequence
     * @return
     */
    protected Tag getTagByName(String tagName, String sequence) {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        boolean isCov = abstractMT.getSwiftMessage().isCOV();
        if (isCov) {
            SwiftTagListBlock swiftTagListBlock = abstractMT.getSequence(sequence);
            if (swiftTagListBlock != null) {
                return swiftTagListBlock.getTagByName(tagName);
            }
        } else {
            return abstractMT.getSwiftMessage().getBlock4().getTagByName(tagName);
        }
        return null;
    }
}
