package com.brilliance.swift.mt2mx.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs009001.AbstractMt2MxPacs009001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs009001Parse20Field extends AbstractMt2MxPacs009001ParseField {

    private static final String NAME = "20";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag20 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag20 != null) {
            appHdrMaps.put("bizMsgIdr", tag20.getValue());
            grpHdrMaps.put("msgId", tag20.getValue());
            Map<String, Object> pmtIdMaps = null;
            if (cdtTrfTxInfMaps.containsKey("pmtId")) {
                pmtIdMaps = (Map<String, Object>) cdtTrfTxInfMaps.get("pmtId");
            } else {
                pmtIdMaps = new HashMap<>();
                cdtTrfTxInfMaps.put("pmtId", pmtIdMaps);
            }
            pmtIdMaps.put("instrId", tag20.getValue());
        }
    }
}
