package com.brilliance.swift.mt2mx.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs009001.AbstractMt2MxPacs009001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs009001Parse21Field extends AbstractMt2MxPacs009001ParseField {

    private static final String NAME = "21";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag21 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag21 != null) {
            Map<String, Object> pmtIdMaps = null;
            if (cdtTrfTxInfMaps.containsKey("pmtId")) {
                pmtIdMaps = (Map<String, Object>) cdtTrfTxInfMaps.get("pmtId");
            } else {
                pmtIdMaps = new HashMap<>();
                cdtTrfTxInfMaps.put("pmtId", pmtIdMaps);
            }
            pmtIdMaps.put("endToEndId", tag21.getValue());
        }
    }
}
