package com.brilliance.swift.mt2mx.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs009001.AbstractMt2MxPacs009001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field70;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs009001ParseSeqB70Field extends AbstractMt2MxPacs009001ParseField {

    private static final String NAME = "70";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        if (!abstractMT.getSwiftMessage().isCOV()) {
            return;
        }
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag != null) {
            Field70 field70 = (Field70)tag.asField();
            String mt70 = field70.getValue();
            Map<String, Object> rmtInfMaps = null;
            if (undrlygCstmrCdtTrfMaps.containsKey("rmtInf")) {
                rmtInfMaps = (Map<String, Object>) undrlygCstmrCdtTrfMaps.get("rmtInf");
            } else {
                rmtInfMaps = new HashMap<>();
            }
            mt_to_mxRemittanceInformation(mt70, rmtInfMaps);
            if (rmtInfMaps.size() > 0) {
                undrlygCstmrCdtTrfMaps.put("rmtInf", rmtInfMaps);
            }
        }
    }
}
