package com.brilliance.swift.mt2mx.setlmtd;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.Mt2MxContext;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.SwiftTranslationErrorInfo;
import com.brilliance.swift.vo.SwiftTranslationReport;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.List;

public abstract class AbstractSettlementMethodAnalyzer implements SettlementMethodAnalyzer{

    protected Mt2MxContext context;

    public Mt2MxContext getContext() {
        return context;
    }

    public AbstractSettlementMethodAnalyzer setContext(Mt2MxContext context) {
        this.context = context;
        return this;
    }

    protected Field field53;

    protected Field field54;

    protected String returnFlag;

    public Field getField53() {
        return field53;
    }

    public AbstractSettlementMethodAnalyzer setField53(Field field53) {
        this.field53 = field53;
        return this;
    }

    public Field getField54() {
        return field54;
    }

    public AbstractSettlementMethodAnalyzer setField54(Field field54) {
        this.field54 = field54;
        return this;
    }

    public String getReturnFlag() {
        return returnFlag;
    }

    public AbstractSettlementMethodAnalyzer setReturnFlag(String returnFlag) {
        this.returnFlag = returnFlag;
        return this;
    }

    /**
     * 封装报文转换详细报告
     * @param errorCode
     * @param location
     * @param originalValue
     * @return
     */
    protected void buildSTErrorInfo(String errorCode, String location, String originalValue) {
        SwiftTranslationReport str = context.get(SwiftTranslationReport.class);
        SwiftTranslationErrorInfo errorInfo = SwiftTransferUtil.getSwiftTranslationErrorInfoByErrorCode(errorCode);
        errorInfo.setLocation(location);
        errorInfo.setOriginalValue(originalValue);
        List<SwiftTranslationErrorInfo> errorInfos = str.getErrorInfos();
        boolean existFlag = false;
        for (int i=0; i<errorInfos.size(); i++) {
            if (SwiftTransferUtil.compareStErrorInfo(errorInfo, errorInfos.get(i))) {
                existFlag = true;
                break;
            }
        }
        if (!existFlag) {
            str.addErrorInfo(errorInfo);
            if ("FAILURE".equalsIgnoreCase(errorInfo.getErrorType())) {
                throw new SwiftException(location + Mx2MtConstants.NEW_LINE + "-" + errorInfo.getErrorType() + ":" + errorInfo.getDescription());
            }
        }
    }

    protected Boolean exist55a() {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName("55A");
        if (tag != null) {
            return true;
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName("55B");
        if (tag != null) {
            return true;
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName("55D");
        if (tag != null) {
            return true;
        }
        return false;
    }
}
