package com.brilliance.swift.mt2mx.setlmtd.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.setlmtd.AbstractSettlementMethodAnalyzer;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.VoSettlementMethodHelper;
import com.prowidesoftware.swift.model.field.Field53D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class Field53D54aAnalyzer extends AbstractSettlementMethodAnalyzer {
    @Override
    public VoSettlementMethodHelper analyse() {
        VoSettlementMethodHelper seltMtdHelper = new VoSettlementMethodHelper();
        Field53D field53D = (Field53D)field53;
        String account = "";
        if (StringUtil.isNotEmpty(field53D.getComponent1())) {
            account += "/" + field53D.getComponent1();
        }
        if (StringUtil.isNotEmpty(field53D.getComponent2())) {
            account += "/" + field53D.getComponent2();
        }
        if (SwiftTransferUtil.isAccount(account)) {
            if (account.startsWith("/C/")) {
                seltMtdHelper.setSettlementMethod("INGA");
            } else {
                seltMtdHelper.setSettlementMethod("INDA");
            }
            seltMtdHelper.setTranslateSetlAcctFlag(true);
            buildSTErrorInfo(ERROR.T20069, "Block4/:53D:", null);
            buildSTErrorInfo(ERROR.T20023, "Block4/:54a:", null);
            if (exist55a()) {
                buildSTErrorInfo(ERROR.T20008, "Block4/:55a:", null);
            }
        } else {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            if (abstractMT.getSwiftMessage().isCOV() || Mx2MtConstants.YES.equals(returnFlag)) {
                seltMtdHelper.setSettlementMethod("INDA");
                buildSTErrorInfo(ERROR.T20024, "Block4/:53D:", null);
                buildSTErrorInfo(ERROR.T20023, "Block4/:54a:", null);
            } else {
                seltMtdHelper.setSettlementMethod("COVE");
                seltMtdHelper.setTranslate53Flag(true);
                seltMtdHelper.setTranslate54Flag(true);
                seltMtdHelper.setTranslate55Flag(true);
            }
        }
        return seltMtdHelper;
    }
}
