package com.brilliance.swift.mt2mx.setlmtd.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.mt2mx.setlmtd.AbstractSettlementMethodAnalyzer;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.VoSettlementMethodHelper;
import com.prowidesoftware.swift.model.field.Field53B;

public class FieldOnly53BAnalyzer extends AbstractSettlementMethodAnalyzer {
    @Override
    public VoSettlementMethodHelper analyse() {
        VoSettlementMethodHelper seltMtdHelper = new VoSettlementMethodHelper();
        Field53B field53B = (Field53B)field53;
        String account = "";
        if (StringUtil.isNotEmpty(field53B.getComponent1())) {
            account += "/" + field53B.getComponent1();
        }
        if (StringUtil.isNotEmpty(field53B.getComponent2())) {
            account += "/" + field53B.getComponent2();
        }
        if (SwiftTransferUtil.isAccount(account)) {
            if (account.startsWith("/C/")) {
                seltMtdHelper.setSettlementMethod("INGA");
            } else {
                seltMtdHelper.setSettlementMethod("INDA");
            }
            seltMtdHelper.setTranslateSetlAcctFlag(true);
            if (StringUtil.isNotEmpty(field53B.getLocation())) {
                buildSTErrorInfo(ERROR.T20070, "Block4/:53B:", null);
            }
        } else {
            seltMtdHelper.setSettlementMethod("INDA");
            buildSTErrorInfo(ERROR.T20001, "Block4/:53B:", null);
        }
        return seltMtdHelper;
    }
}
