package com.brilliance.swift.mt2mx.setlmtd.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.setlmtd.AbstractSettlementMethodAnalyzer;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoSettlementMethodHelper;
import com.prowidesoftware.swift.model.field.Field54A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class FieldOnly54AAnalyzer extends AbstractSettlementMethodAnalyzer {
    @Override
    public VoSettlementMethodHelper analyse() {
        VoSettlementMethodHelper seltMtdHelper = new VoSettlementMethodHelper();
        Field54A field54A = (Field54A) field54;
        String bicCode = field54A.getBIC();
        String sendBic = (String) context.get(Mt2MxContextIdentifier.MT_SEND_BIC, true);
        String receiveBic = (String) context.get(Mt2MxContextIdentifier.MT_RECEIVE_BIC, true);
        if ((StringUtil.isNotEmpty(sendBic) && bicCode.substring(0, 8).equals(sendBic.substring(0, 8)))
                || (StringUtil.isNotEmpty(receiveBic) && bicCode.substring(0, 8).equals(receiveBic.substring(0, 8)))) {
            seltMtdHelper.setSettlementMethod("INDA");
            buildSTErrorInfo(ERROR.T20010, "Block4/:54A:", null);
        } else {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            if (abstractMT.getSwiftMessage().isCOV() || Mx2MtConstants.YES.equals(returnFlag)) {
                seltMtdHelper.setSettlementMethod("INDA");
                buildSTErrorInfo(ERROR.T20023, "Block4/:54A:", null);
            } else {
                seltMtdHelper.setSettlementMethod("COVE");
                seltMtdHelper.setTranslate54Flag(true);
            }
        }
        return seltMtdHelper;
    }
}
