package com.brilliance.swift.mx2element.camt029001;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2element.AbstractMx2ElementCreator;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.XmlUtil;
import com.brilliance.swift.vo.common.BalanceTypeCode;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.DocumentHelper;

import java.io.InputStream;
import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class Mx2ElementCamt029001Creator extends AbstractMx2ElementCreator {
    @Override
    public Map<String, Object> buildElement() {
        return super.buildElement();
    }

    /*
    //cretrPty=rsltnOfInvstgtn.cxlDtls.txInfAndSts.rslvdCase.cretr.pty[prefix:cretr,type:party]
    //cretrAgt=rsltnOfInvstgtn.cxlDtls.txInfAndSts.rslvdCase.cretr.agt[prefix:cretr,type:agent]
    @Override
    public Map<String, Object> buildElement() {
        //AbstractMX abstractMX = AbstractMX.parse(xmlStr);
        String messageType = abstractMX.getMxId().getBusinessProcess().name()
                + abstractMX.getMxId().getFunctionality()
                + abstractMX.getMxId().getVariant()
                + abstractMX.getMxId().getVersion();
        maps.put("messageType", messageType);
        String gsonStr = abstractMX.toJson();
        Map<String, Object> mxGsonMaps = JSON.parseObject(gsonStr);
        String fileName = "/template/"+messageType+".properties";
        InputStream resourceAsStream = AbstractMx2ElementCreator.class.getResourceAsStream(fileName);
        if (resourceAsStream == null) {
            int versionLength = abstractMX.getMxId().getVersion().length();
            fileName = "/template/"+messageType.substring(0, messageType.length()-versionLength)+".properties";
            resourceAsStream = AbstractMx2ElementCreator.class.getResourceAsStream(fileName);

        }
        List<String> properties = StringUtil.inputStreamToLines(resourceAsStream);
        if (properties.size() > 0) {
            for (String property : properties) {
                if (property.startsWith("#")) {
                    continue;//过滤注释
                }
                String[] strArr = property.split("=");
                if (strArr.length != 2) {
                    continue;//过滤掉不符合规则的配置
                }
                String key = strArr[0];
                String path = strArr[1];
                Object value = getXmlValue(mxGsonMaps, path);
                if (value != null) {
                    maps.put(key, value);
                }
            }
        }
        return maps;
    }
    protected Object getXmlValue(Map<String, Object> jsonMaps, String path) {
        Object value = null;
        if (path.indexOf("?") > 0) {
            String[] childPaths = path.split("\\?");
            for (String childPath : childPaths) {
                value = getXmlValue(jsonMaps, childPath);
                if (value != null) {
                    return value;
                }
            }
        }
        //获取数据类型，&分隔，默认是string
        String type = "string";
        if (path.indexOf("&") > -1) {
            type = path.substring(path.indexOf("&")+1);
            path = path.substring(0, path.indexOf("&"));
        }
        if(path.contains("[")&&path.contains("]")){
            String str = path.substring(path.indexOf("[")+1,path.indexOf("]"));
            String[] paths = path.split("\\.");
            String node = paths[paths.length-1].split("\\[")[0];
            String key1 = str.split(",")[0].split(":")[0];
            String value1 = str.split(",")[0].split(":")[1];
            String key2 = str.split(",")[1].split(":")[0];
            String value2= str.split(",")[1].split(":")[1];
            List<String> keyList = new ArrayList<>();
            List<String> valueList = new ArrayList<>();
            if(StringUtil.isNotEmpty(node)&&
                    StringUtil.isNotEmpty(key1) &&StringUtil.isNotEmpty(key2)
                    &&StringUtil.isNotEmpty(value1)&&StringUtil.isNotEmpty(value2)){
                String fileName = "/template/partyAndAgent.properties";
                InputStream resourceAsStream = AbstractMx2ElementCreator.class.getResourceAsStream(fileName);
                List<String> properties = StringUtil.inputStreamToLines(resourceAsStream);
                if (properties.size() > 0) {
                    for (String property : properties) {
                        if (property.startsWith("#")) {
                            continue;//过滤注释
                        }
                        String[] strArr = property.split("=");
                        if (strArr.length != 2) {
                            continue;//过滤掉不符合规则的配置
                        }
                        String str1 = strArr[0];
                        String str2 = "";
                        if(value2.equals("party")){
                            str2 = strArr[1].split("\\?")[0];
                        }else if(value2.equals("agent")){
                            str2 = strArr[1].split("\\?")[1];
                        }else {
                            return null;
                        }
                        if(StringUtil.isNotEmpty(str1)&&StringUtil.isNotEmpty(str2)){
                            if(node.equals(value1)&&"finInstnId.bicfi".equals(str2)){
                                keyList.add(value1+"Bicfi");
                            }else {
                                keyList.add(value1+str1.substring(0,1).toUpperCase()+str1.substring(1));
                                valueList.add(str2);
                            }
                        }
                    }
                }
                String fileName2 = "/template/"+value2+".properties";
                InputStream resourceAsStream2 = AbstractMx2ElementCreator.class.getResourceAsStream(fileName2);
                List<String> properties2 = StringUtil.inputStreamToLines(resourceAsStream2);
                if (properties2.size() > 0) {
                    for (String property : properties2) {
                        if (property.startsWith("#")) {
                            continue;//过滤注释
                        }
                        String[] strArr = property.split("=");
                        if (strArr.length != 2) {
                            continue;//过滤掉不符合规则的配置
                        }
                        String str1 = strArr[0];
                        String str2 = strArr[1];
                        if(StringUtil.isNotEmpty(str1)&&StringUtil.isNotEmpty(str2)){
                            keyList.add(value1+str1.substring(0,1).toUpperCase()+str1.substring(1));
                            valueList.add(str2);
                        }
                    }
                }

            }
            for (int i = 0; i < keyList.size(); i++) {
                Object xmlValue = getXmlValue(jsonMaps, path.split("\\[")[0] + "." + valueList.get(i));
                maps.put(keyList.get(i),xmlValue);
            }
            return null;
        }
        //需要用. split,然后循环遍历json获取值
        String[] paths = path.split("\\.");
        Map<String, Object> tmpMaps = jsonMaps;
        for (int i=0; i<paths.length; i++) {
            String p = paths[i];
            Object obj = tmpMaps.get(p);
            if (obj == null) return null;
            if (obj instanceof JSONArray) {
                JSONArray jsonArray = (JSONArray)obj;
                if (i == paths.length-1) {
                    return jsonArray;
                } else {
                    obj = jsonArray.get(0);
                    if (obj instanceof JSONObject) {
                        tmpMaps = (Map<String, Object>)obj; //不是最后一层
                    } else {
                        return jsonArray;
                    }
                }
            } else if (obj instanceof JSONObject) {
                tmpMaps = (Map<String, Object>)obj;
            } else {
                if ("bigdecimal".equals(type)) {
                    value = new BigDecimal(String.valueOf(obj));
                } else if ("boolean".equals(type)) {
                    value = Boolean.valueOf(String.valueOf(obj));
                } else {
                    value = String.valueOf(obj);
                }
                break;
            }
        }
        return value;
    }*/
}
