package com.brilliance.swift.mx2element.camt053001;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2element.AbstractMx2ElementCreator;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.XmlUtil;
import com.brilliance.swift.vo.common.BalanceTypeCode;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.DocumentHelper;

import java.io.InputStream;
import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.util.*;

public class Mx2ElementCamt053001Creator extends AbstractMx2ElementCreator {
    /*@Override
    public Map<String, Object> buildElement() {
        String messageType = abstractMX.getMxId().getBusinessProcess().name()
                + abstractMX.getMxId().getFunctionality()
                + abstractMX.getMxId().getVariant()
                + abstractMX.getMxId().getVersion();
        maps.put("messageType", messageType);
        String gsonStr = abstractMX.toJson();
        Map<String, Object> mxGsonMaps = JSON.parseObject(gsonStr);
        String fileName = "/template/"+messageType+".properties";
        InputStream resourceAsStream = AbstractMx2ElementCreator.class.getResourceAsStream(fileName);
        if (resourceAsStream == null) {
            int versionLength = abstractMX.getMxId().getVersion().length();
            fileName = "/template/"+messageType.substring(0, messageType.length()-versionLength)+".properties";
            resourceAsStream = AbstractMx2ElementCreator.class.getResourceAsStream(fileName);

        }
        List<String> properties = StringUtil.inputStreamToLines(resourceAsStream);
        if (properties.size() > 0) {
            for (String property : properties) {
                if (property.startsWith("#")) {
                    continue;//过滤注释
                }
                String[] strArr = property.split("=");
                if (strArr.length != 2) {
                    continue;//过滤掉不符合规则的配置
                }
                String key = strArr[0];
                String path = strArr[1];
                Object value = getXmlValue(mxGsonMaps, path,0);
                if (value != null) {
                    maps.put(key, value);
                }
            }
        }
        return maps;
    }*/
    private Object invokeHere(String methodName, Object where) {
        try {
            Method method = getClass().getMethod(methodName);
            return method.invoke(where);
        } catch (final NoSuchMethodException e) {
            throw new SwiftException("Method " + methodName + " does not exist in " + getClass());
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
    protected Object getXmlValue(Map<String, Object> jsonMaps, String path,int count) {
        Object value = null;
        if (path.startsWith("@")) { //如果以@开始 表示取值规则采用的函数
            return invokeHere(path.substring(1), this);
        }
        if (path.indexOf("?") > 0) {
            String[] childPaths = path.split("\\?");
            for (String childPath : childPaths) {
                value = getXmlValue(jsonMaps, childPath);
                if (value != null) {
                    return value;
                }
            }
        }
        //获取数据类型，&分隔，默认是string
        String type = "string";
        if (path.indexOf("&") > -1) {
            type = path.substring(path.indexOf("&")+1);
            path = path.substring(0, path.indexOf("&"));
        }
        //需要用. split,然后循环遍历json获取值
        int index1 = path.indexOf("(");
        int index2 = path.indexOf(")");
        if(index1>0&&index2>0){
            path = path.substring(0,index1)+path.substring(index1,index2).replace(".","-")+path.substring(index2);
        }
        String[] paths = path.split("\\.");
        Map<String, Object> tmpMaps = jsonMaps;
        for (int i=0; i<paths.length; i++) {
            int j = 0;
            String p = paths[i];
            if(p.indexOf("#")>0){
                String key = p.split("#")[0];
                JSONArray array = (JSONArray) tmpMaps.get(key);
                String fileName = "/template/"+p.split("#")[1]+".properties";
                InputStream resourceAsStream = AbstractMx2ElementCreator.class.getResourceAsStream(fileName);
                List<String> properties = StringUtil.inputStreamToLines(resourceAsStream);
                List<Map<String,Object>> list = new ArrayList<>();
                List<String> keyList = new ArrayList<>();
                List<String> valueList = new ArrayList<>();
                if (properties.size() > 0) {
                    for (String property : properties) {
                        if (property.startsWith("#")) {
                            continue;//过滤注释
                        }
                        String[] strArr = property.split("=");
                        if (strArr.length != 2) {
                            continue;//过滤掉不符合规则的配置
                        }
                        String key1 = strArr[0];
                        String value1 = strArr[1];
                        if(StringUtil.isNotEmpty(key1)&&StringUtil.isNotEmpty(value1)){
                            keyList.add(key1);
                            valueList.add(value1);
                        }
                    }
                }
                for (int i1 = 0; i1 < array.size(); i1++) {
                    Map<String,Object> entryMaps = new LinkedHashMap<>();
                    for (int j1 = 0; j1 < valueList.size(); j1++) {
                        Object xmlValue = getXmlValue((Map<String, Object>) array.get(i1), valueList.get(j1), 0);
                        if(xmlValue!=null){
                            entryMaps.put(keyList.get(j1),xmlValue);
                        }
                    }
                    list.add(entryMaps);
                }
                if(list.size()>0){
                    return list;
                }else {
                    return null;
                }
                //清空ntry中的值将list存入ntry中
            }
            if(p.contains("(")&&p.contains(")")){
                JSONArray array = (JSONArray) tmpMaps.get(p.substring(0,p.indexOf("(")));
                String[] split = p.split(":");
                String path1 = split[0].substring(p.indexOf("(")+1).replace("-",".");
                String value1 = split[1].substring(0,split[1].length()-1);
                for (;j<array.size();j++){
                    String xmlValue = (String)getXmlValue((Map<String, Object>) array.get(j), path1,j);
                    if(StringUtil.isNotEmpty(xmlValue)&&xmlValue.equals(value1)){
                        int index = p.indexOf("(");
                        p = p.substring(0,index);
                        break;
                    }
                }
            }
            Object obj = tmpMaps.get(p);
            if (obj == null) return null;
            if (obj instanceof JSONArray) {
                JSONArray jsonArray = (JSONArray)obj;
                if (i == paths.length-1) {
                    return jsonArray;
                } else {
                    obj = jsonArray.get(j);
                    if (obj instanceof JSONObject) {
                        tmpMaps = (Map<String, Object>)obj; //不是最后一层
                    } else {
                        return jsonArray;
                    }
                }
            } else if (obj instanceof JSONObject) {
                tmpMaps = (Map<String, Object>)obj;
            } else {
                if ("bigdecimal".equals(type)) {
                    value = new BigDecimal(String.valueOf(obj));
                } else if ("boolean".equals(type)) {
                    value = Boolean.valueOf(String.valueOf(obj));
                } else {
                    value = String.valueOf(obj);
                }
                break;
            }
        }
        return value;
    }

    public Object buildOpbdBalance(){
        balance(BalanceTypeCode.OPBD.value());
        return null;
    }

    public Object buildClbdBalance(){
        balance(BalanceTypeCode.CLBD.value());
        return null;
    }

    public Object buildClavBalance(){
        balance(BalanceTypeCode.CLAV.value());
        return null;
    }

    public Object bulidNtry(){
        try {
            Document document = DocumentHelper.parseText(xmlStr);
            Map<String, String> parentElementMaps = XmlUtil.getParentElementMaps(document);
            String bodyParentPath = parentElementMaps.get("Stmt");
            int entryCount = XmlUtil.getChildrenCount(document, bodyParentPath+".Stmt.Ntry", null);
            List<Map<String, Object>> list = new ArrayList<>();
            if(entryCount>0){
                for (int i = 0; i < entryCount; i++) {
                    Map<String, Object> entryMaps = new LinkedHashMap<>();
                    String ntryRef = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").NtryRef");
                    if (StringUtil.isNotEmpty(ntryRef)) {
                        entryMaps.put("ntryRef", ntryRef);
                    }
                    String ntryAmt = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").Amt");
                    if (StringUtil.isNotEmpty(ntryAmt)) {
                        entryMaps.put("ntryAmt", new BigDecimal(ntryAmt));
                    }
                    String ntryCcy = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").Amt@Ccy");
                    if (StringUtil.isNotEmpty(ntryCcy)) {
                        entryMaps.put("ntryCcy", ntryCcy);
                    }
                    String ntryCdtDbtInd = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").CdtDbtInd");
                    if (StringUtil.isNotEmpty(ntryCdtDbtInd)) {
                        entryMaps.put("ntryCdtDbtInd", ntryCdtDbtInd);
                    }
                    String ntryRvslInd = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").RvslInd");
                    if (StringUtil.isNotEmpty(ntryRvslInd)) {
                        entryMaps.put("ntryRvslInd", Boolean.valueOf(ntryRvslInd));
                    }
                    String ntrySts = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").Sts.Cd");
                    if (StringUtil.isNotEmpty(ntrySts)) {
                        entryMaps.put("ntrySts", ntrySts);
                    }
                    String ntryStsPrtry = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").Sts.Prtry");
                    if (StringUtil.isNotEmpty(ntryStsPrtry)) {
                        entryMaps.put("ntryStsPrtry", ntryStsPrtry);
                    }
                    String ntryBookgDt = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").BookgDt.Dt");
                    if (StringUtil.isNotEmpty(ntryBookgDt)) {
                        entryMaps.put("ntryBookgDt", ntryBookgDt);
                    }
                    String ntryValDt = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").ValDt.Dt");
                    if (StringUtil.isNotEmpty(ntryValDt)) {
                        entryMaps.put("ntryValDt", ntryValDt);
                    }
                    String ntryAcctSvcrRef = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").AcctSvcrRef");
                    if (StringUtil.isNotEmpty(ntryAcctSvcrRef)) {
                        entryMaps.put("ntryAcctSvcrRef", ntryAcctSvcrRef);
                    }
                    String ntryBkTxCdDomnCd = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").BkTxCd.Domn.Cd");
                    if (StringUtil.isNotEmpty(ntryBkTxCdDomnCd)) {
                        entryMaps.put("ntryBkTxCdDomnCd", ntryBkTxCdDomnCd);
                    }
                    String ntryBkTxCdFmlyCd = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").BkTxCd.Domn.Fmly.Cd");
                    if (StringUtil.isNotEmpty(ntryBkTxCdFmlyCd)) {
                        entryMaps.put("ntryBkTxCdFmlyCd", ntryBkTxCdFmlyCd);
                    }
                    String ntryBkTxCdFmlySubFmlyCd = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").BkTxCd.Domn.Fmly.SubFmlyCd");
                    if (StringUtil.isNotEmpty(ntryBkTxCdFmlySubFmlyCd)) {
                        entryMaps.put("ntryBkTxCdFmlySubFmlyCd", ntryBkTxCdFmlySubFmlyCd);
                    }
                    String ntryBkTxCdPrtryCd = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").BkTxCd.Prtry.Cd");
                    if (StringUtil.isNotEmpty(ntryBkTxCdPrtryCd)) {
                        entryMaps.put("ntryBkTxCdPrtryCd", ntryBkTxCdPrtryCd);
                    }
                    String endToEndId = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").NtryDtls.TxDtls.Refs.EndToEndId");
                    if (StringUtil.isNotEmpty(endToEndId)) {
                        entryMaps.put("endToEndId", endToEndId);
                    }
                    String addtlTxInf = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Ntry("+i+").NtryDtls.TxDtls.AddtlTxInf");
                    if (StringUtil.isNotEmpty(addtlTxInf)) {
                        entryMaps.put("addtlTxInf", addtlTxInf);
                    }
                    list.add(entryMaps);
                }
            }
            if(list.size()>0){
                return list;
            }else {
                return null;
            }
        }catch (DocumentException e) {
            throw new SwiftException(e.getMessage());
        }
    }


    public void balance(String type){
        try {
            Document document = DocumentHelper.parseText(xmlStr);
            Map<String, String> parentElementMaps = XmlUtil.getParentElementMaps(document);
            String bodyParentPath = parentElementMaps.get("Stmt");
            int balCount = XmlUtil.getChildrenCount(document, bodyParentPath+".Stmt.Bal", null);
            if(balCount>0){
                for (int i = 0; i < balCount; i++) {
                    String balanceType = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Bal("+i+").Tp.CdOrPrtry.Cd");
                    if (StringUtil.isNotEmpty(type)&&type.equals(balanceType)) {
                        balanceType = balanceType.toLowerCase();
                        String balSubType = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Bal("+i+").Tp.SubTp.Cd");
                        if(StringUtil.isNotEmpty(balSubType)){
                            maps.put(balanceType+"BalSubType",balSubType);
                        }
                        String balSubTypePrtry = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Bal("+i+").Tp.SubTp.Prtry");
                        if(StringUtil.isNotEmpty(balSubTypePrtry)){
                            maps.put(balanceType+"BalSubTypePrtry",balSubTypePrtry);
                        }
                        String balAmt = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Bal("+i+").Amt");
                        if(StringUtil.isNotEmpty(balAmt)){
                            maps.put(balanceType+"BalAmt",new BigDecimal(balAmt));
                        }
                        String balCcy = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Bal("+i+").Amt@Ccy");
                        if(StringUtil.isNotEmpty(balCcy)){
                            maps.put(balanceType+"BalCcy",balCcy);
                        }
                        String balCdtDbtInd = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Bal("+i+").CdtDbtInd");
                        if(StringUtil.isNotEmpty(balCdtDbtInd)){
                            maps.put(balanceType+"BalCdtDbtInd",balCdtDbtInd);
                        }
                        String balDt = XmlUtil.getXmlNodeValue(document, bodyParentPath+".Stmt.Bal("+i+").Dt.Dt");
                        if(StringUtil.isNotEmpty(balDt)){
                            maps.put(balanceType+"BalDt",balDt);
                        }
                    }
                }
            }
        }catch (DocumentException e) {
                throw new SwiftException(e.getMessage());
        }
    }
}
