package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 * CdtTrfTxInf.PmtId.InstrId
 * GrpHdr.MsgId
 * AppHdr.BizMsgIdr
 */
public class Field20Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "20";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String messageId = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.PmtId.InstrId");
        if (StringUtil.isEmpty(messageId)) {
            messageId = getXmlNodeValue(grpHdrParentElementName, document, "GrpHdr.MsgId");
        }
        if (StringUtil.isEmpty(messageId)) {
            messageId = getXmlNodeValue(appHdrParentElementName, document, "AppHdr.BizMsgIdr");
        }
        if (StringUtil.isNotEmpty(messageId)) {
            if (messageId.startsWith("/") || messageId.endsWith("/") || messageId.contains("//")) {
                buildSTErrorInfo(42, "Block4/:20:", messageId);
                messageId = Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
            }
            if (messageId.length() > 16) {
                buildSTErrorInfo(13, "Block4/:20:", messageId);
                messageId = messageId.substring(0, 15) + "+";
            }
            tags.add(new Tag(name, messageId));
        }

    }
}
