package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

public class Field36Generate extends AbstractMx2MtTagsGenerate {
    private static String name = "36";
    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String exchangeRateStr = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.XchgRate");
        if (StringUtil.isNotEmpty(exchangeRateStr)) {
            exchangeRateStr = String.valueOf(new BigDecimal(exchangeRateStr));
            if (exchangeRateStr.startsWith("-")) {
                exchangeRateStr = exchangeRateStr.replace("-", "");
            }
            if(exchangeRateStr.indexOf(".") > 0){//去掉小数点后不需要的0
                exchangeRateStr = exchangeRateStr.replaceAll("0+?$", "");
            }
            exchangeRateStr = exchangeRateStr.replace(".", ",");//小数点替换成,
            tags.add(new Tag(name, exchangeRateStr));
        }

    }
}
