package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.common.SettlementMethodCode;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 *对于所有代理行，如果xml报文中有代理行的bic，并且账户和清算代码都存在，则MT账号取账户；
 *  * 如果代理行没有bic，MT账号优先取清算代码，没有的话再取账户。
 */
public class Field53AGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "53A";

    private static String name_B = "53B";

    private static String name_D = "53D";

    private static String name = "53";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/53a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String settlementMethod = getXmlNodeValue(grpHdrParentElementName, document, "GrpHdr.SttlmInf.SttlmMtd");
        if (SettlementMethodCode.INGA.value().equals(settlementMethod)
           || SettlementMethodCode.INDA.value().equals(settlementMethod)) {
           String value = "";
           String bicCode = mx_to_mt53A(bodyHdrParentElementName + ".CdtTrfTxInf.InstrForNxtAgt");
           String account = mx_to_mtSettlementAccount(settlementMethod, grpHdrParentElementName+".GrpHdr.SttlmInf.SttlmAcct");
           if (StringUtil.isNotEmpty(bicCode)) {
                if (StringUtil.isNotEmpty(account)) {
                    value = account + Mx2MtConstants.NEW_LINE + bicCode;
                } else {
                    value = bicCode;
                }
                tags.add(new Tag(name_A, value));
           } else {
               if (StringUtil.isNotEmpty(account)) {
                   value = account;
                   tags.add(new Tag(name_B, value));
               }
           }
        } else {
            String agentPath = grpHdrParentElementName + ".GrpHdr.SttlmInf.InstgRmbrsmntAgt";
            String accountPath = grpHdrParentElementName + ".GrpHdr.SttlmInf.InstgRmbrsmntAgtAcct";
            Tag tag = mx_to_mtAgentGeneric(name, agentPath, accountPath, true, false, false, null);
            if (tag != null) {
                if (name_D.equals(tag.getName())) {
                    String value = mx_to_mtStartingLineCharacter(tag.getValue(), "Block4/:"+name_D+":");
                    tag.setValue(value);
                }
                tags.add(tag);
            }
        }
    }
}
