package com.brilliance.swift.mx2mt.mt103Retn.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

public class Field33BGenerate extends AbstractMx2MtTagsGenerate {
    private static String name = "33B";
    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String amt = getXmlNodeValue(bodyHdrParentElementName, document, "TxInf.RtrdInstdAmt");
        String ccy = getXmlNodeValue(bodyHdrParentElementName, document, "TxInf.RtrdInstdAmt@Ccy");
        if (StringUtil.isNotEmpty(amt) && StringUtil.isNotEmpty(ccy)) {
            tags.add(new Tag(name, ccy + NumberUtil.formatAmt(new BigDecimal(amt), ccy)));
        } else {
            String senderBic = (String)context.get(Mx2MtContextIdentifier.MX_SENDER_BIC, true);
            String receiverBic = (String)context.get(Mx2MtContextIdentifier.MX_RECEIVER_BIC, true);
            if (StringUtil.isNotEmpty(senderBic)
               && SwiftTransferUtil.checkInEuCountryList(senderBic.substring(4, 6))
               && StringUtil.isNotEmpty(receiverBic)
               && SwiftTransferUtil.checkInEuCountryList(receiverBic.substring(4, 6))){
                amt = getXmlNodeValue(bodyHdrParentElementName, document, "TxInf.RtrdIntrBkSttlmAmt");
                ccy = getXmlNodeValue(bodyHdrParentElementName, document, "TxInf.RtrdIntrBkSttlmAmt@Ccy");
                if (StringUtil.isNotEmpty(amt) && StringUtil.isNotEmpty(ccy)) {
                    buildSTErrorInfo(38, "Block4/:"+name+":", null);
                    tags.add(new Tag(name, ccy+NumberUtil.formatAmt(new BigDecimal(amt), ccy)));
                }
            }
        }

    }
}

