package com.brilliance.swift.mx2mt.mt103Retn.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 *对于所有代理行，如果xml报文中有代理行的bic，并且账户和清算代码都存在，则MT账号取账户；
 *  * 如果代理行没有bic，MT账号优先取清算代码，没有的话再取账户。
 */
public class Field52AGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "52A";

    private static String name_D = "52D";

    private static String name = "52";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/52a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String agentPath = bodyHdrParentElementName + ".TxInf.RtrChain.DbtrAgt";
        Tag tag = mx_to_mtAgentGeneric(name, agentPath, null, false, false, false, null);
        if (tag != null) {
            if (name_D.equals(tag.getName())) {
                String value = mx_to_mtStartingLineCharacter(tag.getValue(), "Block4/:"+name_D+":");
                tag.setValue(value);
            }
            tags.add(tag);
        }
    }
}