package com.brilliance.swift.mx2mt.mt103Retn.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 *对于所有代理行，如果xml报文中有代理行的bic，并且账户和清算代码都存在，则MT账号取账户；
 *  * 如果代理行没有bic，MT账号优先取清算代码，没有的话再取账户。
 */
public class Field57AGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "57A";

    private static String name_D = "57D";

    private static String name = "57";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/57a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String agentPath = bodyHdrParentElementName + ".TxInf.RtrChain.CdtrAgt";
        Tag tag = mx_to_mtAgentGeneric(name, agentPath, null, true, true, false, null);
        if (tag != null) {
            if (name_D.equals(tag.getName())) {
                String value = mx_to_mtStartingLineCharacter(tag.getValue(), "Block4/:"+name_D+":");
                tag.setValue(value);
            }
            tags.add(tag);
        } else {
            //mapping转换文档 Translation Post Conditions -> POSTC004
            if (exist56a(tags)) {
                tags.add(new Tag(name_D, Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE));
            }
        }
    }

    /**
     * 56a 是否存在
     * @param tags
     * @return
     */
    private boolean exist56a(List<Tag> tags) {
        boolean flag = false;
        if (tags != null && tags.size() > 0) {
            for (int i=0; i<tags.size(); i++) {
                Tag tag = tags.get(i);
                if (tag.getName().matches("56[ACD]")) {
                    flag = true;
                    break;
                }
            }
        }
        return flag;
    }
}
