package com.brilliance.swift.mx2mt.mt192292.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field21Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "21";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String orgnlInstrId = getXmlNodeValue(bodyHdrParentElementName, document, "Undrlyg.TxInf.OrgnlInstrId");
        if (StringUtil.isNotEmpty(orgnlInstrId)) {
            if (orgnlInstrId.length() > 16) {
                buildSTErrorInfo(13, "Block4/:21:", orgnlInstrId);
                orgnlInstrId = orgnlInstrId.substring(0, 15) + "+";
            }
        }
        if (StringUtil.isEmpty(orgnlInstrId) || (orgnlInstrId.startsWith("/") || orgnlInstrId.endsWith("/") || orgnlInstrId.contains("//"))) {
            buildSTErrorInfo(73, "Block4/:21:", orgnlInstrId);
            orgnlInstrId = Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
        }
        tags.add(new Tag(name, orgnlInstrId));
    }
}
