package com.brilliance.swift.mx2mt.mt192292.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**

 */
public class Field79Generate extends AbstractMx2MtTagsGenerate {

    private static String name_79 = "79";

    private static String name_32A = "32A";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String mt32A = "";
        try {
            String intrBkSttlmDtStr = "";
            String intrBkSttlmAmt = "";
            String intrBkSttlmccy = "";
            String intrBkSttlmDtValue = getXmlNodeValue(bodyHdrParentElementName, document, "Undrlyg.TxInf.OrgnlIntrBkSttlmDt");
            if (StringUtil.isNotEmpty(intrBkSttlmDtValue)) {
                XMLGregorianCalendar intrBkSttlmDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(intrBkSttlmDtValue);
                intrBkSttlmDtStr = DateUtil.format(intrBkSttlmDt, "yyMMdd");
            }
            String amt = getXmlNodeValue(bodyHdrParentElementName, document, "Undrlyg.TxInf.OrgnlIntrBkSttlmAmt");
            String ccy = getXmlNodeValue(bodyHdrParentElementName, document, "Undrlyg.TxInf.OrgnlIntrBkSttlmAmt@Ccy");
            if (StringUtil.isNotEmpty(amt) && StringUtil.isNotEmpty(ccy)) {
                intrBkSttlmAmt = NumberUtil.formatAmt(new BigDecimal(amt), ccy);
                intrBkSttlmccy = ccy;
                mt32A = intrBkSttlmDtStr + intrBkSttlmccy + intrBkSttlmAmt;
            }
        }catch (DatatypeConfigurationException e) {
            throw new SwiftException(e.getMessage());
        }
        String uetr = getXmlNodeValue(bodyHdrParentElementName, document, "Undrlyg.TxInf.OrgnlUETR");
        if (StringUtil.isEmpty(uetr)) {
            if (StringUtil.isNotEmpty(mt32A)) {
                tags.add(new Tag(name_32A, mt32A));
            }
            return;
        }
        String mxReasonCode = getXmlNodeValue(bodyHdrParentElementName, document, "Undrlyg.TxInf.CxlRsnInf.Rsn.Cd");
        int addtlInfCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Undrlyg.TxInf.CxlRsnInf.AddtlInf");
        String mxAddtlInf = "";
        if (addtlInfCount > 0) {
            for (int i=0; i<addtlInfCount; i++) {
                if (i == 2) break;
                String addtlInf = getXmlNodeValue(bodyHdrParentElementName, document, "Undrlyg.TxInf.CxlRsnInf.AddtlInf("+i+")");
                if (i == 0) {
                    mxAddtlInf += addtlInf;
                } else {
                    if (getXmlNodeValue(bodyHdrParentElementName, document, "Undrlyg.TxInf.CxlRsnInf.AddtlInf("+(i-1)+")").length() > 104) {
                        mxAddtlInf += addtlInf;
                    } else {
                        mxAddtlInf += " " + addtlInf;
                    }
                }
            }
        }
        String mt79 = "";
        if (StringUtil.isNotEmpty(mxReasonCode)) {
            mt79 += "/" + mxReasonCode + "/";
        }
        if (StringUtil.isNotEmpty(mxAddtlInf)) {
            mt79 += mxAddtlInf;
        }
        List<String> list = new ArrayList<>();
        if (StringUtil.isNotEmpty(mt79)) {
            list.addAll(StringUtil.outStringList(mt79, 50, "//"));
        }
        list.add("/UETR/" + uetr);
        String value = "";
        for (int i=0; i<list.size(); i++) {
            if (i == 35) break;
            if (i == 0) {
                value = list.get(i);
            } else {
                value += Mx2MtConstants.NEW_LINE + list.get(i);
            }
        }
        value = mx_to_mtStartingLineCharacter(value, "Block4/:79:");
        tags.add(new Tag(name_79, value));
        if (StringUtil.isNotEmpty(mt32A)) {
            tags.add(new Tag(name_32A, mt32A));
        }
    }
}
