package com.brilliance.swift.mx2mt.mt196296.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.List;

/**
 *
 */
public class Field11RGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "11R";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        boolean boolean1 = false;
        boolean boolean2 = false;
        String mtNumber = "";
        String orgnlMsgNm = getXmlNodeValue(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.OrgnlGrpInf.OrgnlMsgNmId");
        if (StringUtil.isNotEmpty(orgnlMsgNm)) {
            if(orgnlMsgNm.indexOf("pacs.008") > -1){
                mtNumber =  "103";
            }else if(orgnlMsgNm.indexOf("pacs.003") > -1){
                mtNumber = "104";
            }else if(orgnlMsgNm.indexOf("pacs.009") > -1){
                mtNumber = "202";
            }else if(orgnlMsgNm.indexOf("pacs.010") > -1){
                mtNumber = "204";
            }else if(orgnlMsgNm.matches("MT10[0-9]{1}")){
                mtNumber = orgnlMsgNm.substring(2);
            }else if(orgnlMsgNm.matches("MT20[0-9]{1}")){
                mtNumber = orgnlMsgNm.substring(2);
            }else {
                mtNumber = "202";
                boolean1 = true;
            }
        }
        String mtDate = "";
        String dateStr = getXmlNodeValue(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.OrgnlGrpInf.OrgnlCreDtTm");
        if (StringUtil.isNotEmpty(dateStr)) {
            try {
                XMLGregorianCalendar date = DatatypeFactory.newInstance().newXMLGregorianCalendar(dateStr);
                mtDate = DateUtil.format(date, "yyMMdd");
            } catch (DatatypeConfigurationException e) {
                throw new SwiftException(e.getMessage());
            }
        }
        if (StringUtil.isEmpty(mtDate)) {
            mtDate = "991231";
            boolean2 = true;
        }
        if((boolean1 && boolean2) || StringUtil.isEmpty(mtNumber)){
            return;
        }else {
            tags.add(new Tag(name, mtNumber + Mx2MtConstants.NEW_LINE + mtDate));
            if(boolean1){
                buildSTErrorInfo(75,"Block4/:11R:",null);
            }
        }

    }
}
