package com.brilliance.swift.mx2mt.mt196296.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field20Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "20";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String cxlStsId = getXmlNodeValue(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.CxlStsId");
        if (StringUtil.isNotEmpty(cxlStsId)) {
            if (cxlStsId.length() > 16) {
                buildSTErrorInfo(13, "Block4/:20:", cxlStsId);
                cxlStsId = cxlStsId.substring(0, 15) + "+";
            }
            if (cxlStsId.startsWith("/") || cxlStsId.endsWith("/") || cxlStsId.contains("//")) {
                buildSTErrorInfo(42, "Block4/:20:", cxlStsId);
                cxlStsId = Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
            }
            tags.add(new Tag(name, cxlStsId));
        }
    }
}
