package com.brilliance.swift.mx2mt.mt196296.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.ArrayList;
import java.util.List;

/**

 */
public class Field76Generate extends AbstractMx2MtTagsGenerate {

    private static String name_76 = "76";

    private static String name_77A = "77A";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String status = getXmlNodeValue(bodyHdrParentElementName, document, "Sts.Conf");
        if (StringUtil.isEmpty(status)) return;
        String mxReasonCode = getXmlNodeValue(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.CxlStsRsnInf.Rsn.Cd");
        int addtlInfCount = getXmlNodeCounts(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.CxlStsRsnInf.AddtlInf");
        String mxAddtlInf = "";
        if (addtlInfCount > 0) {
            for (int i=0; i<addtlInfCount; i++) {
                if (i == 2) break;
                String addtlInf = getXmlNodeValue(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.CxlStsRsnInf.AddtlInf("+i+")");
                if (i == 0) {
                    mxAddtlInf += addtlInf;
                } else {
                    if (getXmlNodeValue(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.CxlStsRsnInf.AddtlInf("+(i-1)+")").length() > 104) {
                        mxAddtlInf += addtlInf;
                    } else {
                        mxAddtlInf += " " + addtlInf;
                    }
                }
            }
        }
        String mxString76 = "/" + status + "/";
        if (StringUtil.isNotEmpty(mxReasonCode)) {
            if (StringUtil.isNotEmpty(mxAddtlInf)) {
                mxString76 += mxReasonCode + "/" + mxAddtlInf;
            } else {
                mxString76 += mxReasonCode;
            }
        } else if (StringUtil.isNotEmpty(mxAddtlInf)) {
            mxString76 += mxAddtlInf;
        }
        List<String> list = StringUtil.outStringList(mxString76, 35, "//");
        String mt76 = "";
        String moreStr = "";
        if (list != null && list.size() > 0) {
            for (int i=0; i<list.size(); i++) {
                String str = list.get(i);
                if (i < 6) {
                    if (i == 0) {
                        mt76 = str;
                    } else {
                        mt76 += Mx2MtConstants.NEW_LINE + str;
                    }
                } else {
                    moreStr += str.substring(2);
                }
            }
        }
        if (StringUtil.isNotEmpty(mt76)) {
            tags.add(new Tag(name_76, mt76));
        }
        List<String> listMt77 = new ArrayList<>();
        if (StringUtil.isNotEmpty(moreStr)) {
            listMt77.addAll(StringUtil.outStringList(moreStr, 35, "//"));
        }
        String uetr = getXmlNodeValue(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.OrgnlUETR");
        if (StringUtil.isNotEmpty(uetr)) {
            listMt77.addAll(StringUtil.outStringList("/UETR/"+uetr, 35, "//"));
        }
        String mt77 = "";
        for (int i=0; i<listMt77.size(); i++) {
            if (i == 20) break;
            String str = listMt77.get(i);
            if (i == 0) {
                mt77 = str;
            } else {
                mt77 += Mx2MtConstants.NEW_LINE + str;
            }
        }
        if (StringUtil.isNotEmpty(mt77)) {
            tags.add(new Tag(name_77A, mt77));
        }
    }
}
