package com.brilliance.swift.mx2mt.mt202Retn.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 * 取值逻辑：
 * field21 = CdtTrfTxInf.PmtId.EndToEndId,如果长度大于16，field21 = field21截取15位 + 最后一位用+代替
 * 如果filed21 以/开始或者以/结束或者包含//，field21=NONREF
 * 否则保持原值不变
 */
public class Field21Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "21";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String endToEndId = getXmlNodeValue(bodyHdrParentElementName, document, "TxInf.OrgnlEndToEndId");
        if (StringUtil.isNotEmpty(endToEndId)) {
            if (endToEndId.startsWith("/") || endToEndId.endsWith("/") || endToEndId.contains("//")) {
                buildSTErrorInfo(42, "Block4/:21:", endToEndId);
                endToEndId = Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
            }
            if (endToEndId.length() > 16) {
                buildSTErrorInfo(13, "Block4/:21:", endToEndId);
                endToEndId = endToEndId.substring(0, 15) + "+";
            }
            tags.add(new Tag(name, endToEndId));
        }
    }
}
