package com.brilliance.swift.mx2mt.mt202cov202.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field58A;
import com.prowidesoftware.swift.model.field.Field58D;

import java.util.List;

/**
 */
public class Field58AGenerate extends AbstractMx2MtTagsGenerate {


    private static String name_A = "58A";

    private static String name_D = "58D";

    private static String name = "58";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/58a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String agentPath = bodyHdrParentElementName + ".CdtTrfTxInf.Cdtr";
        String accountPath = bodyHdrParentElementName + ".CdtTrfTxInf.CdtrAcct";
        String clearingChannelPath = bodyHdrParentElementName + ".CdtTrfTxInf.PmtTpInf.ClrChanl";
        Tag tag = mx_to_mtAgentGeneric(name, agentPath, accountPath, false, false, true, clearingChannelPath);
        if (tag != null) {
            if (name_D.equals(tag.getName())) {
                String value = mx_to_mtStartingLineCharacter(tag.getValue(), "Block4/:"+name_D+":");
                tag.setValue(value);
            }
            //mapping转换文档 Translation Post Conditions -> POSTC004  POSTC005
            String value = tag.getValue();
            String tagName = tag.getName();
            boolean flag = exist56a57aStartWithFWRT(tags);
            if (flag && (value.startsWith("//FW") || value.startsWith("//RT"))) {
                String tmp58aPartyIdentifier = mx_to_mtClearingIdentifier(agentPath);
                if (StringUtil.isEmpty(tmp58aPartyIdentifier) || tmp58aPartyIdentifier.startsWith("//FW")) {
                    if (tagName.equals(name_A)) {
                        Field58A field58A = (Field58A)tag.asField();
                        tag = new Tag(name_A, field58A.getBIC());
                        buildSTErrorInfo(105, "Block4/:"+tagName+":", null);
                    } else if (tagName.equals(name_D)) {
                        Field58D field58D = (Field58D)tag.asField();
                        if (!field58D.getNameAndAddress().startsWith("//")) {
                            tag = new Tag(name_D, field58D.getNameAndAddress());
                            buildSTErrorInfo(105, "Block4/:"+tagName+":", null);
                        } else if (StringUtil.isNotEmpty(tmp58aPartyIdentifier)) {
                            tag = new Tag(name_D, tmp58aPartyIdentifier + Mx2MtConstants.NEW_LINE + field58D.getNameAndAddress());
                        }
                    }
                } else {
                    if (tagName.equals(name_A)) {
                        Field58A field58A = (Field58A)tag.asField();
                        tag = new Tag(name_A, tmp58aPartyIdentifier + Mx2MtConstants.NEW_LINE + field58A.getBIC());
                    } else if (tagName.equals(name_D)) {
                        Field58D field58D = (Field58D)tag.asField();
                        tag = new Tag(name_D, tmp58aPartyIdentifier + Mx2MtConstants.NEW_LINE + field58D.getNameAndAddress());
                    }
                }
            }
            tags.add(tag);
        }
    }

    /**
     * 56a 是否以 //FW or //RT 开始
     * 否则 57a 是否以 //FW or //RT 开始
     * @param tags
     * @return
     */
    private boolean exist56a57aStartWithFWRT(List<Tag> tags) {
        boolean flag = false;
        if (tags != null && tags.size() > 0) {
            for (int i=0; i<tags.size(); i++) {
                Tag tag = tags.get(i);
                if (tag.getName().matches("56[ACD]")) {
                    String value = tag.getValue();
                    if (value.startsWith("//FW") || value.startsWith("//RT")) {
                        flag = true;
                        break;
                    }
                }
            }
        }
        if (!flag) {
            if (tags != null && tags.size() > 0) {
                for (int i=0; i<tags.size(); i++) {
                    Tag tag = tags.get(i);
                    if (tag.getName().matches("57[ABCD]")) {
                        String value = tag.getValue();
                        if (value.startsWith("//FW") || value.startsWith("//RT")) {
                            flag = true;
                            break;
                        }
                    }
                }
            }
        }
        return flag;
    }
}

