package com.brilliance.swift.mx2mt.mt202cov202.impl.cov;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftBlock3;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field119;

import java.util.List;

public class Field50AGenerate extends AbstractMx2MtTagsGenerate {


    private static String name_A = "50A";

    private static String name_F = "50F";

    private static String name_K = "50K";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/SequenceB/50a");
        boolean covFlag = false;
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String partyPath = bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.Dbtr";
        String bicCode = mx_to_mtAnyBIC(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.Dbtr");
        String countryCode = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.Dbtr.PstlAdr.Ctry");
        String name = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.Dbtr.Nm");
        int addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.Dbtr.PstlAdr.AdrLine");
        String account = mx_to_mtAccount(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.DbtrAcct");
        String value = "";
        if (StringUtil.isNotEmpty(bicCode)) {
            if (StringUtil.isNotEmpty(account)) {
                value = account + Mx2MtConstants.NEW_LINE + bicCode;
            } else {
                value = bicCode;
            }
            tags.add(new Tag(name_A, value));
            covFlag = true;
        } else if (StringUtil.isNotEmpty(countryCode)) {
            String nameAddress = mx_to_mtFATFNameAndAddress(partyPath);
            if (StringUtil.isEmpty(account)) {
                account = mx_to_mtFATFIdentification(partyPath, false);
                if (StringUtil.isNotEmpty(account) && account.length() > 35) {
                    account = account.substring(0, 35);
                }
            }
            if (StringUtil.isEmpty(account)) {
                account = "/" + Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
            }
            value = account + Mx2MtConstants.NEW_LINE + nameAddress;
            tags.add(new Tag(name_F, value));
            covFlag = true;
        } else if (addressLineCount > 0) {
            boolean structuredAddressIndicator = mx_to_mtAddressLineType(partyPath);
            if (structuredAddressIndicator) {
                String nameAddress = mx_to_mtFATFNameAndAddress2(partyPath);
                if (StringUtil.isEmpty(account)) {
                    account = mx_to_mtFATFIdentification(partyPath, true);
                    if (StringUtil.isNotEmpty(account) && account.length() > 35) {
                        account = account.substring(0, 35);
                    }
                }
                if (StringUtil.isEmpty(account)) {
                    account = "/" + Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
                }
                value = account + Mx2MtConstants.NEW_LINE + nameAddress;
                tags.add(new Tag(name_F, value));
                covFlag = true;
            } else {
                String mtNameAddress = mx_to_mtPartyNameAndUnstructuredAddress(partyPath);
                if (StringUtil.isNotEmpty(account)) {
                    value = account + Mx2MtConstants.NEW_LINE + mtNameAddress;
                } else {
                    value = mtNameAddress;
                }
                value = mx_to_mtStartingLineCharacter(value, "Block4/SequenceB/:50K:");
                tags.add(new Tag(name_K, value));
                covFlag = true;
            }
        } else if (StringUtil.isNotEmpty(name)) {
            String mtNameAddress = mx_to_mtPartyNameAndUnstructuredAddress(partyPath);
            if (StringUtil.isNotEmpty(account)) {
                value = account + Mx2MtConstants.NEW_LINE + mtNameAddress;
            } else {
                value = mtNameAddress;
            }
            value = mx_to_mtStartingLineCharacter(value, "Block4/SequenceB/:50K:");
            tags.add(new Tag(name_K, value));
            covFlag = true;
        }
        if (covFlag) {
            SwiftBlock3 block3 = context.get(SwiftMessage.class).getBlock3();
            Field119 field119 = new Field119("COV");
            block3.builder().setField119(field119);
        }
    }
}

