package com.brilliance.swift.mx2mt.mt202cov202.impl.cov;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Field70Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "70";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/SequenceB/:70:");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String mt70FullString = "";
        String mtUltimateCreditor = mx_to_mtUltimateParty(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.UltmtCdtr");
        if (StringUtil.isNotEmpty(mtUltimateCreditor)) {
            if (StringUtil.isEmpty(mt70FullString)) {
                int remainLength = 140 - mt70FullString.length() - 6;
                if (remainLength > 0) {
                    if (mtUltimateCreditor.length() > remainLength) {
                        buildSTErrorInfo(12, "Block4/SequenceB/:70:/ULTB/", mtUltimateCreditor);
                        mtUltimateCreditor = mtUltimateCreditor.substring(0, remainLength-1) + "+";
                    }
                    mt70FullString += "/ULTB/" + mtUltimateCreditor;
                }
            } else {
                int remainLength = 140 - mt70FullString.length() - 8;
                if (remainLength > 0) {
                    if (mtUltimateCreditor.length() > remainLength) {
                        buildSTErrorInfo(12, "Block4/SequenceB/:70:///ULTB/", mtUltimateCreditor);
                        mtUltimateCreditor = mtUltimateCreditor.substring(0, remainLength-1) + "+";
                    }
                    mt70FullString += "///ULTB/" + mtUltimateCreditor;
                }
            }
        }
        String mtUltimateDebtor = mx_to_mtUltimateParty(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.UltmtDbtr");
        if (StringUtil.isNotEmpty(mtUltimateDebtor)) {
            if (StringUtil.isEmpty(mt70FullString)) {
                int remainLength = 140 - mt70FullString.length() - 6;
                if (remainLength > 0) {
                    if (mtUltimateDebtor.length() > remainLength) {
                        buildSTErrorInfo(12, "Block4/SequenceB/:70:/ULTD/", mtUltimateDebtor);
                        mtUltimateDebtor = mtUltimateDebtor.substring(0, remainLength-1) + "+";
                    }
                    mt70FullString += "/ULTD/" + mtUltimateDebtor;
                }
            } else {
                int remainLength = 140 - mt70FullString.length() - 8;
                if (remainLength > 0) {
                    if (mtUltimateDebtor.length() > remainLength) {
                        buildSTErrorInfo(12, "Block4/SequenceB/:70:///ULTD/", mtUltimateDebtor);
                        mtUltimateDebtor = mtUltimateDebtor.substring(0, remainLength-1) + "+";
                    }
                    mt70FullString += "///ULTD/" + mtUltimateDebtor;
                }
            }
        }
        String remittanceInfoUnstructured = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.RmtInf.Ustrd");
        if (StringUtil.isNotEmpty(remittanceInfoUnstructured)) {
            if (StringUtil.isEmpty(mt70FullString)) {
                if (remittanceInfoUnstructured.length() > 140) {
                    buildSTErrorInfo(12, "Block4/SequenceB/:70:", remittanceInfoUnstructured);
                    remittanceInfoUnstructured = remittanceInfoUnstructured.substring(0, 139) + "+";
                }
                mt70FullString += remittanceInfoUnstructured;
            } else {
                int remainLength = 140 - mt70FullString.length() - 7;
                if (remainLength > 0) {
                    if (remittanceInfoUnstructured.length() > remainLength) {
                        buildSTErrorInfo(12, "Block4/SequenceB/:70:///URI/", remittanceInfoUnstructured);
                        remittanceInfoUnstructured = remittanceInfoUnstructured.substring(0, remainLength-1) + "+";
                    }
                    mt70FullString += "///URI/" + remittanceInfoUnstructured;
                }
            }
        }
        int remittanceInfoStructuredCount = getXmlNodeCounts(bodyHdrParentElementName, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.RmtInf.Strd");
        if (remittanceInfoStructuredCount > 0) {
            if (StringUtil.isEmpty(mt70FullString)) {
                mt70FullString += "/SRI/+";
            } else {
                mt70FullString += "///SRI/+";
            }
        }
        if (StringUtil.isNotEmpty(mt70FullString)) {
            String value = StringUtil.getStringByEnter(mt70FullString, 35, 4);
            value = mx_to_mtStartingLineCharacter(value, "Block4/SequenceB/:70:");
            tags.add(new Tag(name, value));
        }
    }
}
