package com.brilliance.swift.mx2mt.mt202cov202.impl.cov;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.common.SettlementMethodCode;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.ArrayList;
import java.util.List;

public class Field72Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "72";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/SequenceB/:72:");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        List<String> mt72List = new ArrayList<>();
        String mtIntrmyAgt = mx_to_mtAgent(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.IntrmyAgt2", 6);
        if (StringUtil.isEmpty(mtIntrmyAgt)) {
            mtIntrmyAgt = mx_to_mtAgent(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.IntrmyAgt3", 6);
        }
        if (StringUtil.isNotEmpty(mtIntrmyAgt)) {
            mt72List.add("/INTA/" + mtIntrmyAgt);
        }
        String mtCreditorAgt = subFunctionInstructionForCreditorAgentAndJP(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.InstrForCdtrAgt");
        if (StringUtil.isNotEmpty(mtCreditorAgt)) {
            mt72List.add(mtCreditorAgt);
        }

        List<String> mtNextAgts = subFunctionInstructionForNextAgent(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.InstrForNxtAgt", SettlementMethodCode.COVE.value());
        if (mtNextAgts.size() > 0) {
            mt72List.addAll(mtNextAgts);
        }
        String mtPrvsInstgAgt = mx_to_mtBICNameAgent(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.PrvsInstgAgt1", 210);
        if (StringUtil.isEmpty(mtPrvsInstgAgt)) {
            mtPrvsInstgAgt = mx_to_mtBICNameAgent(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.PrvsInstgAgt2", 210);
        }
        if (StringUtil.isEmpty(mtPrvsInstgAgt)) {
            mtPrvsInstgAgt = mx_to_mtBICNameAgent(bodyHdrParentElementName + ".CdtTrfTxInf.UndrlygCstmrCdtTrf.PrvsInstgAgt3", 210);
        }
        if (StringUtil.isNotEmpty(mtPrvsInstgAgt)) {
            mt72List.add("/INS/" + mtPrvsInstgAgt);
        }
        if (mt72List.size() > 0) {
            List<String> list = new ArrayList<>();
            for (int i=0; i<mt72List.size(); i++) {
                String mt72FullField = mt72List.get(i);
                List<String> tmplist = StringUtil.outStringList(mt72FullField, 35, "//");
                list.addAll(tmplist);
            }
            String value = "";
            for (int i=0; i<list.size(); i++) {
                if (i == 6) break;
                if (i == 0) {
                    value = list.get(i);
                } else {
                    value += Mx2MtConstants.NEW_LINE + list.get(i);
                }
            }
            value = mx_to_mtStartingLineCharacter(value, "Block4/SequenceB/:72:");
            tags.add(new Tag(name, value));
        }
    }
}
