package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field21Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "21";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String filed21 = "";
        String endToEndId = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").EndToEndId");
        if(StringUtil.isNotEmpty(endToEndId)){
            filed21 = endToEndId;
        }else {
            filed21 = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Id");
        }
        if (StringUtil.isNotEmpty(filed21)) {
            if (filed21.length() > 16) {
                buildSTErrorInfo(13, "Block4/:21:", filed21);
                filed21 = filed21.substring(0, 15) + "+";
            }
            if (filed21.startsWith("/") || filed21.endsWith("/") || filed21.contains("//")) {
                buildSTErrorInfo(42, "Block4/:21:", filed21);
                filed21 = Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
            }
            tags.add(new Tag(name, filed21));
        }
    }
}
