package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field25Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "25";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String account = mx_to_mtAccount(bodyHdrParentElementName+".Ntfctn.Acct");
        if (StringUtil.isEmpty(account)) {
            account = mx_to_mtAccount(bodyHdrParentElementName+".Ntfctn.Itm.Acct");
        }
        if (StringUtil.isNotEmpty(account)) {
            tags.add(new Tag(name, account));
        }
    }

    protected String mx_to_mtAccount(String accountPath) {
        String mtAccount = "";
        String ibanAcct = getXmlNodeValue(null, document, accountPath + ".Id.IBAN");
        if (StringUtil.isNotEmpty(ibanAcct)) {
            mtAccount = ibanAcct;
        } else {
            String account = getXmlNodeValue(null, document, accountPath + ".Id.Othr.Id");
            if (StringUtil.isNotEmpty(account)) {
                mtAccount = account;
            }
        }
        return mtAccount;
    }
}
