package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.List;

/**

 */
public class Field30Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "30";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String valDtStr = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.XpctdValDt");
        if (StringUtil.isEmpty(valDtStr)) {
            valDtStr = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").XpctdValDt");
        }
        if (StringUtil.isNotEmpty(valDtStr)) {
            try {
                XMLGregorianCalendar valDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(valDtStr);
                String mtValDtStr = DateUtil.format(valDt, "yyMMdd");
                tags.add(new Tag(name, mtValDtStr));
            } catch (DatatypeConfigurationException e) {
                throw new SwiftException(e.getMessage());
            }
        } else {
            buildSTErrorInfo(114, "Block4/:30:", null);
            tags.add(new Tag(name, "991231"));
        }
    }
}
