package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

/**

 */
public class Field32BGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "32B";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String amtStr = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Amt");
        String ccyStr = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Amt@Ccy");
        if ("XAU".equalsIgnoreCase(ccyStr) || "XAG".equalsIgnoreCase(ccyStr)
                || "XPD".equalsIgnoreCase(ccyStr) || "XPT".equalsIgnoreCase(ccyStr)) {
            buildSTErrorInfo(63, bodyHdrParentElementName+".Ntfctn.Itm.Amt", ccyStr);
        }
        if (StringUtil.isNotEmpty(amtStr) && StringUtil.isNotEmpty(ccyStr)) {
            if (NumberUtil.judgeAmtStrExceedLength(amtStr, 14)) {
                buildSTErrorInfo(68, "Block4/:"+name+":", amtStr);
            }
            tags.add(new Tag(name, ccyStr + NumberUtil.formatAmt(new BigDecimal(amtStr), ccyStr)));
        }
    }
}
