package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field52aGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "52A";

    private static String name_D = "52D";

    private static String name_ = "52";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/52a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        if (step50a()) {
            if (!exist50a(tags)) { //不存在50a
                Tag tag = new Tag(name_D, Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                tags.add(tag);
            }
            return;
        }
        String agentPath = "";
        int agentCount = getXmlNodeCounts(null, document, bodyHdrParentElementName + ".Ntfctn.DbtrAgt");
        if (agentCount > 0) {
            agentPath = bodyHdrParentElementName + ".Ntfctn.DbtrAgt";
        } else {
            agentCount = getXmlNodeCounts(null, document, bodyHdrParentElementName + ".Ntfctn.Itm.DbtrAgt");
            if (agentCount > 0) {
                agentPath = bodyHdrParentElementName + ".Ntfctn.Itm.DbtrAgt";
            }
        }
        Tag tag = mx_to_mtAgentGeneric(name_, agentPath, null, false, false, false, null);
        if (tag == null) {
            //POSTC004
            tag = new Tag(name_D, Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
        }
        if (name_D.equals(tag.getName())) {
            String value = mx_to_mtStartingLineCharacter(tag.getValue(), "Block4/:"+name_D+":");
            tag.setValue(value);
        }
        tags.add(tag);
    }


    /**
     * 是否走了 Field50aGenerate 逻辑
     * @return
     */
    private boolean step50a() {
        boolean flag = true;
        int partyCount = getXmlNodeCounts(null, document, bodyHdrParentElementName + ".Ntfctn.Dbtr.Pty");
        if (partyCount == 0) {
            partyCount = getXmlNodeCounts(null, document, bodyHdrParentElementName + ".Ntfctn.Itm.Dbtr.Pty");
        }
        int agentCount = getXmlNodeCounts(null, document, bodyHdrParentElementName + ".Ntfctn.Dbtr.Agt");
        if (agentCount == 0) {
            agentCount = getXmlNodeCounts(null, document, bodyHdrParentElementName + ".Ntfctn.Itm.Dbtr.Agt");
        }
        if (partyCount == 0 && agentCount == 0) {
            flag = false;
        }
        return flag;
    }
    /**
     * 是否存在50aPath
     * 是否真的产出50a
     */
    private boolean exist50a(List<Tag> tags) {
        boolean flag = false;
        if (tags != null && tags.size() > 0) {
            for (int i=0; i<tags.size(); i++) {
                Tag tag = tags.get(i);
                if (tag.getName().matches("50[CF]?")) {
                    flag = true;
                    break;
                }
            }
        }
        return flag;
    }
}
