package com.brilliance.swift.mx2mt.mt900910.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 * <Ntfctn><Ntry><NtryDtls><TxDtls><Refs><EndToEndId>
 */
public class Field21Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "21";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String endToEndId = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Ntry.NtryDtls.TxDtls.Refs.EndToEndId");
        String instructionId = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Ntry.NtryDtls.TxDtls.Refs.InstrId");
        String value = "";
        if (StringUtil.isNotEmpty(instructionId)) {
            if (instructionId.length() > 16) {
                buildSTErrorInfo(13, "Block4/:21:", instructionId);
                instructionId = instructionId.substring(0, 15) + "+";
            }
            value = instructionId;
        } else if (StringUtil.isNotEmpty(endToEndId)) {
            if (endToEndId.length() > 16) {
                buildSTErrorInfo(13, "Block4/:21:", endToEndId);
                endToEndId = endToEndId.substring(0, 15) + "+";
            }
            value = endToEndId;
        } else {
            value = Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
        }
        if (value.startsWith("/") || value.endsWith("/") || value.contains("//")) {
            buildSTErrorInfo(42, "Block4/:21:", value);
            value = Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
        }
        if (StringUtil.isNotEmpty(value)) {
            tags.add(new Tag(name, value));
        }
    }
}
