package com.brilliance.swift.mx2mt.mt900910.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field52D;
import com.prowidesoftware.swift.model.mx.dic.CreditDebitCode;

import java.util.List;

public class Field52aFor900Generate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "52A";

    private static String name_D = "52D";

    private static String name = "52";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/52a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String cdtDbtInd = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Ntry.CdtDbtInd");
        if (!CreditDebitCode.DBIT.value().equals(cdtDbtInd)) {
            return;
        }
        String agtPath = bodyHdrParentElementName + ".Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt";
        int agentCount = getXmlNodeCounts(null, document, agtPath);
        Tag tag = null;
        if (agentCount > 0) {
           tag = mx_to_mtAgentGeneric(name, agtPath, null, false, false, false, null);
        } else {
            agtPath = bodyHdrParentElementName + ".Ntfctn.Ntry.NtryDtls.TxDtls.RltdPties.Dbtr.Agt";
            String accoutPath = bodyHdrParentElementName + ".Ntfctn.Ntry.NtryDtls.TxDtls.RltdPties.DbtrAcct";
            tag = mx_to_mtAgentGeneric(name, agtPath, accoutPath, false, false, false,null);
        }
        if (tag != null) {
            if (name_D.equals(tag.getName())) {
                Field52D field52D = (Field52D)tag.asField();
                if (Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE.equals(field52D.getNameAndAddress()) && StringUtil.isEmpty(field52D.getAccount())){
                    buildSTErrorInfo(67, "Block4/52a", null);
                    return;
                }
            }
            tags.add(tag);
        }
    }
}
