package com.brilliance.swift.mx2mt.mt900910.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field52D;
import com.prowidesoftware.swift.model.mx.dic.CreditDebitCode;

import java.util.List;

//<Ntfctn><Ntry><NtryDtls><TxDtls><RltdPties><Dbtr><Pty><Id><OrgId><AnyBIC>
public class Field52aFor910Generate extends AbstractMx2MtTagsGenerate {


    private static String name_A = "52A";

    private static String name_D = "52D";

    private static String name = "52";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/52a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String cdtDbtInd = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Ntry.CdtDbtInd");
        if (!CreditDebitCode.CRDT.value().equals(cdtDbtInd)) {
            return;
        }
        String agtPath = bodyHdrParentElementName + ".Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt";
        Tag tag = mx_to_mtAgentGeneric(name, agtPath, null, false, false, false, null);
        if (tag != null) {
            //mapping转换文档 Translation Post Conditions -> POSTC0003
            if (name_D.equals(tag.getName())) {
                Field52D field52D = (Field52D)tag.asField();
                if (exist50a(tags) && Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE.equals(field52D.getNameAndAddress()) && StringUtil.isEmpty(field52D.getAccount())){
                    buildSTErrorInfo(67, "Block4/52a", null);
                    return;
                }
            }
            tags.add(tag);
        } else {
            //mapping转换文档 Translation Post Conditions -> POSTC0006
            if (!exist50a(tags)) {
                tag = new Tag(name_D, Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                tags.add(tag);
            }
        }
    }

    /**
     * 判断是否存在50a
     * @param tags
     * @return
     */
    private boolean exist50a(List<Tag> tags) {
        boolean flag = false;
        if (tags != null && tags.size() > 0) {
            for (int i=0; i<tags.size(); i++) {
                Tag tag = tags.get(i);
                if (tag.getName().matches("50[AFK]")) {
                    flag = true;
                    break;
                }
            }
        }
        return flag;
    }
}
