package com.brilliance.swift.mx2mt.mt920.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Field25Generate extends AbstractMx2MtTagsGenerate {

    private static String NAME = "25";

    private int index = -1; //存在多个域循环, 表示xml节点的下标.

    public Field25Generate(int index) {
        this.index = index;
    }

    @Override
    public void tagGenerate() throws SwiftException {
        if (index > -1) {
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            String iban = getXmlNodeValue(bodyHdrParentElementName, document, "RptgReq("+index+").Acct.Id.IBAN");
            String acctId = getXmlNodeValue(bodyHdrParentElementName, document, "RptgReq("+index+").Acct.Id.Othr.Id");
            String account = StringUtil.isNotEmpty(iban) ? iban : acctId;
            if (StringUtil.isNotEmpty(account)) {
                tags.add(new Tag(NAME, account));
            }
        }
    }
}
