package com.brilliance.swift.mx2mt.mt940950.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 * <Stmt><Acct><Id><IBAN>
 * <Stmt><Acct><Id><Othr><Id>
 */
public class Field25aGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "25";

    private static String name_P = "25P";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String iban = getXmlNodeValue(bodyHdrParentElementName, document, "Stmt.Acct.Id.IBAN");
        String acctId = getXmlNodeValue(bodyHdrParentElementName, document, "Stmt.Acct.Id.Othr.Id");
        String account = StringUtil.isNotEmpty(iban) ? iban : acctId;
        String bicCode = getXmlNodeValue(bodyHdrParentElementName, document, "Stmt.Acct.Ownr.Id.OrgId.AnyBIC");
        String receiveCode = (String) context.get(Mx2MtContextIdentifier.MX_RECEIVER_BIC, true);
        String value = "";
        if (StringUtil.isNotEmpty(bicCode) && !bicCode.equals(receiveCode)) {
            if (StringUtil.isNotEmpty(account)) {
                value = account + Mx2MtConstants.NEW_LINE + bicCode;
            } else {
                value = bicCode;
            }
            tags.add(new Tag(name_P, value));
        } else {
            value = account;
            if (StringUtil.isNotEmpty(value)) {
                tags.add(new Tag(name, value));
            }
        }
    }
}
