package com.brilliance.swift.mx2mt.mt941942.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field28CGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "28C";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String value = "";
        String elctrncSeqNbStr = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.ElctrncSeqNb");
        String lglSeqNbStr = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.LglSeqNb");
        //Translation Preconditions/PREC001
        if (StringUtil.isEmpty(lglSeqNbStr) || lglSeqNbStr.length() > 5) {
            if (StringUtil.isEmpty(elctrncSeqNbStr) || elctrncSeqNbStr.length() > 5) {
                buildSTErrorInfo(83, "Block4/:28C:", null);
                return;
            }
        }
        String pageNumber = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.RptPgntn.PgNb");
        if (StringUtil.isNotEmpty(lglSeqNbStr) && lglSeqNbStr.length() <= 5) {
            value = lglSeqNbStr + "/" + pageNumber;
        } else {
            value = elctrncSeqNbStr + "/" + pageNumber;
        }
        tags.add(new Tag(name, value));
    }
}
