package com.brilliance.swift.mx2mt.mt941942.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

/**

 */
public class Field90CGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "90C";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String creditEntrySum = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.TxsSummry.TtlCdtNtries.Sum");
        String creditEntryNum = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.TxsSummry.TtlCdtNtries.NbOfNtries");
        if(StringUtil.isEmpty(creditEntrySum) && StringUtil.isEmpty(creditEntryNum)) {
            return;
        }
        String currency = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.Acct.Ccy");
        if(StringUtil.isNotEmpty(creditEntrySum) && StringUtil.isNotEmpty(creditEntryNum)) {
            if (NumberUtil.judgeAmtStrExceedLength(creditEntrySum, 14)) {
                buildSTErrorInfo(97, "Block4/:90C:", creditEntrySum);
            } else if(creditEntryNum.length() > 5){
                buildSTErrorInfo(96, "Block4/:90C:", creditEntryNum);
            } else {
                String amt = NumberUtil.formatAmt(new BigDecimal(creditEntrySum), currency);
                tags.add(new Tag(name,creditEntryNum+currency+amt));
            }
        }else {
            buildSTErrorInfo(99, "Block4/:90C:","");
        }
    }
}
