package com.brilliance.swift.mx2mt.mt941942.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

/**

 */
public class Field90DGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "90D";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String debitEntrySum = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.TxsSummry.TtlDbtNtries.Sum");
        String debitEntryNum = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.TxsSummry.TtlDbtNtries.NbOfNtries");
        if(StringUtil.isEmpty(debitEntrySum) && StringUtil.isEmpty(debitEntryNum)) {
            return;
        }
        String currency = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.Acct.Ccy");
        if(StringUtil.isNotEmpty(debitEntrySum) && StringUtil.isNotEmpty(debitEntryNum)) {
            if (NumberUtil.judgeAmtStrExceedLength(debitEntrySum, 14)) {
                buildSTErrorInfo(97, "Block4/:90D:", debitEntrySum);
            } else if(debitEntryNum.length() > 5){
                buildSTErrorInfo(96, "Block4/:90D:", debitEntryNum);
            } else {
                String amt = NumberUtil.formatAmt(new BigDecimal(debitEntrySum), currency);
                tags.add(new Tag(name,debitEntryNum+currency+amt));
            }
        } else {
            buildSTErrorInfo(98, "Block4/:90D:","");
        }
    }
}
