package com.brilliance.swift.mx2mt.mtn99.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.MxMtReasonCodeInfo;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.ArrayList;
import java.util.List;

public class Field79Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "79";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/:79:");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        List<String> mt79List = new ArrayList<>();
        List<MxMtReasonCodeInfo> mxMtReasonCodeInfos = SwiftTransferUtil.getMxMtReasonCodes();
        String mxAddtlInf = "";
        int addtlInfCount = getXmlNodeCounts(bodyHdrParentElementName, document, "TxInfAndSts.StsRsnInf.AddtlInf");
        if (addtlInfCount > 0) {
            mxAddtlInf = getXmlNodeValue(bodyHdrParentElementName, document, "TxInfAndSts.StsRsnInf.AddtlInf(0)");
            if (addtlInfCount > 1) {
                for (int i=1; i<addtlInfCount; i++) {
                    if (i == 2) break; //最多只取2行数据
                    String tmpAddtlInf = getXmlNodeValue(bodyHdrParentElementName, document, "TxInfAndSts.StsRsnInf.AddtlInf(" + i + ")");
                    if (mxAddtlInf.length() > 104) {
                        mxAddtlInf += tmpAddtlInf;
                    } else {
                        mxAddtlInf += " " + tmpAddtlInf;
                    }
                }
            }
        }
        mt79List.add("/REJT/99");
        String mtLine2 = "";
        String mtLine6 = "";
        String mxReasonCode = getXmlNodeValue(bodyHdrParentElementName, document, "TxInfAndSts.StsRsnInf.Rsn.Cd");
        String mxReasonProprietary = getXmlNodeValue(bodyHdrParentElementName, document, "TxInfAndSts.StsRsnInf.Rsn.Prtry");
        if (StringUtil.isNotEmpty(mxReasonCode)) {
            mtLine2 = subFunctionReasonCodeTranslation(mxReasonCode, mxMtReasonCodeInfos);
        } else if (StringUtil.isNotEmpty(mxReasonProprietary)) {
            mtLine2 = "/XT99/" + mxReasonProprietary + "/";
        }
        mtLine2 += mxAddtlInf;
        if (mtLine2.length() > 50) {
            mtLine6 = "/TEXT/" + mtLine2.substring(50);
            mtLine2 = mtLine2.substring(0, 50);
        }
        if (StringUtil.isNotEmpty(mtLine2)) {
            mt79List.add(mtLine2);
        }
        String orgMsgId = getXmlNodeValue(bodyHdrParentElementName, document, "TxInfAndSts.OrgnlGrpInf.OrgnlMsgId");
        String mtLine3 = "/MREF/" + subFunctionIDTruncation(orgMsgId, true);
        mt79List.add(mtLine3);
        String orgEndToEndId = getXmlNodeValue(bodyHdrParentElementName, document, "TxInfAndSts.OrgnlEndToEndId");
        if (StringUtil.isNotEmpty(orgEndToEndId)) {
            String mtLine4 = "/TREF/" + subFunctionIDTruncation(orgEndToEndId, false);
            mt79List.add(mtLine4);
        }
        //没有mtLine5
        String mtUetr = "";
        //是否有UETR
        String uetr = getXmlNodeValue(bodyHdrParentElementName, document, "TxInfAndSts.OrgnlUETR");
        if (StringUtil.isNotEmpty(uetr)) {
            mtUetr = "/UETR/" + uetr;
        }
        if (StringUtil.isNotEmpty(mtLine6)) {
            mt79List.add(mtLine6);
            if (StringUtil.isNotEmpty(mtUetr)) {
                mt79List.add("//" + mtUetr);
            }
        } else {
            mt79List.add("/TEXT/" + mtUetr);
        }
        if (mt79List.size() > 0) {
            List<String> list = new ArrayList<>();
            for (int i=0; i<mt79List.size(); i++) {
                String mt72FullField = mt79List.get(i);
                List<String> tmplist = StringUtil.outStringList(mt72FullField, 50, "//");
                list.addAll(tmplist);
            }
            String value = "";
            for (int i=0; i<list.size(); i++) {
                if (i == 35) break;
                if (i == 0) {
                    value = list.get(i);
                } else {
                    value += Mx2MtConstants.NEW_LINE + list.get(i);
                }
            }
            value = mx_to_mtStartingLineCharacter(value, "Block4/:79:");
            tags.add(new Tag(name, value));
        }

    }
}
