package com.brilliance.swift.swiftdto2mt.mt103.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.CategoryPurpose;
import com.brilliance.swift.vo.common.InstructionForCreditAgent;
import com.brilliance.swift.vo.common.ServiceLevel;
import com.brilliance.swift.vo.common.ServiceLevelCode;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;


public class Tag23EGenerate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "23E";

    @Override
    public void tagGenerate() throws SwiftException {
        VoCustomerCreditTransfer customerCreditTransfer = (VoCustomerCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        ServiceLevel serviceLevel = customerCreditTransfer.getServiceLevel();
        if (serviceLevel != null && ServiceLevelCode.SDVA.equals(serviceLevel.getCode())) {
            tags.add(new Tag(name, serviceLevel.getCode().value()));
        }
        CategoryPurpose categoryPurpose = customerCreditTransfer.getCategoryPurpose();
        if (categoryPurpose != null && categoryPurpose.getCode() != null) {
            tags.add(new Tag(name, categoryPurpose.getCode().value()));
        }
        InstructionForCreditAgent instForCrdAgt = customerCreditTransfer.getInstForCrdAgt();
        if (instForCrdAgt != null && instForCrdAgt.getCode() != null) {
            String value = instForCrdAgt.getCode().value();
            if (StringUtil.isNotEmpty(instForCrdAgt.getInstrInf())) {
                value += "/" + instForCrdAgt.getInstrInf();
            }
            tags.add(new Tag(name, value));
        }
    }
}
