package com.brilliance.swift.swiftdto2mt.mt103.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PurposeChoice;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;


public class Tag26TGenerate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "26T";

    @Override
    public void tagGenerate() throws SwiftException {
        VoCustomerCreditTransfer customerCreditTransfer = (VoCustomerCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        PurposeChoice purposeChoice = customerCreditTransfer.getPurposeChoice();
        if (purposeChoice != null && StringUtil.isNotEmpty(purposeChoice.getProprietary())) {
            tags.add(new Tag(name, purposeChoice.getProprietary()));
        }
    }
}
