package com.brilliance.swift.swiftdto2mt.mt202.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.brilliance.swift.vo.common.ExternalCreditorAgentInstructionCode;
import com.brilliance.swift.vo.common.InstructionForCreditAgent;
import com.brilliance.swift.vo.common.InstructionForNextAgent;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mx.dic.Instruction4Code;

import java.util.ArrayList;
import java.util.List;

public class Tag72Generate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "72";

    @Override
    public void tagGenerate() throws SwiftException {
        VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = (VoFinancialInstitutionCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        List<String> list = new ArrayList<>();
        PartyDto preInstgAgtParty = financialInstitutionCreditTransfer.getPreInstgAgtParty();
        if (preInstgAgtParty != null) {
            String bicCode = preInstgAgtParty.getPartyBic();
            String name = preInstgAgtParty.getPartyName();
            if (StringUtil.isNotEmpty(bicCode)) {
                bicCode = Mx2MtConstants.INS + bicCode;
                list.addAll(StringUtil.outStringList(bicCode, 35, "//"));
            } else if (StringUtil.isNotEmpty(name)) {
                name = Mx2MtConstants.INS + name;
                list.addAll(StringUtil.outStringList(name, 35, "//"));
            }
        }
        InstructionForCreditAgent instForCrdAgt = financialInstitutionCreditTransfer.getInstForCrdAgt();
        if (instForCrdAgt != null) {
            ExternalCreditorAgentInstructionCode code = instForCrdAgt.getCode();
            if (code == null) {
                String instrInfo = Mx2MtConstants.ACC + instForCrdAgt.getInstrInf();
                list.addAll(StringUtil.outStringList(instrInfo, 35, "//"));
            } else if (ExternalCreditorAgentInstructionCode.PHOB.equals(code)
                        || ExternalCreditorAgentInstructionCode.TELB.equals(code)) {
                String instrInfo = Mx2MtConstants.PHONBEN + instForCrdAgt.getInstrInf();
                list.addAll(StringUtil.outStringList(instrInfo, 35, "//"));
            }
        }
        InstructionForNextAgent instForNxtAgt = financialInstitutionCreditTransfer.getInstForNxtAgt();
        if (instForNxtAgt != null) {
            Instruction4Code code = instForNxtAgt.getCode();
            if (code == null) {
                String instrInfo = Mx2MtConstants.REC + instForNxtAgt.getInstrInf();
                list.addAll(StringUtil.outStringList(instrInfo, 35, "//"));
            } else if (Instruction4Code.TELA.equals(code)) {
                String instrInfo = Mx2MtConstants.TELE + instForNxtAgt.getInstrInf();
                list.addAll(StringUtil.outStringList(instrInfo, 35, "//"));
            } else if (Instruction4Code.PHOA.equals(code)) {
                String instrInfo = "";
                if (financialInstitutionCreditTransfer.getIntrmyAgtParty() != null) {
                    instrInfo = Mx2MtConstants.PHONIBK + instForNxtAgt.getInstrInf();
                } else {
                    instrInfo = Mx2MtConstants.PHON + instForNxtAgt.getInstrInf();
                }
                list.addAll(StringUtil.outStringList(instrInfo, 35, "//"));
            }
        }
        String value = "";
        for (int i=0; i<list.size(); i++) {
            if (i == 6) break;
            if (i == 0) {
                value += list.get(i);
            } else {
                value += Mx2MtConstants.NEW_LINE + list.get(i);
            }
        }
        if (StringUtil.isNotEmpty(value)) {
            tags.add(new Tag(name, value));
        }
    }
}

