package com.brilliance.swift.swiftdto2mt.mt202.impl.cov;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;


public class Tag56Generate extends AbstractSwiftDto2MtTagGenerate {

    private String name_A = "56A";

    private String name_C = "56C";

    private String name_D = "56D";

    @Override
    public void tagGenerate() throws SwiftException {
        VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = (VoFinancialInstitutionCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        VoCustomerCreditTransfer customerCreditTransfer = financialInstitutionCreditTransfer.getUnderCustomerCreditTransfer();
        if (customerCreditTransfer == null) return;
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        PartyDto intrymyAgtParty = customerCreditTransfer.getIntrmyAgtParty();
        if (intrymyAgtParty != null) {
            String account = getAccount(intrymyAgtParty);
            String bicCode = intrymyAgtParty.getPartyBic();
            String name = intrymyAgtParty.getPartyName();
            String value = "";
            if (StringUtil.isNotEmpty(bicCode)) {
                value = bicCode;
                if (StringUtil.isNotEmpty(account)) {
                    value = account + Mx2MtConstants.NEW_LINE + bicCode;
                }
                tags.add(new Tag(name_A, value));
            } else if (StringUtil.isNotEmpty(name)) {
                if (name.length() > 35) name = name.substring(0, 35);
                if (StringUtil.isNotEmpty(account)) {
                    value = account + Mx2MtConstants.NEW_LINE + name;
                } else {
                    value = name;
                }
                List<String> addressList = intrymyAgtParty.getAddressList();
                for (int i=0; i<addressList.size(); i++) {
                    if (i == 3) break;
                    String address = addressList.get(i);
                    if (address.length() > 35) address = address.substring(0, 35);
                    value += Mx2MtConstants.NEW_LINE + address;
                }
                tags.add(new Tag(name_D, value));
            } else {
                tags.add(new Tag(name_C, account));
            }
        }
    }
}
