package com.brilliance.swift.swiftdto2mt.mt900910.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.BankToCustomerDebitCreditNotification;
import com.brilliance.swift.vo.common.TransactionReference;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;


public class Tag21Generate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "21";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = (BankToCustomerDebitCreditNotification)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            TransactionReference txnRef = bankToCustomerDebitCreditNotification.getTxnRef();
            if (txnRef != null && StringUtil.isNotEmpty(txnRef.getEndToEndId())) {
                tags.add(new Tag(name, txnRef.getEndToEndId()));
            }
        }catch (Exception e){
            throw new SwiftException(e.getMessage());
        }
    }
}
