package com.brilliance.swift.swiftdto2mt.mt900910.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.vo.BankToCustomerDebitCreditNotification;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;


public class Tag25aGenerate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "25";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = (BankToCustomerDebitCreditNotification)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            if(bankToCustomerDebitCreditNotification.getAccount().getAccount()!=null){
                tags.add(new Tag(name, bankToCustomerDebitCreditNotification.getAccount().getAccount()));
            }else if(bankToCustomerDebitCreditNotification.getAccount().getIbanAcct()!=null){
                tags.add(new Tag(name, bankToCustomerDebitCreditNotification.getAccount().getIbanAcct()));
            }
        }catch (Exception e){
            throw new SwiftException(e.getMessage());
        }

    }
}
