package com.brilliance.swift.swiftdto2mt.mt940950.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.BankToCustomerStatement;
import com.brilliance.swift.vo.common.ClearingSystemMember;
import com.brilliance.swift.vo.common.ClearingSystemMemberCode;
import com.brilliance.swift.vo.common.PartyAccount;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;


public class Tag25aGenerate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "25";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            BankToCustomerStatement bankToCustomerStatement = (BankToCustomerStatement)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            if(bankToCustomerStatement.getAccount()!=null){
                PartyDto partyDto = new PartyDto();
                partyDto.setPartyAcct(bankToCustomerStatement.getAccount());
                tags.add(new Tag(name, getAccount(partyDto)));
            }
        }catch (Exception e){
            throw new SwiftException(e.getMessage());
        }
    }

    protected String getAccount(PartyDto partyDto) {
        if (partyDto == null) {
            return null;
        }
        String account = "";
        ClearingSystemMember clrSysMmb = partyDto.getClrSysMmb();
        if (clrSysMmb != null) {
            ClearingSystemMemberCode memberCode = getClsSysMemberByValue(clrSysMmb.getCode());
            if (memberCode != null) {
                account = "//" + memberCode.desc();
            } else {
                account = "//" + clrSysMmb.getCode();
            }
            account += clrSysMmb.getId();
        } else {
            PartyAccount partyAcct = partyDto.getPartyAcct();
            if (partyAcct != null) {
                if ("CUID".equals(partyAcct.getAcctType())) {
                    account = "//CH" + partyAcct.getAccount();
                } else {
                    account = (StringUtil.isNotEmpty(partyAcct.getIbanAcct()) ? partyAcct.getIbanAcct() : partyAcct.getAccount());
                }
            }
        }
        if (account.length() > 35) {
            account = account.substring(0, 35);
        }
        return account;
    }
}
