package com.brilliance.swift.swiftdto2mt.mt940950.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.BankToCustomerStatement;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;


public class Tag86Generate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "86";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            BankToCustomerStatement bankToCustomerStatement = (BankToCustomerStatement)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            String additionalStatementInformation = bankToCustomerStatement.getAdditionalStatementInformation();
            if(StringUtil.isNotEmpty(additionalStatementInformation)){
                tags.add(new Tag(name, StringUtil.getStringByEnter(additionalStatementInformation, 35, 6)));
            }
        }catch (Exception e){
            throw new SwiftException(e.getMessage());
        }
    }
}
