package com.brilliance.swift.util;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;

import java.io.InputStream;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

public class MessageUtil {

    public static Properties properties = null;

    public static String getPropertyValue(String localCode, String key) {
        try {
            if (properties == null) {
                String fileName = "/Messages_CN.properties";
                if ("US".equals(localCode)) {
                    fileName = "/Messages_US.properties";
                }
                InputStream resourceAsStream = MessageUtil.class.getResourceAsStream(fileName);
                properties = new Properties();
                properties.load(resourceAsStream);
            }
            if (properties != null) {
                return properties.getProperty(key, key);
            }
            return key;
        } catch (Exception e) {
            properties = null;
            throw new SwiftException(e.getMessage());
        }
    }

    public static void showMaps(Map<String, Object> maps, StringBuilder sb) {
        Set<String> keys = maps.keySet();
        for (String key : keys) {
            if (maps.get(key) instanceof Map) {
                sb//.append(Mx2MtConstants.NEW_LINE)
                  .append(key).append(":")
                  .append(Mx2MtConstants.NEW_LINE);
                Map<String, Object> newMaps = (Map<String, Object>)maps.get(key);
                showMaps(newMaps, sb);
            } else {
                sb.append(key).append(":").append(maps.get(key)).append(Mx2MtConstants.NEW_LINE);
            }
        }
    }

    /*public static void main(String[] args) {
        TemplateEngine engine = TemplateUtil.createEngine(new TemplateConfig(CharsetUtil.CHARSET_GBK, "template", TemplateConfig.ResourceMode.CLASSPATH));
        Template template = engine.getTemplate("template/pacs008001.vm");
        Map<String, Object> maps = new HashMap<>();
        maps.put("name", "程");
        //maps.put("name1", "");
        String result = template.render(maps);
        System.out.println(result);
    }*/
}
