package com.brilliance.swift.vo;

import com.brilliance.swift.util.DateUtil;
import com.google.gson.*;

import java.lang.reflect.Type;
import java.text.ParseException;
import java.util.Date;

public class DateAdapter implements JsonSerializer<Date>, JsonDeserializer<Date> {

    private static final String DATE_FORMAT = "yyyy-MM-dd HH:mm:ss,SSS";

    @Override
    public Date deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
        try {
            return DateUtil.parseDate(json.getAsString(), DATE_FORMAT);
        } catch (ParseException e) {
            throw new JsonParseException(e.getMessage());
        }
    }

    @Override
    public JsonElement serialize(Date src, Type typeOfSrc, JsonSerializationContext context) {
        String dateStr = DateUtil.format(src, DATE_FORMAT);
        return new JsonPrimitive(dateStr);
    }
}
