package com.brilliance.swift.vo;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.util.StringUtil;

public class SwiftTranslationErrorInfo {

    private long id;

    private String code;

    private String category;

    private String location;

    @Deprecated
    private String errorCode;

    private String description;

    @Deprecated
    private String errorType;

    private String originalValue;

    public String getErrorCode() {
        return errorCode;
    }

    public void setErrorCode(String errorCode) {
        this.errorCode = errorCode;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getErrorType() {
        return errorType;
    }

    public void setErrorType(String errorType) {
        this.errorType = errorType;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public String getOriginalValue() {
        return originalValue;
    }

    public void setOriginalValue(String originalValue) {
        this.originalValue = originalValue;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    @Override
    public String toString() {
        String info = "";
        if (StringUtil.isNotEmpty(location)) {
            info += location + Mx2MtConstants.NEW_LINE + " - ";
        }
        info += "Translation: " + category + "." + code + ": " + description;
        if (StringUtil.isNotEmpty(originalValue)) {
            if (ERROR.T0000T.equals(code)
                || ERROR.T0000R.equals(code)
                || ERROR.T0000L.equals(code)) {
                info += Mx2MtConstants.NEW_LINE + "Value " + originalValue + " has been altered.";
            } else if (ERROR.T0000M.equals(code)) {
                info += Mx2MtConstants.NEW_LINE + "Value " + originalValue + " has been dropped.";
            } else {
                info += Mx2MtConstants.NEW_LINE + "Original Value is " + originalValue;
            }
        }
        return info;
    }
}
