package com.brilliance.swift.vo;

import com.brilliance.swift.vo.common.*;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Mapping pacs.008.001.xx
 */
public class VoCustomerCreditTransfer extends SwiftDto {

    protected TransactionReference txnRef;

    protected Date debitDate;

    protected Date creditDate;

    protected Date clsDate;

    protected ServiceLevel serviceLevel;

    protected CategoryPurpose categoryPurpose;

    protected PurposeChoice purposeChoice;

    protected Date settledDate;

    protected CcyFormatAmount settledCcyFormatAmount;

    protected CcyFormatAmount instructedCcyFormatAmount;

    protected BigDecimal exchangeRate;

    protected SettlementMethodCode settlementMethodCode;

    protected PartyAccount settleAccount;//appear 53B

    protected PartyDto debitParty;

    protected PartyDto debitAgtParty;

    protected PartyDto instgAgtParty;

    protected PartyDto instdAgtParty;

    protected PartyDto thridAgtParty;

    protected PartyDto intrmyAgtParty;

    protected PartyDto creditAgtParty;

    protected PartyDto creditParty;

    protected RemittanceInformation remittanceInfo;

    protected ChargeForEnum chargeFor;

    protected List<ChargeInfo> chargeInfos;

    protected PartyDto preInstgAgtParty;

    protected InstructionForCreditAgent instForCrdAgt;

    protected InstructionForNextAgent instForNxtAgt;

    protected List<String> regulatoryReportings;

    public Date getDebitDate() {
        return debitDate;
    }

    public void setDebitDate(Date debitDate) {
        this.debitDate = debitDate;
    }

    public Date getCreditDate() {
        return creditDate;
    }

    public void setCreditDate(Date creditDate) {
        this.creditDate = creditDate;
    }

    public Date getClsDate() {
        return clsDate;
    }

    public void setClsDate(Date clsDate) {
        this.clsDate = clsDate;
    }

    public ServiceLevel getServiceLevel() {
        return serviceLevel;
    }

    public void setServiceLevel(ServiceLevel serviceLevel) {
        this.serviceLevel = serviceLevel;
    }

    public Date getSettledDate() {
        return settledDate;
    }

    public void setSettledDate(Date settledDate) {
        this.settledDate = settledDate;
    }

    public CcyFormatAmount getSettledCcyFormatAmount() {
        return settledCcyFormatAmount;
    }

    public void setSettledCcyFormatAmount(CcyFormatAmount settledCcyFormatAmount) {
        this.settledCcyFormatAmount = settledCcyFormatAmount;
    }

    public CcyFormatAmount getInstructedCcyFormatAmount() {
        return instructedCcyFormatAmount;
    }

    public void setInstructedCcyFormatAmount(CcyFormatAmount instructedCcyFormatAmount) {
        instructedCcyFormatAmount = instructedCcyFormatAmount;
    }

    public BigDecimal getExchangeRate() {
        return exchangeRate;
    }

    public void setExchangeRate(BigDecimal exchangeRate) {
        this.exchangeRate = exchangeRate;
    }

    public ChargeForEnum getChargeFor() {
        return chargeFor;
    }

    public void setChargeFor(ChargeForEnum chargeFor) {
        this.chargeFor = chargeFor;
    }

    public List<String> getRegulatoryReportingList() {
        if (regulatoryReportings == null) {
            regulatoryReportings = new ArrayList<>();
        }
        return this.regulatoryReportings;
    }

    public VoCustomerCreditTransfer addRegulatoryReporting(String regulatoryReporting) {
        getRegulatoryReportingList().add(regulatoryReporting);
        return this;
    }

    public List<ChargeInfo> getChargeInfoList() {
        if (chargeInfos == null) {
            chargeInfos = new ArrayList<>();
        }
        return this.chargeInfos;
    }

    public VoCustomerCreditTransfer addChargeInfo(ChargeInfo chargeInfo) {
        getChargeInfoList().add(chargeInfo);
        return this;
    }

    public PartyDto getDebitParty() {
        return debitParty;
    }

    public void setDebitParty(PartyDto debitParty) {
        this.debitParty = debitParty;
    }

    public PartyDto getDebitAgtParty() {
        return debitAgtParty;
    }

    public void setDebitAgtParty(PartyDto debitAgtParty) {
        this.debitAgtParty = debitAgtParty;
    }

    public PartyDto getInstgAgtParty() {
        return instgAgtParty;
    }

    public void setInstgAgtParty(PartyDto instgAgtParty) {
        this.instgAgtParty = instgAgtParty;
    }

    public PartyDto getInstdAgtParty() {
        return instdAgtParty;
    }

    public void setInstdAgtParty(PartyDto instdAgtParty) {
        this.instdAgtParty = instdAgtParty;
    }

    public PartyDto getThridAgtParty() {
        return thridAgtParty;
    }

    public void setThridAgtParty(PartyDto thridAgtParty) {
        this.thridAgtParty = thridAgtParty;
    }

    public PartyDto getIntrmyAgtParty() {
        return intrmyAgtParty;
    }

    public void setIntrmyAgtParty(PartyDto intrmyAgtParty) {
        this.intrmyAgtParty = intrmyAgtParty;
    }

    public PartyDto getCreditAgtParty() {
        return creditAgtParty;
    }

    public void setCreditAgtParty(PartyDto creditAgtParty) {
        this.creditAgtParty = creditAgtParty;
    }

    public PartyDto getCreditParty() {
        return creditParty;
    }

    public void setCreditParty(PartyDto creditParty) {
        this.creditParty = creditParty;
    }

    public SettlementMethodCode getSettlementMethodCode() {
        return settlementMethodCode;
    }

    public void setSettlementMethodCode(SettlementMethodCode settlementMethodCode) {
        this.settlementMethodCode = settlementMethodCode;
    }

    public PartyAccount getSettleAccount() {
        return settleAccount;
    }

    public void setSettleAccount(PartyAccount settleAccount) {
        this.settleAccount = settleAccount;
    }

    public PartyDto getPreInstgAgtParty() {
        return preInstgAgtParty;
    }

    public void setPreInstgAgtParty(PartyDto preInstgAgtParty) {
        this.preInstgAgtParty = preInstgAgtParty;
    }

    public CategoryPurpose getCategoryPurpose() {
        return categoryPurpose;
    }

    public void setCategoryPurpose(CategoryPurpose categoryPurpose) {
        this.categoryPurpose = categoryPurpose;
    }

    public PurposeChoice getPurposeChoice() {
        return purposeChoice;
    }

    public void setPurposeChoice(PurposeChoice purposeChoice) {
        this.purposeChoice = purposeChoice;
    }

    public RemittanceInformation getRemittanceInfo() {
        return remittanceInfo;
    }

    public void setRemittanceInfo(RemittanceInformation remittanceInfo) {
        this.remittanceInfo = remittanceInfo;
    }

    public InstructionForCreditAgent getInstForCrdAgt() {
        return instForCrdAgt;
    }

    public void setInstForCrdAgt(InstructionForCreditAgent instForCrdAgt) {
        this.instForCrdAgt = instForCrdAgt;
    }

    public InstructionForNextAgent getInstForNxtAgt() {
        return instForNxtAgt;
    }

    public void setInstForNxtAgt(InstructionForNextAgent instForNxtAgt) {
        this.instForNxtAgt = instForNxtAgt;
    }

    public TransactionReference getTxnRef() {
        return txnRef;
    }

    public void setTxnRef(TransactionReference txnRef) {
        this.txnRef = txnRef;
    }
}
