package com.brilliance.swift.vo.common;

public enum StatusReasonCode {

    AB01("AbortedClearingTimeout"),
    AB02("AbortedClearingFatalError"),
    AB03("AbortedSettlementTimeout"),
    AB04("AbortedSettlementFatalError"),
    AB05("TimeoutCreditorAgent"),
    AB06("TimeoutInstructedAgent"),
    AB07("OfflineAgent"),
    AB08("OfflineCreditorAgent"),
    AB09("ErrorCreditorAgent"),
    AB10("ErrorInstructedAgent"),
    AB11("TimeoutDebtorAgent"),
    AC01("IncorrectAccountNumber"),
    AC02("InvalidDebtorAccountNumber"),
    AC03("InvalidCreditorAccountNumber"),
    AC04("ClosedAccountNumber"),
    AC05("ClosedDebtorAccountNumber"),
    AC06("BlockedAccount"),
    AC07("ClosedCreditorAccountNumber"),
    AC08("InvalidBranchCode"),
    AC09("InvalidAccountCurrency"),
    AC10("InvalidDebtorAccountCurrency"),
    AC11("InvalidCreditorAccountCurrency"),
    AC12("InvalidAccountType"),
    AC13("InvalidDebtorAccountType"),
    AC14("InvalidCreditorAccountType"),
    AC15("AccountDetailsChanged"),
    AC16("CardNumberInvalid"),
    AG01("TransactionForbidden"),
    AG02("InvalidBankOperationCode"),
    AG03("TransactionNotSupported"),
    AG04("InvalidAgentCountry"),
    AG05("InvalidDebtorAgentCountry"),
    AG06("InvalidCreditorAgentCountry"),
    AG07("UnsuccesfulDirectDebit"),
    AG08("InvalidAccessRights"),
    AG09("PaymentNotReceived"),
    AG10("AgentSuspended"),
    AG11("CreditorAgentSuspended"),
    AG12("NotAllowedBookTransfer"),
    AG13("ForbiddenReturnPayment"),
    AGNT("IncorrectAgent"),
    AM01("ZeroAmount"),
    AM02("NotAllowedAmount"),
    AM03("NotAllowedCurrency"),
    AM04("InsufficientFunds"),
    AM05("Duplication"),
    AM06("TooLowAmount"),
    AM07("BlockedAmount"),
    AM09("WrongAmount"),
    AM10("InvalidControlSum"),
    AM11("InvalidTransactionCurrency"),
    AM12("InvalidAmount"),
    AM13("AmountExceedsClearingSystemLimit"),
    AM14("AmountExceedsAgreedLimit"),
    AM15("AmountBelowClearingSystemMinimum"),
    AM16("InvalidGroupControlSum"),
    AM17("InvalidPaymentInfoControlSum"),
    AM18("InvalidNumberOfTransactions"),
    AM19("InvalidGroupNumberOfTransactions"),
    AM20("InvalidPaymentInfoNumberOfTransactions"),
    AM21("LimitExceeded"),
    AM22("ZeroAmountNotApplied"),
    AM23("AmountExceedsSettlementLimit"),
    BE01("InconsistenWithEndCustomer"),
    BE04("MissingCreditorAddress"),
    BE05("UnrecognisedInitiatingParty"),
    BE06("UnknownEndCustomer"),
    BE07("MissingDebtorAddress"),
    BE08("MissingDebtorName"),
    BE09("InvalidCountry"),
    BE10("InvalidDebtorCountry"),
    BE11("InvalidCreditorCountry"),
    BE12("InvalidCountryOfResidence"),
    BE13("InvalidDebtorCountryOfResidence"),
    BE14("InvalidCreditorCountryOfResidence"),
    BE15("InvalidIdentificationCode"),
    BE16("InvalidDebtorIdentificationCode"),
    BE17("InvalidCreditorIdentificationCode"),
    BE18("InvalidContactDetails"),
    BE19("InvalidChargeBearerCode"),
    BE20("InvalidNameLength"),
    BE21("MissingName"),
    BE22("MissingCreditorName"),
    BE23("AccountProxyInvalid"),
    CERI("CheckERI"),
    CH03("RequestedExecutionDateOrRequestedCollectionDateTooFarInFuture"),
    CH04("RequestedExecutionDateOrRequestedCollectionDateTooFarInPast"),
    CH07("ElementIsNotToBeUsedAtB-andC-Level"),
    CH09("MandateChangesNotAllowed"),
    CH10("InformationOnMandateChangesMissing"),
    CH11("CreditorIdentifierIncorrect"),
    CH12("CreditorIdentifierNotUnambiguouslyAtTransaction-Level"),
    CH13("OriginalDebtorAccountIsNotToBeUsed"),
    CH14("OriginalDebtorAgentIsNotToBeUsed"),
    CH15("ElementContentIncludesMoreThan140Characters"),
    CH16("ElementContentFormallyIncorrect"),
    CH17("ElementNotAdmitted"),
    CH19("ValuesWillBeSetToNextTARGETday"),
    CH20("DecimalPointsNotCompatibleWithCurrency"),
    CH21("RequiredCompulsoryElementMissing"),
    CH22("COREandB2BwithinOnemessage"),
    CHQC("ChequeSettledOnCreditorAccount"),
    CNOR("CreditorBankIsNotRegistered"),
    CURR("IncorrectCurrency"),
    CUST("RequestedByCustomer"),
    DNOR("DebtorBankIsNotRegistered"),
    DS01("ElectronicSignaturesCorrect"),
    DS02("OrderCancelled"),
    DS03("OrderNotCancelled"),
    DS04("OrderRejected"),
    DS05("OrderForwardedForPostprocessing"),
    DS06("TransferOrder"),
    DS07("ProcessingOK"),
    DS08("DecompressionError"),
    DS09("DecryptionError"),
    DS0A("DataSignRequested"),
    DS0B("UnknownDataSignFormat"),
    DS0C("SignerCertificateRevoked"),
    DS0D("SignerCertificateNotValid"),
    DS0E("IncorrectSignerCertificate"),
    DS0F("SignerCertificationAuthoritySignerNotValid"),
    DS0G("NotAllowedPayment"),
    DS0H("NotAllowedAccount"),
    DS0K("NotAllowedNumberOfTransaction"),
    DS10("Signer1CertificateRevoked"),
    DS11("Signer1CertificateNotValid"),
    DS12("IncorrectSigner1Certificate"),
    DS13("SignerCertificationAuthoritySigner1NotValid"),
    DS14("UserDoesNotExist"),
    DS15("IdenticalSignatureFound"),
    DS16("PublicKeyVersionIncorrect"),
    DS17("DifferentOrderDataInSignatures"),
    DS18("RepeatOrder"),
    DS19("ElectronicSignatureRightsInsufficient"),
    DS20("Signer2CertificateRevoked"),
    DS21("Signer2CertificateNotValid"),
    DS22("IncorrectSigner2Certificate"),
    DS23("SignerCertificationAuthoritySigner2NotValid"),
    DS24("WaitingTimeExpired"),
    DS25("OrderFileDeleted"),
    DS26("UserSignedMultipleTimes"),
    DS27("UserNotYetActivated"),
    DT01("InvalidDate"),
    DT02("InvalidCreationDate"),
    DT03("InvalidNonProcessingDate"),
    DT04("FutureDateNotSupported"),
    DT05("InvalidCutOffDate"),
    DT06("ExecutionDateChanged"),
    DU01("DuplicateMessageID"),
    DU02("DuplicatePaymentInformationID"),
    DU03("DuplicateTransaction"),
    DU04("DuplicateEndToEndID"),
    DU05("DuplicateInstructionID"),
    DUPL("DuplicatePayment"),
    ED01("CorrespondentBankNotPossible"),
    ED03("BalanceInfoRequest"),
    ED05("SettlementFailed"),
    ED06("SettlementSystemNotAvailable"),
    ERIN("ERIOptionNotSupported"),
    FF01("InvalidFileFormat"),
    FF02("SyntaxError"),
    FF03("InvalidPaymentTypeInformation"),
    FF04("InvalidServiceLevelCode"),
    FF05("InvalidLocalInstrumentCode"),
    FF06("InvalidCategoryPurposeCode"),
    FF07("InvalidPurpose"),
    FF08("InvalidEndToEndId"),
    FF09("InvalidChequeNumber"),
    FF10("BankSystemProcessingError"),
    FF11("ClearingRequestAborted"),
    G000("PaymentTransferredAndTracked"),
    G001("PaymentTransferredAndNotTracked"),
    G002("CreditDebitNotConfirmed"),
    G003("CreditPendingDocuments"),
    G004("CreditPendingFunds"),
    G005("DeliveredWithServiceLevel"),
    G006("DeliveredWIthoutServiceLevel"),
    ID01("CorrespondingOriginalFileStillNotSent"),
    MD01("NoMandate"),
    MD02("MissingMandatoryInformationInMandate"),
    MD05("CollectionNotDue"),
    MD06("RefundRequestByEndCustomer"),
    MD07("EndCustomerDeceased"),
    MS02("NotSpecifiedReasonCustomerGenerated"),
    MS03("NotSpecifiedReasonAgentGenerated"),
    NARR("Narrative"),
    NERI("NoERI"),
    RC01("BankIdentifierIncorrect"),
    RC02("InvalidBankIdentifier"),
    RC03("InvalidDebtorBankIdentifier"),
    RC04("InvalidCreditorBankIdentifier"),
    RC05("InvalidBICIdentifier"),
    RC06("InvalidDebtorBICIdentifier"),
    RC07("InvalidCreditorBICIdentifier"),
    RC08("InvalidClearingSystemMemberIdentifier"),
    RC09("InvalidDebtorClearingSystemMemberIdentifier"),
    RC10("InvalidCreditorClearingSystemMemberIdentifier"),
    RC11("InvalidIntermediaryAgent"),
    RC12("MissingCreditorSchemeId"),
    RCON("RMessageConflict"),
    RECI("ReceiverCustomerInformation"),
    RF01("NotUniqueTransactionReference"),
    RR01("MissingDebtorAccountOrIdentification"),
    RR02("MissingDebtorNameOrAddress"),
    RR03("MissingCreditorNameOrAddress"),
    RR04("RegulatoryReason"),
    RR05("RegulatoryInformationInvalid"),
    RR06("TaxInformationInvalid"),
    RR07("RemittanceInformationInvalid"),
    RR08("RemittanceInformationTruncated"),
    RR09("InvalidStructuredCreditorReference"),
    RR10("InvalidCharacterSet"),
    RR11("InvalidDebtorAgentServiceID"),
    RR12("InvalidPartyID"),
    S000("ValidRequestForCancellationAcknowledged"),
    S001("UETRFlaggedForCancellation"),
    S002("NetworkStopOfUETR"),
    S003("RequestForCancellationForwarded"),
    S004("RequestForCancellationDeliveryAcknowledgement"),
    SL01("SpecificServiceOfferedByDebtorAgent"),
    SL02("SpecificServiceOfferedByCreditorAgent"),
    SL03("ServiceofClearingSystem"),
    SL11("CreditorNotOnWhitelistOfDebtor"),
    SL12("CreditorOnBlacklistOfDebtor"),
    SL13("MaximumNumberOfDirectDebitTransactionsExceeded"),
    SL14("MaximumDirectDebitTransactionAmountExceeded"),
    TA01("TransmissonAborted"),
    TD01("NoDataAvailable"),
    TD02("FileNonReadable"),
    TD03("IncorrectFileStructure"),
    TK01("TokenInvalid"),
    TK02("SenderTokenNotFound"),
    TK03("ReceiverTokenNotFound"),
    TK09("TokenMissing"),
    TKCM("TokenCounterpartyMismatch"),
    TKSG("TokenSingleUse"),
    TKSP("TokenSuspended"),
    TKVE("TokenValueLimitExceeded"),
    TKXP("TokenExpired"),
    TM01("InvalidCutOffTime"),
    TS01("TransmissionSuccessful"),
    TS04("TransferToSignByHand"),
    CN01("AuthorisationCancelled"),
    FOCR("FollowingCancellationRequest"),
    FR01("Fraud"),
    NOCM("NotCompliantGeneric"),
    NOAS("NoAnswerFromCustomer"),
    RUTA("ReturnUponUnableToApply"),
    UPAY("UnduePayment"),
    ALAC("AlreadyAcceptedRTP"),
    AEXR("AlreadyExpiredRTP"),
    ARFR("AlreadyRefusedRTP"),
    ARJR("AlreadyRejectedRTP"),
    ATNS("AttachementsNotSupported"),
    EDTR("ExpiryDateTimeReached"),
    EDTL("ExpiryDateTooLong"),
    FRAD("FraudulentOrigin"),
    IEDT("IncorrectExpiryDateTime"),
    IRNR("InitialRTPNeverReceived"),
    NOAR("NonAgreedRTP"),
    NOPG("NoPaymentGuarantee"),
    NRCH("PayerOrPayerRTPSPNotReachable"),
    RTNS("RTPNotSupportedForDebtor"),
    REPR("RTPReceivedCanBeProcessed"),
    SPII("RTPServiceProviderIdentifierIncorrect"),
    PINS("TypeOfPaymentInstrumentNotSupported"),
    UCRD("UnknownCreditor"),
    FF12("OriginalTransactionNotEligibleForRequestedReturn"),
    FF13("RequestForCancellationNotFound");

    StatusReasonCode(String s) {}
    public String value() {
        return name();
    }
}
