package com.brilliance;

import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.SwiftTranslationErrorInfo;
import com.brilliance.swift.vo.SwiftTranslationReport;
import org.apache.commons.io.FileUtils;
import org.junit.Test;

import java.io.File;
import java.util.List;
import java.util.Map;

public class Mt2MxTest {

    public void printSwiftTranslationReport(SwiftTranslationReport str) {
        if (str != null) {
            String errorDsp = "";
            List<SwiftTranslationErrorInfo> errorInfos = str.getErrorInfos();
            if (errorInfos != null && errorInfos.size() > 0) {
                for (int i=0; i<errorInfos.size(); i++) {
                    SwiftTranslationErrorInfo errorInfo = errorInfos.get(i);
                    errorDsp += errorInfo.getErrorType()
                            + "-" + errorInfo.getErrorCode()
                            + ":" + errorInfo.getDescription();
                    if (StringUtil.isNotEmpty(errorInfo.getLocation())) {
                        errorDsp += ";Occur in the " + errorInfo.getLocation();
                    }
                    if (StringUtil.isNotEmpty(errorInfo.getOriginalValue())) {
                        errorDsp += ";Original Value is " + errorInfo.getOriginalValue();
                    }
                    errorDsp += Mx2MtConstants.NEW_LINE;
                }
            }
            if (StringUtil.isNotEmpty(errorDsp)) {
                System.out.println(errorDsp);
            }
            System.out.println(str.getMessage());
        }
    }

    public void test(String source, Map<String, Object> extraMap) {
        File file = FileUtils.toFile(Mx2MtTest.class.getResource(source));
        SwiftTranslationReport str = SwiftTransfer.mt2MxPlus(file, null, extraMap);
        printSwiftTranslationReport(str);
    }

    @Test
    public void testPacs008001() {
        test("/swiftTxt/MT103.txt", null);
    }

    @Test
    public void testCamt053001() {
        test("/swiftTxt/MT950.txt", null);
    }

    @Test
    public void testCamt054001() {
        test("/swiftTxt/MT910.txt", null);
    }

    @Test
    public void testCamt056001_1() {
        test("/swiftTxt/MT192.txt", null);
    }

    @Test
    public void testCamt029001_1() {
        test("/swiftTxt/MT196.txt", null);
    }

    @Test
    public void testCamt057001() {
        test("/swiftTxt/MT210.txt", null);
    }

}
