
package com.prowidesoftware.swift.model.mx;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.dic.AcknowledgementDetails1Choice;
import com.prowidesoftware.swift.model.mx.dic.PayInEventAcknowledgementV02;
import com.prowidesoftware.swift.model.mx.dic.SupplementaryData1;
import com.prowidesoftware.swift.model.mx.dic.SupplementaryDataEnvelope1;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;


/**
 * Class for camt.063.001.02 ISO 20022 message.
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
    "payInEvtAck"
})
@XmlRootElement(name = "Document", namespace = "urn:iso:std:iso:20022:tech:xsd:camt.063.001.02")
public class MxCamt06300102
    extends AbstractMX
{

    @XmlElement(name = "PayInEvtAck", required = true)
    protected PayInEventAcknowledgementV02 payInEvtAck;
    public final static transient String BUSINESS_PROCESS = "camt";
    public final static transient int FUNCTIONALITY = 63;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 2;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[] {AcknowledgementDetails1Choice.class, MxCamt06300102 .class, PayInEventAcknowledgementV02 .class, SupplementaryData1 .class, SupplementaryDataEnvelope1 .class };
    public final static transient String NAMESPACE = "urn:iso:std:iso:20022:tech:xsd:camt.063.001.02";

    public MxCamt06300102() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     * 
     */
    public MxCamt06300102(final String xml) {
        this();
        MxCamt06300102 tmp = parse(xml);
        payInEvtAck = tmp.getPayInEvtAck();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     * 
     */
    public MxCamt06300102(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Gets the value of the payInEvtAck property.
     * 
     * @return
     *     possible object is
     *     {@link PayInEventAcknowledgementV02 }
     *     
     */
    public PayInEventAcknowledgementV02 getPayInEvtAck() {
        return payInEvtAck;
    }

    /**
     * Sets the value of the payInEvtAck property.
     * 
     * @param value
     *     allowed object is
     *     {@link PayInEventAcknowledgementV02 }
     *     
     */
    public MxCamt06300102 setPayInEvtAck(PayInEventAcknowledgementV02 value) {
        this.payInEvtAck = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     * 
     */
    public static MxCamt06300102 parse(String xml) {
        return ((MxCamt06300102) MxReadImpl.parse(MxCamt06300102 .class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     * @since 9.0.1
     * 
     * @param parserImpl an MX unmarshall implementation
     */
    public static MxCamt06300102 parse(String xml, MxRead parserImpl) {
        return ((MxCamt06300102) parserImpl.read(MxCamt06300102 .class, xml, _classes));
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

    /**
     * Creates an MxCamt06300102 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance 
     * see {@link AbstractMX#fromJson(String)}
     * 
     * @since 7.10.2
     * 
     * @param json a JSON representation of an MxCamt06300102 message
     * @return
     *     a new instance of MxCamt06300102
     */
    public final static MxCamt06300102 fromJson(String json) {
        return AbstractMX.fromJson(json, MxCamt06300102 .class);
    }

}
