package com.prowidesoftware.swift.model.mx.adapter;

import javax.xml.bind.annotation.adapters.XmlAdapter;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;

public class XMLGregorianCalendarAdapter extends XmlAdapter<String, XMLGregorianCalendar> {
    @Override
    public XMLGregorianCalendar unmarshal(String v) throws Exception {
        return DatatypeFactory.newInstance().newXMLGregorianCalendar(v);
    }

    @Override
    public String marshal(XMLGregorianCalendar v) {
        String dateTimeStr = v.toXMLFormat();
        if (dateTimeStr != null && dateTimeStr.length() > 0) {
            dateTimeStr = dateTimeStr.replaceAll("Z$", "+00:00");
        }
        return dateTimeStr;
    }
}
