
package com.prowidesoftware.swift.model.mx.dic;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for ChargeType8Code.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <p>
 * <pre>
 * &lt;simpleType name="ChargeType8Code"&gt;
 *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string"&gt;
 *     &lt;enumeration value="SIGN"/&gt;
 *     &lt;enumeration value="STDE"/&gt;
 *     &lt;enumeration value="STOR"/&gt;
 *     &lt;enumeration value="PACK"/&gt;
 *     &lt;enumeration value="PICK"/&gt;
 *     &lt;enumeration value="DNGR"/&gt;
 *     &lt;enumeration value="SECU"/&gt;
 *     &lt;enumeration value="INSU"/&gt;
 *     &lt;enumeration value="COLF"/&gt;
 *     &lt;enumeration value="CHOR"/&gt;
 *     &lt;enumeration value="CHDE"/&gt;
 *     &lt;enumeration value="AIRF"/&gt;
 *     &lt;enumeration value="TRPT"/&gt;
 *   &lt;/restriction&gt;
 * &lt;/simpleType&gt;
 * </pre>
 * 
 */
@XmlType(name = "ChargeType8Code")
@XmlEnum
public enum ChargeType8Code {


    /**
     * Charge is for signature services.
     * 
     */
    SIGN,

    /**
     * Charge is for storage of goods at destination.
     * 
     */
    STDE,

    /**
     * Charge is for storage of goods at origin.
     * 
     */
    STOR,

    /**
     * Charge is for packaging of goods.
     * 
     */
    PACK,

    /**
     * Charge is for pick-up of goods.
     * 
     */
    PICK,

    /**
     * Charge is for dangerous goods.
     * 
     */
    DNGR,

    /**
     * Charge is for security.
     * 
     */
    SECU,

    /**
     * Charge is a premium for insurance.
     * 
     */
    INSU,

    /**
     * Charge is for the collection of the freight.
     * 
     */
    COLF,

    /**
     * Charge is for clearance and handling of goods at origin.
     * 
     */
    CHOR,

    /**
     * Charge is for clearance and handling of goods at destination.
     * 
     */
    CHDE,

    /**
     * Charge is an airway bill fee.
     * 
     */
    AIRF,

    /**
     * Charge is for transport.
     * 
     */
    TRPT;

    public String value() {
        return name();
    }

    public static ChargeType8Code fromValue(String v) {
        return valueOf(v);
    }

}
