package com.prowidesoftware.swift.model.mx.sys;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.AbstractMX;
import com.prowidesoftware.swift.model.mx.MxRead;
import com.prowidesoftware.swift.model.mx.MxReadImpl;
import com.prowidesoftware.swift.model.mx.sys.dic.*;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;


/**
 * Class for xsys.005.001.01 ISO 20022 message.
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
        "xsys00500101"
})
@XmlRootElement(name = "Document", namespace = "urn:swift:xsd:xsys.005.001.01")
public class MxXsys00500101
        extends AbstractMX {

    public final static transient String BUSINESS_PROCESS = "xsys";
    public final static transient int FUNCTIONALITY = 5;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 1;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[]{MxXsys00500101.class, ReportInfo.class, RequestReference.class, ResultCode.class, com.prowidesoftware.swift.model.mx.sys.dic.SwBooleanIndicator.class, UndeliveredMessage.class, UndeliveredMessageList.class, UndeliveredMessagesReport.class};
    public final static transient String NAMESPACE = "urn:swift:xsd:xsys.005.001.01";
    @XmlElement(name = "xsys.005.001.01", required = true)
    protected UndeliveredMessagesReport xsys00500101;

    public MxXsys00500101() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     */
    public MxXsys00500101(final String xml) {
        this();
        MxXsys00500101 tmp = parse(xml);
        xsys00500101 = tmp.getXsys00500101();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     */
    public MxXsys00500101(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     */
    public static MxXsys00500101 parse(String xml) {
        return ((MxXsys00500101) MxReadImpl.parse(MxXsys00500101.class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     *
     * @param parserImpl an MX unmarshall implementation
     * @since 9.0.1
     */
    public static MxXsys00500101 parse(String xml, MxRead parserImpl) {
        return ((MxXsys00500101) parserImpl.read(MxXsys00500101.class, xml, _classes));
    }

    /**
     * Creates an MxXsys00500101 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance
     * see {@link AbstractMX#fromJson(String)}
     *
     * @param json a JSON representation of an MxXsys00500101 message
     * @return a new instance of MxXsys00500101
     * @since 7.10.2
     */
    public final static MxXsys00500101 fromJson(String json) {
        return AbstractMX.fromJson(json, MxXsys00500101.class);
    }

    /**
     * Gets the value of the xsys00500101 property.
     *
     * @return possible object is
     * {@link UndeliveredMessagesReport }
     */
    public UndeliveredMessagesReport getXsys00500101() {
        return xsys00500101;
    }

    /**
     * Sets the value of the xsys00500101 property.
     *
     * @param value allowed object is
     *              {@link UndeliveredMessagesReport }
     */
    public MxXsys00500101 setXsys00500101(UndeliveredMessagesReport value) {
        this.xsys00500101 = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

}
